/* Emulator.c generated by valac 0.47.3, the Vala compiler
 * generated from Emulator.vala, do not modify */

/*
This file is part of GameHub.
Copyright (C) 2018-2019 Anatoliy Kashkin

GameHub is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GameHub is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GameHub.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <gee.h>

#define GAME_HUB_DATA_TYPE_RUNNABLE (game_hub_data_runnable_get_type ())
#define GAME_HUB_DATA_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable))
#define GAME_HUB_DATA_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))
#define GAME_HUB_DATA_IS_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_IS_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_RUNNABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))

typedef struct _GameHubDataRunnable GameHubDataRunnable;
typedef struct _GameHubDataRunnableClass GameHubDataRunnableClass;
typedef struct _GameHubDataRunnablePrivate GameHubDataRunnablePrivate;
typedef enum  {
	GAME_HUB_DATA_PLATFORM_LINUX,
	GAME_HUB_DATA_PLATFORM_WINDOWS,
	GAME_HUB_DATA_PLATFORM_MACOS,
	GAME_HUB_DATA_PLATFORM_EMULATED
} GameHubDataPlatform;

#define GAME_HUB_DATA_TYPE_PLATFORM (game_hub_data_platform_get_type ())
typedef enum  {
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_INTERACTIVE,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC_DOWNLOAD
} GameHubDataRunnableInstallerInstallMode;

#define GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_INSTALL_MODE (game_hub_data_runnable_installer_install_mode_get_type ())

#define GAME_HUB_DATA_TYPE_EMULATOR (game_hub_data_emulator_get_type ())
#define GAME_HUB_DATA_EMULATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_EMULATOR, GameHubDataEmulator))
#define GAME_HUB_DATA_EMULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_EMULATOR, GameHubDataEmulatorClass))
#define GAME_HUB_DATA_IS_EMULATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_EMULATOR))
#define GAME_HUB_DATA_IS_EMULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_EMULATOR))
#define GAME_HUB_DATA_EMULATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_EMULATOR, GameHubDataEmulatorClass))

typedef struct _GameHubDataEmulator GameHubDataEmulator;
typedef struct _GameHubDataEmulatorClass GameHubDataEmulatorClass;
typedef struct _GameHubDataEmulatorPrivate GameHubDataEmulatorPrivate;

#define GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER (game_hub_data_runnable_installer_get_type ())
#define GAME_HUB_DATA_RUNNABLE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstaller))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstallerClass))
#define GAME_HUB_DATA_RUNNABLE_IS_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_IS_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstallerClass))

typedef struct _GameHubDataRunnableInstaller GameHubDataRunnableInstaller;
typedef struct _GameHubDataRunnableInstallerClass GameHubDataRunnableInstallerClass;

#define GAME_HUB_DATA_EMULATOR_TYPE_INSTALLER (game_hub_data_emulator_installer_get_type ())
#define GAME_HUB_DATA_EMULATOR_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_EMULATOR_TYPE_INSTALLER, GameHubDataEmulatorInstaller))
#define GAME_HUB_DATA_EMULATOR_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_EMULATOR_TYPE_INSTALLER, GameHubDataEmulatorInstallerClass))
#define GAME_HUB_DATA_EMULATOR_IS_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_EMULATOR_TYPE_INSTALLER))
#define GAME_HUB_DATA_EMULATOR_IS_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_EMULATOR_TYPE_INSTALLER))
#define GAME_HUB_DATA_EMULATOR_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_EMULATOR_TYPE_INSTALLER, GameHubDataEmulatorInstallerClass))

typedef struct _GameHubDataEmulatorInstaller GameHubDataEmulatorInstaller;
typedef struct _GameHubDataEmulatorInstallerClass GameHubDataEmulatorInstallerClass;
enum  {
	GAME_HUB_DATA_EMULATOR_0_PROPERTY,
	GAME_HUB_DATA_EMULATOR_EXECUTABLE_PROPERTY,
	GAME_HUB_DATA_EMULATOR_GAME_EXECUTABLE_PATTERN_PROPERTY,
	GAME_HUB_DATA_EMULATOR_GAME_IMAGE_PATTERN_PROPERTY,
	GAME_HUB_DATA_EMULATOR_GAME_ICON_PATTERN_PROPERTY,
	GAME_HUB_DATA_EMULATOR_NUM_PROPERTIES
};
static GParamSpec* game_hub_data_emulator_properties[GAME_HUB_DATA_EMULATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _game_hub_data_runnable_installer_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_runnable_installer_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define GAME_HUB_DATA_DB_TABLE_TYPE_FIELD (game_hub_data_db_table_field_get_type ())
#define GAME_HUB_DATA_DB_TABLE_FIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD, GameHubDataDBTableField))
#define GAME_HUB_DATA_DB_TABLE_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD, GameHubDataDBTableFieldClass))
#define GAME_HUB_DATA_DB_TABLE_IS_FIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD))
#define GAME_HUB_DATA_DB_TABLE_IS_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD))
#define GAME_HUB_DATA_DB_TABLE_FIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD, GameHubDataDBTableFieldClass))

typedef struct _GameHubDataDBTableField GameHubDataDBTableField;
typedef struct _GameHubDataDBTableFieldClass GameHubDataDBTableFieldClass;
typedef struct _Block9Data Block9Data;

#define GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG (game_hub_ui_dialogs_install_dialog_get_type ())
#define GAME_HUB_UI_DIALOGS_INSTALL_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG, GameHubUIDialogsInstallDialog))
#define GAME_HUB_UI_DIALOGS_INSTALL_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG, GameHubUIDialogsInstallDialogClass))
#define GAME_HUB_UI_DIALOGS_IS_INSTALL_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG))
#define GAME_HUB_UI_DIALOGS_IS_INSTALL_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG))
#define GAME_HUB_UI_DIALOGS_INSTALL_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG, GameHubUIDialogsInstallDialogClass))

typedef struct _GameHubUIDialogsInstallDialog GameHubUIDialogsInstallDialog;
typedef struct _GameHubUIDialogsInstallDialogClass GameHubUIDialogsInstallDialogClass;

#define GAME_HUB_DATA_TYPE_COMPAT_TOOL (game_hub_data_compat_tool_get_type ())
#define GAME_HUB_DATA_COMPAT_TOOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatTool))
#define GAME_HUB_DATA_COMPAT_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatToolClass))
#define GAME_HUB_DATA_IS_COMPAT_TOOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL))
#define GAME_HUB_DATA_IS_COMPAT_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_COMPAT_TOOL))
#define GAME_HUB_DATA_COMPAT_TOOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatToolClass))

typedef struct _GameHubDataCompatTool GameHubDataCompatTool;
typedef struct _GameHubDataCompatToolClass GameHubDataCompatToolClass;
typedef struct _Block10Data Block10Data;
typedef struct _GameHubDataEmulatorInstallData GameHubDataEmulatorInstallData;

#define GAME_HUB_DATA_TYPE_GAME (game_hub_data_game_get_type ())
#define GAME_HUB_DATA_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGame))
#define GAME_HUB_DATA_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))
#define GAME_HUB_DATA_IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))

typedef struct _GameHubDataGame GameHubDataGame;
typedef struct _GameHubDataGameClass GameHubDataGameClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GameHubDataEmulatorRunData GameHubDataEmulatorRunData;
typedef struct _Block11Data Block11Data;
typedef struct _GameHubDataEmulatorRunGameData GameHubDataEmulatorRunGameData;

#define GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG (game_hub_ui_dialogs_compat_run_dialog_get_type ())
#define GAME_HUB_UI_DIALOGS_COMPAT_RUN_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG, GameHubUIDialogsCompatRunDialog))
#define GAME_HUB_UI_DIALOGS_COMPAT_RUN_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG, GameHubUIDialogsCompatRunDialogClass))
#define GAME_HUB_UI_DIALOGS_IS_COMPAT_RUN_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG))
#define GAME_HUB_UI_DIALOGS_IS_COMPAT_RUN_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG))
#define GAME_HUB_UI_DIALOGS_COMPAT_RUN_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG, GameHubUIDialogsCompatRunDialogClass))

typedef struct _GameHubUIDialogsCompatRunDialog GameHubUIDialogsCompatRunDialog;
typedef struct _GameHubUIDialogsCompatRunDialogClass GameHubUIDialogsCompatRunDialogClass;
typedef struct _GameHubDataEmulatorRunGameCompatData GameHubDataEmulatorRunGameCompatData;
typedef struct _GameHubDataRunnableInstallerPrivate GameHubDataRunnableInstallerPrivate;
typedef struct _GameHubDataEmulatorInstallerPrivate GameHubDataEmulatorInstallerPrivate;

#define GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART (game_hub_data_runnable_installer_part_get_type ())
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_PART(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, GameHubDataRunnableInstallerPart))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, GameHubDataRunnableInstallerPartClass))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_IS_PART(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_IS_PART_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, GameHubDataRunnableInstallerPartClass))

typedef struct _GameHubDataRunnableInstallerPart GameHubDataRunnableInstallerPart;
typedef struct _GameHubDataRunnableInstallerPartClass GameHubDataRunnableInstallerPartClass;
enum  {
	GAME_HUB_DATA_EMULATOR_REMOVED_SIGNAL,
	GAME_HUB_DATA_EMULATOR_NUM_SIGNALS
};
static guint game_hub_data_emulator_signals[GAME_HUB_DATA_EMULATOR_NUM_SIGNALS] = {0};

struct _GameHubDataRunnable {
	GObject parent_instance;
	GameHubDataRunnablePrivate * priv;
};

struct _GameHubDataRunnableClass {
	GObjectClass parent_class;
	gboolean (*is_supported) (GameHubDataRunnable* self, GameHubDataPlatform* platform, gboolean with_compat);
	void (*install) (GameHubDataRunnable* self, GameHubDataRunnableInstallerInstallMode install_mode, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*install_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	void (*run) (GameHubDataRunnable* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	gboolean (*can_be_launched) (GameHubDataRunnable* self, gboolean is_launch_attempt);
	void (*run_with_compat) (GameHubDataRunnable* self, gboolean is_opened_from_menu, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_with_compat_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	GtkFileChooser* (*setup_executable_chooser) (GameHubDataRunnable* self);
	void (*choose_executable) (GameHubDataRunnable* self, gboolean update);
	void (*set_chosen_executable) (GameHubDataRunnable* self, GFile* file, gboolean update);
	void (*save) (GameHubDataRunnable* self);
	void (*update_status) (GameHubDataRunnable* self);
	void (*import) (GameHubDataRunnable* self, gboolean update);
	GFile* (*get_executable) (GameHubDataRunnable* self);
	void (*set_executable) (GameHubDataRunnable* self, GFile* value);
	GFile* (*get_default_install_dir) (GameHubDataRunnable* self);
};

struct _GameHubDataEmulator {
	GameHubDataRunnable parent_instance;
	GameHubDataEmulatorPrivate * priv;
	GameHubDataEmulatorInstaller* installer;
};

struct _GameHubDataEmulatorClass {
	GameHubDataRunnableClass parent_class;
};

struct _GameHubDataEmulatorPrivate {
	gboolean is_removed;
	GFile* _executable;
	gchar* _game_executable_pattern;
	gchar* _game_image_pattern;
	gchar* _game_icon_pattern;
};

struct _Block9Data {
	int _ref_count_;
	GameHubDataEmulator* self;
	gpointer _async_data_;
};

struct _Block10Data {
	int _ref_count_;
	Block9Data * _data9_;
	GameHubDataRunnableInstaller* installer;
};

struct _GameHubDataEmulatorInstallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataEmulator* self;
	GameHubDataRunnableInstallerInstallMode install_mode;
	Block9Data* _data9_;
	gboolean _tmp0_;
	GameHubDataEmulatorInstaller* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GeeArrayList* installers;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	GameHubDataEmulatorInstaller* _tmp6_;
	GameHubUIDialogsInstallDialog* wnd;
	GeeArrayList* _tmp7_;
	GameHubUIDialogsInstallDialog* _tmp8_;
	GameHubUIDialogsInstallDialog* _tmp9_;
	GameHubUIDialogsInstallDialog* _tmp10_;
	GameHubUIDialogsInstallDialog* _tmp11_;
	GameHubUIDialogsInstallDialog* _tmp12_;
};

struct _GameHubDataEmulatorRunData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataEmulator* self;
	gboolean _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	gint _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
};

struct _Block11Data {
	int _ref_count_;
	GameHubDataEmulator* self;
	GameHubDataGame* game;
	gpointer _async_data_;
};

struct _GameHubDataEmulatorRunGameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataEmulator* self;
	GameHubDataGame* game;
	gboolean launch_in_game_dir;
	Block11Data* _data11_;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gboolean _tmp5_;
	GFile* _tmp6_;
	gboolean _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* dir;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	gint _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	GFile* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
};

struct _GameHubDataEmulatorRunGameCompatData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataEmulator* self;
	GameHubDataGame* game;
	gboolean launch_in_game_dir;
	GameHubUIDialogsCompatRunDialog* _tmp0_;
	GameHubUIDialogsCompatRunDialog* _tmp1_;
};

struct _GameHubDataRunnableInstaller {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataRunnableInstallerPrivate * priv;
};

struct _GameHubDataRunnableInstallerClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataRunnableInstaller *self);
	void (*fetch_parts) (GameHubDataRunnableInstaller* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*fetch_parts_finish) (GameHubDataRunnableInstaller* self, GAsyncResult* _res_);
	gchar* (*get_name) (GameHubDataRunnableInstaller* self);
};

struct _GameHubDataEmulatorInstaller {
	GameHubDataRunnableInstaller parent_instance;
	GameHubDataEmulatorInstallerPrivate * priv;
};

struct _GameHubDataEmulatorInstallerClass {
	GameHubDataRunnableInstallerClass parent_class;
};

struct _GameHubDataEmulatorInstallerPrivate {
	gchar* emu_name;
};

static gint GameHubDataEmulator_private_offset;
static gpointer game_hub_data_emulator_parent_class = NULL;
extern GameHubDataDBTableField* game_hub_data_db_tables_emulators_ID;
extern GameHubDataDBTableField* game_hub_data_db_tables_emulators_NAME;
extern GameHubDataDBTableField* game_hub_data_db_tables_emulators_INSTALL_PATH;
extern GameHubDataDBTableField* game_hub_data_db_tables_emulators_EXECUTABLE;
extern GameHubDataDBTableField* game_hub_data_db_tables_emulators_COMPAT_TOOL;
extern GameHubDataDBTableField* game_hub_data_db_tables_emulators_COMPAT_TOOL_SETTINGS;
extern GameHubDataDBTableField* game_hub_data_db_tables_emulators_ARGUMENTS;
extern GameHubDataDBTableField* game_hub_data_db_tables_emulators_GAME_EXECUTABLE_PATTERN;
extern GameHubDataDBTableField* game_hub_data_db_tables_emulators_GAME_IMAGE_PATTERN;
extern GameHubDataDBTableField* game_hub_data_db_tables_emulators_GAME_ICON_PATTERN;
extern gboolean game_hub_data_runnable_IsLaunched;
static gint GameHubDataEmulatorInstaller_private_offset;
static gpointer game_hub_data_emulator_installer_parent_class = NULL;

GType game_hub_data_runnable_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnable, g_object_unref)
GType game_hub_data_platform_get_type (void) G_GNUC_CONST;
GType game_hub_data_runnable_installer_install_mode_get_type (void) G_GNUC_CONST;
GType game_hub_data_emulator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataEmulator, g_object_unref)
gpointer game_hub_data_runnable_installer_ref (gpointer instance);
void game_hub_data_runnable_installer_unref (gpointer instance);
GParamSpec* game_hub_data_runnable_param_spec_installer (const gchar* name,
                                                         const gchar* nick,
                                                         const gchar* blurb,
                                                         GType object_type,
                                                         GParamFlags flags);
void game_hub_data_runnable_value_set_installer (GValue* value,
                                                 gpointer v_object);
void game_hub_data_runnable_value_take_installer (GValue* value,
                                                  gpointer v_object);
gpointer game_hub_data_runnable_value_get_installer (const GValue* value);
GType game_hub_data_runnable_installer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableInstaller, game_hub_data_runnable_installer_unref)
GType game_hub_data_emulator_installer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataEmulatorInstaller, game_hub_data_runnable_installer_unref)
GameHubDataEmulator* game_hub_data_emulator_new_empty (void);
GameHubDataEmulator* game_hub_data_emulator_construct_empty (GType object_type);
GameHubDataRunnable* game_hub_data_runnable_construct (GType object_type);
GameHubDataEmulator* game_hub_data_emulator_new (const gchar* name,
                                                 GFile* dir,
                                                 GFile* exec,
                                                 const gchar* args,
                                                 const gchar* compat);
GameHubDataEmulator* game_hub_data_emulator_construct (GType object_type,
                                                       const gchar* name,
                                                       GFile* dir,
                                                       GFile* exec,
                                                       const gchar* args,
                                                       const gchar* compat);
void game_hub_data_runnable_set_name (GameHubDataRunnable* self,
                                      const gchar* value);
void game_hub_data_runnable_set_install_dir (GameHubDataRunnable* self,
                                             GFile* value);
void game_hub_data_runnable_set_executable (GameHubDataRunnable* self,
                                            GFile* value);
void game_hub_data_runnable_set_arguments (GameHubDataRunnable* self,
                                           const gchar* value);
void game_hub_data_runnable_set_compat_tool (GameHubDataRunnable* self,
                                             const gchar* value);
void game_hub_data_runnable_set_force_compat (GameHubDataRunnable* self,
                                              gboolean value);
void game_hub_data_runnable_update_status (GameHubDataRunnable* self);
GameHubDataEmulator* game_hub_data_emulator_new_from_db (sqlite3_stmt* s);
GameHubDataEmulator* game_hub_data_emulator_construct_from_db (GType object_type,
                                                               sqlite3_stmt* s);
gpointer game_hub_data_db_table_field_ref (gpointer instance);
void game_hub_data_db_table_field_unref (gpointer instance);
GParamSpec* game_hub_data_db_table_param_spec_field (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
void game_hub_data_db_table_value_set_field (GValue* value,
                                             gpointer v_object);
void game_hub_data_db_table_value_take_field (GValue* value,
                                              gpointer v_object);
gpointer game_hub_data_db_table_value_get_field (const GValue* value);
GType game_hub_data_db_table_field_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataDBTableField, game_hub_data_db_table_field_unref)
gchar* game_hub_data_db_table_field_get (GameHubDataDBTableField* self,
                                         sqlite3_stmt* s);
void game_hub_data_runnable_set_id (GameHubDataRunnable* self,
                                    const gchar* value);
GFile* game_hub_utils_fs_utils_file (const gchar* path,
                                     const gchar* file,
                                     GeeHashMap* variables);
void game_hub_data_runnable_set_compat_tool_settings (GameHubDataRunnable* self,
                                                      const gchar* value);
void game_hub_data_emulator_set_game_executable_pattern (GameHubDataEmulator* self,
                                                         const gchar* value);
void game_hub_data_emulator_set_game_image_pattern (GameHubDataEmulator* self,
                                                    const gchar* value);
void game_hub_data_emulator_set_game_icon_pattern (GameHubDataEmulator* self,
                                                   const gchar* value);
void game_hub_data_emulator_remove (GameHubDataEmulator* self);
gboolean game_hub_data_db_tables_emulators_remove (GameHubDataEmulator* emu);
static void game_hub_data_emulator_real_save (GameHubDataRunnable* base);
const gchar* game_hub_data_runnable_get_name (GameHubDataRunnable* self);
GFile* game_hub_data_runnable_get_executable (GameHubDataRunnable* self);
gboolean game_hub_data_db_tables_emulators_add (GameHubDataEmulator* emu);
static void game_hub_data_emulator_real_update_status (GameHubDataRunnable* base);
gchar* game_hub_utils_md5 (const gchar* s);
GeeArrayList* game_hub_data_runnable_get_platforms (GameHubDataRunnable* self);
static void game_hub_data_emulator_real_install_data_free (gpointer _data);
static void game_hub_data_emulator_real_install (GameHubDataRunnable* base,
                                          GameHubDataRunnableInstallerInstallMode install_mode,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static gboolean game_hub_data_emulator_real_install_co (GameHubDataEmulatorInstallData* _data_);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
GFile* game_hub_data_runnable_get_install_dir (GameHubDataRunnable* self);
GType game_hub_ui_dialogs_install_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUIDialogsInstallDialog, g_object_unref)
GameHubUIDialogsInstallDialog* game_hub_ui_dialogs_install_dialog_new (GameHubDataRunnable* runnable,
                                                                       GeeArrayList* installers,
                                                                       GameHubDataRunnableInstallerInstallMode install_mode);
GameHubUIDialogsInstallDialog* game_hub_ui_dialogs_install_dialog_construct (GType object_type,
                                                                             GameHubDataRunnable* runnable,
                                                                             GeeArrayList* installers,
                                                                             GameHubDataRunnableInstallerInstallMode install_mode);
static void __lambda109_ (Block9Data* _data9_);
void game_hub_data_runnable_install (GameHubDataRunnable* self,
                                     GameHubDataRunnableInstallerInstallMode install_mode,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
void game_hub_data_runnable_install_finish (GameHubDataRunnable* self,
                                            GAsyncResult* _res_);
static gboolean _game_hub_data_emulator_real_install_co_gsource_func (gpointer self);
static void ___lambda109__game_hub_ui_dialogs_install_dialog_cancelled (GameHubUIDialogsInstallDialog* _sender,
                                                                 gpointer self);
GType game_hub_data_compat_tool_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataCompatTool, g_object_unref)
static void __lambda110_ (Block9Data* _data9_,
                   GameHubDataRunnableInstaller* installer,
                   gboolean dl_only,
                   GameHubDataCompatTool* tool);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
void game_hub_data_runnable_installer_install (GameHubDataRunnableInstaller* self,
                                               GameHubDataRunnable* runnable,
                                               gboolean dl_only,
                                               GameHubDataCompatTool* tool,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
void game_hub_data_runnable_installer_install_finish (GameHubDataRunnableInstaller* self,
                                                      GAsyncResult* _res_);
static void __lambda111_ (Block10Data* _data10_,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda111__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void ___lambda110__game_hub_ui_dialogs_install_dialog_install (GameHubUIDialogsInstallDialog* _sender,
                                                               GameHubDataRunnableInstaller* installer,
                                                               gboolean dl_only,
                                                               GameHubDataCompatTool* tool,
                                                               gpointer self);
GType game_hub_data_game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGame, g_object_unref)
gchar** game_hub_data_emulator_get_args (GameHubDataEmulator* self,
                                         GameHubDataGame* game,
                                         GFile* exec,
                                         gint* result_length1);
static void _vala_array_add11 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
const gchar* game_hub_data_runnable_get_arguments (GameHubDataRunnable* self);
gchar** game_hub_utils_parse_args (const gchar* args,
                                   gint* result_length1);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gint stack_length,
                                      const gchar* needle);
static void _vala_array_add12 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
gchar* game_hub_utils_fs_utils_expand (const gchar* path,
                                       const gchar* file,
                                       GeeHashMap* variables);
static void _vala_array_add13 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void game_hub_data_emulator_real_run_data_free (gpointer _data);
static void game_hub_data_emulator_real_run (GameHubDataRunnable* base,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static gboolean game_hub_data_emulator_real_run_co (GameHubDataEmulatorRunData* _data_);
gboolean game_hub_data_runnable_can_be_launched (GameHubDataRunnable* self,
                                                 gboolean is_launch_attempt);
void game_hub_data_runnable_set_is_running (GameHubDataRunnable* self,
                                            gboolean value);
void game_hub_utils_run_thread (gchar** cmd,
                                gint cmd_length1,
                                const gchar* dir,
                                gchar** env,
                                gint env_length1,
                                gboolean override_runtime,
                                gboolean capture_output,
                                gboolean log,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
gchar* game_hub_utils_run_thread_finish (GAsyncResult* _res_);
static void game_hub_data_emulator_run_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
static gboolean ___lambda112_ (GameHubDataEmulator* self);
static gboolean ____lambda112__gsource_func (gpointer self);
static void game_hub_data_emulator_run_game_data_free (gpointer _data);
void game_hub_data_emulator_run_game (GameHubDataEmulator* self,
                                      GameHubDataGame* game,
                                      gboolean launch_in_game_dir,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
void game_hub_data_emulator_run_game_finish (GameHubDataEmulator* self,
                                             GAsyncResult* _res_);
static gboolean game_hub_data_emulator_run_game_co (GameHubDataEmulatorRunGameData* _data_);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
gboolean game_hub_data_runnable_get_use_compat (GameHubDataRunnable* self);
void game_hub_data_emulator_run_game_compat (GameHubDataEmulator* self,
                                             GameHubDataGame* game,
                                             gboolean launch_in_game_dir,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
void game_hub_data_emulator_run_game_compat_finish (GameHubDataEmulator* self,
                                                    GAsyncResult* _res_);
static void game_hub_data_emulator_run_game_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static gboolean ___lambda113_ (Block11Data* _data11_);
static gboolean ____lambda113__gsource_func (gpointer self);
static void game_hub_data_emulator_run_game_compat_data_free (gpointer _data);
static gboolean game_hub_data_emulator_run_game_compat_co (GameHubDataEmulatorRunGameCompatData* _data_);
GameHubUIDialogsCompatRunDialog* game_hub_ui_dialogs_compat_run_dialog_new (GameHubDataRunnable* game,
                                                                            gboolean is_opened_from_menu,
                                                                            GameHubDataGame* emulated_game,
                                                                            gboolean launch_in_game_dir);
GameHubUIDialogsCompatRunDialog* game_hub_ui_dialogs_compat_run_dialog_construct (GType object_type,
                                                                                  GameHubDataRunnable* game,
                                                                                  gboolean is_opened_from_menu,
                                                                                  GameHubDataGame* emulated_game,
                                                                                  gboolean launch_in_game_dir);
GType game_hub_ui_dialogs_compat_run_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUIDialogsCompatRunDialog, g_object_unref)
gboolean game_hub_data_emulator_is_equal (GameHubDataEmulator* first,
                                          GameHubDataEmulator* second);
const gchar* game_hub_data_runnable_get_id (GameHubDataRunnable* self);
guint game_hub_data_emulator_hash (GameHubDataEmulator* emu);
const gchar* game_hub_data_emulator_get_game_executable_pattern (GameHubDataEmulator* self);
const gchar* game_hub_data_emulator_get_game_image_pattern (GameHubDataEmulator* self);
const gchar* game_hub_data_emulator_get_game_icon_pattern (GameHubDataEmulator* self);
GameHubDataEmulatorInstaller* game_hub_data_emulator_installer_new (GameHubDataEmulator* emu,
                                                                    GFile* installer);
GameHubDataEmulatorInstaller* game_hub_data_emulator_installer_construct (GType object_type,
                                                                          GameHubDataEmulator* emu,
                                                                          GFile* installer);
GameHubDataRunnableInstaller* game_hub_data_runnable_installer_construct (GType object_type);
void game_hub_data_runnable_installer_set_id (GameHubDataRunnableInstaller* self,
                                              const gchar* value);
void game_hub_data_runnable_installer_set_platform (GameHubDataRunnableInstaller* self,
                                                    GameHubDataPlatform value);
GType game_hub_data_runnable_installer_part_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableInstallerPart, g_object_unref)
GeeArrayList* game_hub_data_runnable_installer_get_parts (GameHubDataRunnableInstaller* self);
gint64 game_hub_data_runnable_installer_get_full_size (GameHubDataRunnableInstaller* self);
GameHubDataRunnableInstallerPart* game_hub_data_runnable_installer_part_new (const gchar* id,
                                                                             const gchar* url,
                                                                             gint64 size,
                                                                             GFile* remote,
                                                                             GFile* local,
                                                                             const gchar* checksum,
                                                                             GChecksumType checksum_type);
GameHubDataRunnableInstallerPart* game_hub_data_runnable_installer_part_construct (GType object_type,
                                                                                   const gchar* id,
                                                                                   const gchar* url,
                                                                                   gint64 size,
                                                                                   GFile* remote,
                                                                                   GFile* local,
                                                                                   const gchar* checksum,
                                                                                   GChecksumType checksum_type);
static void game_hub_data_emulator_installer_finalize (GameHubDataRunnableInstaller * obj);
static GType game_hub_data_emulator_installer_get_type_once (void);
static void game_hub_data_emulator_finalize (GObject * obj);
static GType game_hub_data_emulator_get_type_once (void);
static void _vala_game_hub_data_emulator_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_game_hub_data_emulator_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
game_hub_data_emulator_get_instance_private (GameHubDataEmulator* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataEmulator_private_offset);
}

GameHubDataEmulator*
game_hub_data_emulator_construct_empty (GType object_type)
{
	GameHubDataEmulator * self = NULL;
#line 37 "../src/data/Emulator.vala"
	self = (GameHubDataEmulator*) game_hub_data_runnable_construct (object_type);
#line 37 "../src/data/Emulator.vala"
	return self;
#line 688 "Emulator.c"
}

GameHubDataEmulator*
game_hub_data_emulator_new_empty (void)
{
#line 37 "../src/data/Emulator.vala"
	return game_hub_data_emulator_construct_empty (GAME_HUB_DATA_TYPE_EMULATOR);
#line 696 "Emulator.c"
}

GameHubDataEmulator*
game_hub_data_emulator_construct (GType object_type,
                                  const gchar* name,
                                  GFile* dir,
                                  GFile* exec,
                                  const gchar* args,
                                  const gchar* compat)
{
	GameHubDataEmulator * self = NULL;
#line 39 "../src/data/Emulator.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 39 "../src/data/Emulator.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 39 "../src/data/Emulator.vala"
	g_return_val_if_fail (exec != NULL, NULL);
#line 39 "../src/data/Emulator.vala"
	g_return_val_if_fail (args != NULL, NULL);
#line 39 "../src/data/Emulator.vala"
	self = (GameHubDataEmulator*) game_hub_data_runnable_construct (object_type);
#line 41 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_name ((GameHubDataRunnable*) self, name);
#line 43 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_install_dir ((GameHubDataRunnable*) self, dir);
#line 45 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_executable ((GameHubDataRunnable*) self, exec);
#line 46 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_arguments ((GameHubDataRunnable*) self, args);
#line 48 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_compat_tool ((GameHubDataRunnable*) self, compat);
#line 49 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_force_compat ((GameHubDataRunnable*) self, compat != NULL);
#line 51 "../src/data/Emulator.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) self);
#line 39 "../src/data/Emulator.vala"
	return self;
#line 734 "Emulator.c"
}

GameHubDataEmulator*
game_hub_data_emulator_new (const gchar* name,
                            GFile* dir,
                            GFile* exec,
                            const gchar* args,
                            const gchar* compat)
{
#line 39 "../src/data/Emulator.vala"
	return game_hub_data_emulator_construct (GAME_HUB_DATA_TYPE_EMULATOR, name, dir, exec, args, compat);
#line 746 "Emulator.c"
}

GameHubDataEmulator*
game_hub_data_emulator_construct_from_db (GType object_type,
                                          sqlite3_stmt* s)
{
	GameHubDataEmulator * self = NULL;
	GameHubDataDBTableField* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GameHubDataDBTableField* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GameHubDataDBTableField* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GameHubDataDBTableField* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	GameHubDataDBTableField* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GameHubDataDBTableField* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GameHubDataDBTableField* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GameHubDataDBTableField* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GameHubDataDBTableField* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GameHubDataDBTableField* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
#line 54 "../src/data/Emulator.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 54 "../src/data/Emulator.vala"
	self = (GameHubDataEmulator*) game_hub_data_runnable_construct (object_type);
#line 56 "../src/data/Emulator.vala"
	_tmp0_ = game_hub_data_db_tables_emulators_ID;
#line 56 "../src/data/Emulator.vala"
	_tmp1_ = game_hub_data_db_table_field_get (_tmp0_, s);
#line 56 "../src/data/Emulator.vala"
	_tmp2_ = _tmp1_;
#line 56 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_id ((GameHubDataRunnable*) self, _tmp2_);
#line 56 "../src/data/Emulator.vala"
	_g_free0 (_tmp2_);
#line 57 "../src/data/Emulator.vala"
	_tmp3_ = game_hub_data_db_tables_emulators_NAME;
#line 57 "../src/data/Emulator.vala"
	_tmp4_ = game_hub_data_db_table_field_get (_tmp3_, s);
#line 57 "../src/data/Emulator.vala"
	_tmp5_ = _tmp4_;
#line 57 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_name ((GameHubDataRunnable*) self, _tmp5_);
#line 57 "../src/data/Emulator.vala"
	_g_free0 (_tmp5_);
#line 58 "../src/data/Emulator.vala"
	_tmp6_ = game_hub_data_db_tables_emulators_INSTALL_PATH;
#line 58 "../src/data/Emulator.vala"
	_tmp7_ = game_hub_data_db_table_field_get (_tmp6_, s);
#line 58 "../src/data/Emulator.vala"
	_tmp8_ = _tmp7_;
#line 58 "../src/data/Emulator.vala"
	_tmp9_ = game_hub_utils_fs_utils_file (_tmp8_, NULL, NULL);
#line 58 "../src/data/Emulator.vala"
	_tmp10_ = _tmp9_;
#line 58 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_install_dir ((GameHubDataRunnable*) self, _tmp10_);
#line 58 "../src/data/Emulator.vala"
	_g_object_unref0 (_tmp10_);
#line 58 "../src/data/Emulator.vala"
	_g_free0 (_tmp8_);
#line 59 "../src/data/Emulator.vala"
	_tmp11_ = game_hub_data_db_tables_emulators_EXECUTABLE;
#line 59 "../src/data/Emulator.vala"
	_tmp12_ = game_hub_data_db_table_field_get (_tmp11_, s);
#line 59 "../src/data/Emulator.vala"
	_tmp13_ = _tmp12_;
#line 59 "../src/data/Emulator.vala"
	_tmp14_ = game_hub_utils_fs_utils_file (_tmp13_, NULL, NULL);
#line 59 "../src/data/Emulator.vala"
	_tmp15_ = _tmp14_;
#line 59 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_executable ((GameHubDataRunnable*) self, _tmp15_);
#line 59 "../src/data/Emulator.vala"
	_g_object_unref0 (_tmp15_);
#line 59 "../src/data/Emulator.vala"
	_g_free0 (_tmp13_);
#line 60 "../src/data/Emulator.vala"
	_tmp16_ = game_hub_data_db_tables_emulators_COMPAT_TOOL;
#line 60 "../src/data/Emulator.vala"
	_tmp17_ = game_hub_data_db_table_field_get (_tmp16_, s);
#line 60 "../src/data/Emulator.vala"
	_tmp18_ = _tmp17_;
#line 60 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_compat_tool ((GameHubDataRunnable*) self, _tmp18_);
#line 60 "../src/data/Emulator.vala"
	_g_free0 (_tmp18_);
#line 61 "../src/data/Emulator.vala"
	_tmp19_ = game_hub_data_db_tables_emulators_COMPAT_TOOL_SETTINGS;
#line 61 "../src/data/Emulator.vala"
	_tmp20_ = game_hub_data_db_table_field_get (_tmp19_, s);
#line 61 "../src/data/Emulator.vala"
	_tmp21_ = _tmp20_;
#line 61 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_compat_tool_settings ((GameHubDataRunnable*) self, _tmp21_);
#line 61 "../src/data/Emulator.vala"
	_g_free0 (_tmp21_);
#line 62 "../src/data/Emulator.vala"
	_tmp22_ = game_hub_data_db_tables_emulators_ARGUMENTS;
#line 62 "../src/data/Emulator.vala"
	_tmp23_ = game_hub_data_db_table_field_get (_tmp22_, s);
#line 62 "../src/data/Emulator.vala"
	_tmp24_ = _tmp23_;
#line 62 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_arguments ((GameHubDataRunnable*) self, _tmp24_);
#line 62 "../src/data/Emulator.vala"
	_g_free0 (_tmp24_);
#line 63 "../src/data/Emulator.vala"
	_tmp25_ = game_hub_data_db_tables_emulators_GAME_EXECUTABLE_PATTERN;
#line 63 "../src/data/Emulator.vala"
	_tmp26_ = game_hub_data_db_table_field_get (_tmp25_, s);
#line 63 "../src/data/Emulator.vala"
	_tmp27_ = _tmp26_;
#line 63 "../src/data/Emulator.vala"
	game_hub_data_emulator_set_game_executable_pattern (self, _tmp27_);
#line 63 "../src/data/Emulator.vala"
	_g_free0 (_tmp27_);
#line 64 "../src/data/Emulator.vala"
	_tmp28_ = game_hub_data_db_tables_emulators_GAME_IMAGE_PATTERN;
#line 64 "../src/data/Emulator.vala"
	_tmp29_ = game_hub_data_db_table_field_get (_tmp28_, s);
#line 64 "../src/data/Emulator.vala"
	_tmp30_ = _tmp29_;
#line 64 "../src/data/Emulator.vala"
	game_hub_data_emulator_set_game_image_pattern (self, _tmp30_);
#line 64 "../src/data/Emulator.vala"
	_g_free0 (_tmp30_);
#line 65 "../src/data/Emulator.vala"
	_tmp31_ = game_hub_data_db_tables_emulators_GAME_ICON_PATTERN;
#line 65 "../src/data/Emulator.vala"
	_tmp32_ = game_hub_data_db_table_field_get (_tmp31_, s);
#line 65 "../src/data/Emulator.vala"
	_tmp33_ = _tmp32_;
#line 65 "../src/data/Emulator.vala"
	game_hub_data_emulator_set_game_icon_pattern (self, _tmp33_);
#line 65 "../src/data/Emulator.vala"
	_g_free0 (_tmp33_);
#line 67 "../src/data/Emulator.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) self);
#line 54 "../src/data/Emulator.vala"
	return self;
#line 908 "Emulator.c"
}

GameHubDataEmulator*
game_hub_data_emulator_new_from_db (sqlite3_stmt* s)
{
#line 54 "../src/data/Emulator.vala"
	return game_hub_data_emulator_construct_from_db (GAME_HUB_DATA_TYPE_EMULATOR, s);
#line 916 "Emulator.c"
}

void
game_hub_data_emulator_remove (GameHubDataEmulator* self)
{
#line 70 "../src/data/Emulator.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/data/Emulator.vala"
	self->priv->is_removed = TRUE;
#line 73 "../src/data/Emulator.vala"
	game_hub_data_db_tables_emulators_remove (self);
#line 74 "../src/data/Emulator.vala"
	g_signal_emit (self, game_hub_data_emulator_signals[GAME_HUB_DATA_EMULATOR_REMOVED_SIGNAL], 0);
#line 930 "Emulator.c"
}

static void
game_hub_data_emulator_real_save (GameHubDataRunnable* base)
{
	GameHubDataEmulator * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 77 "../src/data/Emulator.vala"
	self = (GameHubDataEmulator*) base;
#line 79 "../src/data/Emulator.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) self);
#line 81 "../src/data/Emulator.vala"
	if (self->priv->is_removed) {
#line 81 "../src/data/Emulator.vala"
		_tmp1_ = TRUE;
#line 947 "Emulator.c"
	} else {
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 81 "../src/data/Emulator.vala"
		_tmp2_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) self);
#line 81 "../src/data/Emulator.vala"
		_tmp3_ = _tmp2_;
#line 81 "../src/data/Emulator.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 957 "Emulator.c"
	}
#line 81 "../src/data/Emulator.vala"
	if (_tmp1_) {
#line 81 "../src/data/Emulator.vala"
		_tmp0_ = TRUE;
#line 963 "Emulator.c"
	} else {
		GFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 81 "../src/data/Emulator.vala"
		_tmp4_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) self);
#line 81 "../src/data/Emulator.vala"
		_tmp5_ = _tmp4_;
#line 81 "../src/data/Emulator.vala"
		_tmp6_ = _tmp5_;
#line 81 "../src/data/Emulator.vala"
		_tmp0_ = _tmp6_ == NULL;
#line 81 "../src/data/Emulator.vala"
		_g_object_unref0 (_tmp6_);
#line 978 "Emulator.c"
	}
#line 81 "../src/data/Emulator.vala"
	if (_tmp0_) {
#line 81 "../src/data/Emulator.vala"
		return;
#line 984 "Emulator.c"
	}
#line 83 "../src/data/Emulator.vala"
	game_hub_data_db_tables_emulators_add (self);
#line 988 "Emulator.c"
}

static void
game_hub_data_emulator_real_update_status (GameHubDataRunnable* base)
{
	GameHubDataEmulator * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GeeArrayList* _tmp11_;
	GeeArrayList* _tmp12_;
	GeeArrayList* _tmp13_;
	GeeArrayList* _tmp14_;
#line 86 "../src/data/Emulator.vala"
	self = (GameHubDataEmulator*) base;
#line 88 "../src/data/Emulator.vala"
	if (self->priv->is_removed) {
#line 88 "../src/data/Emulator.vala"
		_tmp1_ = TRUE;
#line 1011 "Emulator.c"
	} else {
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 88 "../src/data/Emulator.vala"
		_tmp2_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) self);
#line 88 "../src/data/Emulator.vala"
		_tmp3_ = _tmp2_;
#line 88 "../src/data/Emulator.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 1021 "Emulator.c"
	}
#line 88 "../src/data/Emulator.vala"
	if (_tmp1_) {
#line 88 "../src/data/Emulator.vala"
		_tmp0_ = TRUE;
#line 1027 "Emulator.c"
	} else {
		GFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 88 "../src/data/Emulator.vala"
		_tmp4_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) self);
#line 88 "../src/data/Emulator.vala"
		_tmp5_ = _tmp4_;
#line 88 "../src/data/Emulator.vala"
		_tmp6_ = _tmp5_;
#line 88 "../src/data/Emulator.vala"
		_tmp0_ = _tmp6_ == NULL;
#line 88 "../src/data/Emulator.vala"
		_g_object_unref0 (_tmp6_);
#line 1042 "Emulator.c"
	}
#line 88 "../src/data/Emulator.vala"
	if (_tmp0_) {
#line 88 "../src/data/Emulator.vala"
		return;
#line 1048 "Emulator.c"
	}
#line 90 "../src/data/Emulator.vala"
	_tmp7_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) self);
#line 90 "../src/data/Emulator.vala"
	_tmp8_ = _tmp7_;
#line 90 "../src/data/Emulator.vala"
	_tmp9_ = game_hub_utils_md5 (_tmp8_);
#line 90 "../src/data/Emulator.vala"
	_tmp10_ = _tmp9_;
#line 90 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_id ((GameHubDataRunnable*) self, _tmp10_);
#line 90 "../src/data/Emulator.vala"
	_g_free0 (_tmp10_);
#line 92 "../src/data/Emulator.vala"
	_tmp11_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 92 "../src/data/Emulator.vala"
	_tmp12_ = _tmp11_;
#line 92 "../src/data/Emulator.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp12_);
#line 93 "../src/data/Emulator.vala"
	_tmp13_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 93 "../src/data/Emulator.vala"
	_tmp14_ = _tmp13_;
#line 93 "../src/data/Emulator.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, (gpointer) ((gintptr) GAME_HUB_DATA_PLATFORM_LINUX));
#line 1074 "Emulator.c"
}

static void
game_hub_data_emulator_real_install_data_free (gpointer _data)
{
	GameHubDataEmulatorInstallData* _data_;
	_data_ = _data;
#line 25 "../src/data/Emulator.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/Emulator.vala"
	g_slice_free (GameHubDataEmulatorInstallData, _data_);
#line 1086 "Emulator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 25 "../src/data/Emulator.vala"
	return self ? g_object_ref (self) : NULL;
#line 1094 "Emulator.c"
}

static void
game_hub_data_emulator_real_install (GameHubDataRunnable* base,
                                     GameHubDataRunnableInstallerInstallMode install_mode,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	GameHubDataEmulator * self;
	GameHubDataEmulatorInstallData* _data_;
	GameHubDataEmulator* _tmp0_;
#line 25 "../src/data/Emulator.vala"
	self = (GameHubDataEmulator*) base;
#line 25 "../src/data/Emulator.vala"
	_data_ = g_slice_new0 (GameHubDataEmulatorInstallData);
#line 25 "../src/data/Emulator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/Emulator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_emulator_real_install_data_free);
#line 25 "../src/data/Emulator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/Emulator.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/Emulator.vala"
	_data_->install_mode = install_mode;
#line 25 "../src/data/Emulator.vala"
	game_hub_data_emulator_real_install_co (_data_);
#line 1122 "Emulator.c"
}

static void
game_hub_data_emulator_install_finish (GameHubDataRunnable* base,
                                       GAsyncResult* _res_)
{
	GameHubDataEmulatorInstallData* _data_;
#line 25 "../src/data/Emulator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1132 "Emulator.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 96 "../src/data/Emulator.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 96 "../src/data/Emulator.vala"
	return _data9_;
#line 1142 "Emulator.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 96 "../src/data/Emulator.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 1152 "Emulator.c"
		GameHubDataEmulator* self;
#line 96 "../src/data/Emulator.vala"
		self = _data9_->self;
#line 96 "../src/data/Emulator.vala"
		_g_object_unref0 (self);
#line 96 "../src/data/Emulator.vala"
		g_slice_free (Block9Data, _data9_);
#line 1160 "Emulator.c"
	}
}

static gboolean
_game_hub_data_emulator_real_install_co_gsource_func (gpointer self)
{
	gboolean result;
	result = game_hub_data_emulator_real_install_co (self);
#line 107 "../src/data/Emulator.vala"
	return result;
#line 1171 "Emulator.c"
}

static void
__lambda109_ (Block9Data* _data9_)
{
	GameHubDataEmulator* self;
#line 107 "../src/data/Emulator.vala"
	self = _data9_->self;
#line 107 "../src/data/Emulator.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _game_hub_data_emulator_real_install_co_gsource_func, _data9_->_async_data_, NULL);
#line 1182 "Emulator.c"
}

static void
___lambda109__game_hub_ui_dialogs_install_dialog_cancelled (GameHubUIDialogsInstallDialog* _sender,
                                                            gpointer self)
{
#line 107 "../src/data/Emulator.vala"
	__lambda109_ (self);
#line 1191 "Emulator.c"
}

static gpointer
_game_hub_data_runnable_installer_ref0 (gpointer self)
{
#line 109 "../src/data/Emulator.vala"
	return self ? game_hub_data_runnable_installer_ref (self) : NULL;
#line 1199 "Emulator.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 109 "../src/data/Emulator.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 109 "../src/data/Emulator.vala"
	return _data10_;
#line 1209 "Emulator.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 109 "../src/data/Emulator.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 1219 "Emulator.c"
		GameHubDataEmulator* self;
#line 109 "../src/data/Emulator.vala"
		self = _data10_->_data9_->self;
#line 109 "../src/data/Emulator.vala"
		_game_hub_data_runnable_installer_unref0 (_data10_->installer);
#line 109 "../src/data/Emulator.vala"
		block9_data_unref (_data10_->_data9_);
#line 109 "../src/data/Emulator.vala"
		_data10_->_data9_ = NULL;
#line 109 "../src/data/Emulator.vala"
		g_slice_free (Block10Data, _data10_);
#line 1231 "Emulator.c"
	}
}

static void
__lambda111_ (Block10Data* _data10_,
              GObject* obj,
              GAsyncResult* res)
{
	Block9Data* _data9_;
	GameHubDataEmulator* self;
#line 110 "../src/data/Emulator.vala"
	_data9_ = _data10_->_data9_;
#line 110 "../src/data/Emulator.vala"
	self = _data9_->self;
#line 110 "../src/data/Emulator.vala"
	g_return_if_fail (res != NULL);
#line 111 "../src/data/Emulator.vala"
	game_hub_data_runnable_installer_install_finish (_data10_->installer, res);
#line 112 "../src/data/Emulator.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _game_hub_data_emulator_real_install_co_gsource_func, _data9_->_async_data_, NULL);
#line 1252 "Emulator.c"
}

static void
___lambda111__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 110 "../src/data/Emulator.vala"
	__lambda111_ (self, source_object, res);
#line 110 "../src/data/Emulator.vala"
	block10_data_unref (self);
#line 1264 "Emulator.c"
}

static void
__lambda110_ (Block9Data* _data9_,
              GameHubDataRunnableInstaller* installer,
              gboolean dl_only,
              GameHubDataCompatTool* tool)
{
	GameHubDataEmulator* self;
	Block10Data* _data10_;
	GameHubDataRunnableInstaller* _tmp0_;
#line 109 "../src/data/Emulator.vala"
	self = _data9_->self;
#line 109 "../src/data/Emulator.vala"
	g_return_if_fail (installer != NULL);
#line 109 "../src/data/Emulator.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 109 "../src/data/Emulator.vala"
	_data10_->_ref_count_ = 1;
#line 109 "../src/data/Emulator.vala"
	_data10_->_data9_ = block9_data_ref (_data9_);
#line 109 "../src/data/Emulator.vala"
	_tmp0_ = _game_hub_data_runnable_installer_ref0 (installer);
#line 109 "../src/data/Emulator.vala"
	_game_hub_data_runnable_installer_unref0 (_data10_->installer);
#line 109 "../src/data/Emulator.vala"
	_data10_->installer = _tmp0_;
#line 110 "../src/data/Emulator.vala"
	game_hub_data_runnable_installer_install (_data10_->installer, (GameHubDataRunnable*) self, dl_only, tool, ___lambda111__gasync_ready_callback, block10_data_ref (_data10_));
#line 109 "../src/data/Emulator.vala"
	block10_data_unref (_data10_);
#line 109 "../src/data/Emulator.vala"
	_data10_ = NULL;
#line 1298 "Emulator.c"
}

static void
___lambda110__game_hub_ui_dialogs_install_dialog_install (GameHubUIDialogsInstallDialog* _sender,
                                                          GameHubDataRunnableInstaller* installer,
                                                          gboolean dl_only,
                                                          GameHubDataCompatTool* tool,
                                                          gpointer self)
{
#line 109 "../src/data/Emulator.vala"
	__lambda110_ (self, installer, dl_only, tool);
#line 1310 "Emulator.c"
}

static gboolean
game_hub_data_emulator_real_install_co (GameHubDataEmulatorInstallData* _data_)
{
#line 96 "../src/data/Emulator.vala"
	switch (_data_->_state_) {
#line 96 "../src/data/Emulator.vala"
		case 0:
#line 1320 "Emulator.c"
		goto _state_0;
#line 96 "../src/data/Emulator.vala"
		case 1:
#line 1324 "Emulator.c"
		goto _state_1;
		default:
#line 96 "../src/data/Emulator.vala"
		g_assert_not_reached ();
#line 1329 "Emulator.c"
	}
	_state_0:
#line 96 "../src/data/Emulator.vala"
	_data_->_data9_ = g_slice_new0 (Block9Data);
#line 96 "../src/data/Emulator.vala"
	_data_->_data9_->_ref_count_ = 1;
#line 96 "../src/data/Emulator.vala"
	_data_->_data9_->self = g_object_ref (_data_->self);
#line 96 "../src/data/Emulator.vala"
	_data_->_data9_->_async_data_ = _data_;
#line 98 "../src/data/Emulator.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) _data_->self);
#line 100 "../src/data/Emulator.vala"
	_data_->_tmp1_ = _data_->self->installer;
#line 100 "../src/data/Emulator.vala"
	if (_data_->_tmp1_ == NULL) {
#line 100 "../src/data/Emulator.vala"
		_data_->_tmp0_ = TRUE;
#line 1348 "Emulator.c"
	} else {
#line 100 "../src/data/Emulator.vala"
		_data_->_tmp2_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->self);
#line 100 "../src/data/Emulator.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 100 "../src/data/Emulator.vala"
		_data_->_tmp0_ = _data_->_tmp3_ == NULL;
#line 1356 "Emulator.c"
	}
#line 100 "../src/data/Emulator.vala"
	if (_data_->_tmp0_) {
#line 100 "../src/data/Emulator.vala"
		block9_data_unref (_data_->_data9_);
#line 100 "../src/data/Emulator.vala"
		_data_->_data9_ = NULL;
#line 100 "../src/data/Emulator.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 100 "../src/data/Emulator.vala"
		if (_data_->_state_ != 0) {
#line 100 "../src/data/Emulator.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 100 "../src/data/Emulator.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1372 "Emulator.c"
			}
		}
#line 100 "../src/data/Emulator.vala"
		g_object_unref (_data_->_async_result);
#line 100 "../src/data/Emulator.vala"
		return FALSE;
#line 1379 "Emulator.c"
	}
#line 102 "../src/data/Emulator.vala"
	_data_->_tmp4_ = gee_array_list_new (GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, (GBoxedCopyFunc) game_hub_data_runnable_installer_ref, (GDestroyNotify) game_hub_data_runnable_installer_unref, NULL, NULL, NULL);
#line 102 "../src/data/Emulator.vala"
	_data_->installers = _data_->_tmp4_;
#line 103 "../src/data/Emulator.vala"
	_data_->_tmp5_ = _data_->installers;
#line 103 "../src/data/Emulator.vala"
	_data_->_tmp6_ = _data_->self->installer;
#line 103 "../src/data/Emulator.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp5_, (GameHubDataRunnableInstaller*) _data_->_tmp6_);
#line 105 "../src/data/Emulator.vala"
	_data_->_tmp7_ = _data_->installers;
#line 105 "../src/data/Emulator.vala"
	_data_->_tmp8_ = game_hub_ui_dialogs_install_dialog_new ((GameHubDataRunnable*) _data_->self, _data_->_tmp7_, _data_->install_mode);
#line 105 "../src/data/Emulator.vala"
	g_object_ref_sink (_data_->_tmp8_);
#line 105 "../src/data/Emulator.vala"
	_data_->wnd = _data_->_tmp8_;
#line 107 "../src/data/Emulator.vala"
	_data_->_tmp9_ = _data_->wnd;
#line 107 "../src/data/Emulator.vala"
	g_signal_connect_data (_data_->_tmp9_, "cancelled", (GCallback) ___lambda109__game_hub_ui_dialogs_install_dialog_cancelled, block9_data_ref (_data_->_data9_), (GClosureNotify) block9_data_unref, 0);
#line 109 "../src/data/Emulator.vala"
	_data_->_tmp10_ = _data_->wnd;
#line 109 "../src/data/Emulator.vala"
	g_signal_connect_data (_data_->_tmp10_, "install", (GCallback) ___lambda110__game_hub_ui_dialogs_install_dialog_install, block9_data_ref (_data_->_data9_), (GClosureNotify) block9_data_unref, 0);
#line 116 "../src/data/Emulator.vala"
	_data_->_tmp11_ = _data_->wnd;
#line 116 "../src/data/Emulator.vala"
	gtk_widget_show_all ((GtkWidget*) _data_->_tmp11_);
#line 117 "../src/data/Emulator.vala"
	_data_->_tmp12_ = _data_->wnd;
#line 117 "../src/data/Emulator.vala"
	gtk_window_present ((GtkWindow*) _data_->_tmp12_);
#line 119 "../src/data/Emulator.vala"
	_data_->_state_ = 1;
#line 119 "../src/data/Emulator.vala"
	return FALSE;
#line 1419 "Emulator.c"
	_state_1:
	;
#line 96 "../src/data/Emulator.vala"
	_g_object_unref0 (_data_->wnd);
#line 96 "../src/data/Emulator.vala"
	_g_object_unref0 (_data_->installers);
#line 96 "../src/data/Emulator.vala"
	block9_data_unref (_data_->_data9_);
#line 96 "../src/data/Emulator.vala"
	_data_->_data9_ = NULL;
#line 96 "../src/data/Emulator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 96 "../src/data/Emulator.vala"
	if (_data_->_state_ != 0) {
#line 96 "../src/data/Emulator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 96 "../src/data/Emulator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1438 "Emulator.c"
		}
	}
#line 96 "../src/data/Emulator.vala"
	g_object_unref (_data_->_async_result);
#line 96 "../src/data/Emulator.vala"
	return FALSE;
#line 1445 "Emulator.c"
}

static void
_vala_array_add11 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 128 "../src/data/Emulator.vala"
	if ((*length) == (*size)) {
#line 128 "../src/data/Emulator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 128 "../src/data/Emulator.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1460 "Emulator.c"
	}
#line 128 "../src/data/Emulator.vala"
	(*array)[(*length)++] = value;
#line 128 "../src/data/Emulator.vala"
	(*array)[*length] = NULL;
#line 1466 "Emulator.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1488 "Emulator.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1492 "Emulator.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1498 "Emulator.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1502 "Emulator.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1506 "Emulator.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 1514 "Emulator.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1542 "Emulator.c"
				goto __catch15_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 1551 "Emulator.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1565 "Emulator.c"
				goto __catch15_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 1574 "Emulator.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 1588 "Emulator.c"
	}
	goto __finally15;
	__catch15_g_regex_error:
	{
		GError* e = NULL;
#line 1538 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1538 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1538 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 1602 "Emulator.c"
	}
	__finally15:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 1611 "Emulator.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gint stack_length,
                             const gchar* needle)
{
	gint i;
#line 151 "../src/data/Emulator.vala"
	for (i = 0; i < stack_length; i++) {
#line 151 "../src/data/Emulator.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 151 "../src/data/Emulator.vala"
			return TRUE;
#line 1626 "Emulator.c"
		}
	}
#line 151 "../src/data/Emulator.vala"
	return FALSE;
#line 1631 "Emulator.c"
}

static void
_vala_array_add12 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 167 "../src/data/Emulator.vala"
	if ((*length) == (*size)) {
#line 167 "../src/data/Emulator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 167 "../src/data/Emulator.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1646 "Emulator.c"
	}
#line 167 "../src/data/Emulator.vala"
	(*array)[(*length)++] = value;
#line 167 "../src/data/Emulator.vala"
	(*array)[*length] = NULL;
#line 1652 "Emulator.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 1671 "Emulator.c"
}

static void
_vala_array_add13 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 177 "../src/data/Emulator.vala"
	if ((*length) == (*size)) {
#line 177 "../src/data/Emulator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 177 "../src/data/Emulator.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1686 "Emulator.c"
	}
#line 177 "../src/data/Emulator.vala"
	(*array)[(*length)++] = value;
#line 177 "../src/data/Emulator.vala"
	(*array)[*length] = NULL;
#line 1692 "Emulator.c"
}

gchar**
game_hub_data_emulator_get_args (GameHubDataEmulator* self,
                                 GameHubDataGame* game,
                                 GFile* exec,
                                 gint* result_length1)
{
	gchar** result_args = NULL;
	gchar** _tmp0_;
	gint result_args_length1;
	gint _result_args_size_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar** _tmp79_;
	gint _tmp79__length1;
	gchar** result = NULL;
#line 122 "../src/data/Emulator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 124 "../src/data/Emulator.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 124 "../src/data/Emulator.vala"
	result_args = _tmp0_;
#line 124 "../src/data/Emulator.vala"
	result_args_length1 = 0;
#line 124 "../src/data/Emulator.vala"
	_result_args_size_ = result_args_length1;
#line 126 "../src/data/Emulator.vala"
	if (exec != NULL) {
#line 1723 "Emulator.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
		gchar* _tmp2_;
#line 128 "../src/data/Emulator.vala"
		_tmp1_ = result_args;
#line 128 "../src/data/Emulator.vala"
		_tmp1__length1 = result_args_length1;
#line 128 "../src/data/Emulator.vala"
		_tmp2_ = g_file_get_path (exec);
#line 128 "../src/data/Emulator.vala"
		_vala_array_add11 (&result_args, &result_args_length1, &_result_args_size_, _tmp2_);
#line 1735 "Emulator.c"
	}
#line 131 "../src/data/Emulator.vala"
	_tmp4_ = game_hub_data_runnable_get_arguments ((GameHubDataRunnable*) self);
#line 131 "../src/data/Emulator.vala"
	_tmp5_ = _tmp4_;
#line 131 "../src/data/Emulator.vala"
	if (_tmp5_ != NULL) {
#line 1743 "Emulator.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 131 "../src/data/Emulator.vala"
		_tmp6_ = game_hub_data_runnable_get_arguments ((GameHubDataRunnable*) self);
#line 131 "../src/data/Emulator.vala"
		_tmp7_ = _tmp6_;
#line 131 "../src/data/Emulator.vala"
		_tmp8_ = strlen (_tmp7_);
#line 131 "../src/data/Emulator.vala"
		_tmp9_ = _tmp8_;
#line 131 "../src/data/Emulator.vala"
		_tmp3_ = _tmp9_ > 0;
#line 1758 "Emulator.c"
	} else {
#line 131 "../src/data/Emulator.vala"
		_tmp3_ = FALSE;
#line 1762 "Emulator.c"
	}
#line 131 "../src/data/Emulator.vala"
	if (_tmp3_) {
#line 1766 "Emulator.c"
		GeeHashMap* variables = NULL;
		GeeHashMap* _tmp10_;
		GeeHashMap* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GeeHashMap* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar** args = NULL;
		const gchar* _tmp44_;
		const gchar* _tmp45_;
		gint _tmp46_ = 0;
		gchar** _tmp47_;
		gint args_length1;
		gint _args_size_;
		gchar** _tmp48_;
		gint _tmp48__length1;
#line 133 "../src/data/Emulator.vala"
		_tmp10_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 133 "../src/data/Emulator.vala"
		variables = _tmp10_;
#line 134 "../src/data/Emulator.vala"
		_tmp11_ = variables;
#line 134 "../src/data/Emulator.vala"
		_tmp12_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) self);
#line 134 "../src/data/Emulator.vala"
		_tmp13_ = _tmp12_;
#line 134 "../src/data/Emulator.vala"
		_tmp14_ = string_replace (_tmp13_, ": ", " - ");
#line 134 "../src/data/Emulator.vala"
		_tmp15_ = _tmp14_;
#line 134 "../src/data/Emulator.vala"
		_tmp16_ = string_replace (_tmp15_, ":", "");
#line 134 "../src/data/Emulator.vala"
		_tmp17_ = _tmp16_;
#line 134 "../src/data/Emulator.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp11_, "emu", _tmp17_);
#line 134 "../src/data/Emulator.vala"
		_g_free0 (_tmp17_);
#line 134 "../src/data/Emulator.vala"
		_g_free0 (_tmp15_);
#line 135 "../src/data/Emulator.vala"
		_tmp18_ = variables;
#line 135 "../src/data/Emulator.vala"
		_tmp19_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 135 "../src/data/Emulator.vala"
		_tmp20_ = _tmp19_;
#line 135 "../src/data/Emulator.vala"
		_tmp21_ = g_file_get_path (_tmp20_);
#line 135 "../src/data/Emulator.vala"
		_tmp22_ = _tmp21_;
#line 135 "../src/data/Emulator.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp18_, "emu_dir", _tmp22_);
#line 135 "../src/data/Emulator.vala"
		_g_free0 (_tmp22_);
#line 136 "../src/data/Emulator.vala"
		if (game != NULL) {
#line 1830 "Emulator.c"
			GeeHashMap* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			GeeHashMap* _tmp30_;
			GFile* _tmp31_;
			GFile* _tmp32_;
			GFile* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			GeeHashMap* _tmp36_;
			GFile* _tmp37_;
			GFile* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
#line 138 "../src/data/Emulator.vala"
			_tmp23_ = variables;
#line 138 "../src/data/Emulator.vala"
			_tmp24_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) game);
#line 138 "../src/data/Emulator.vala"
			_tmp25_ = _tmp24_;
#line 138 "../src/data/Emulator.vala"
			_tmp26_ = string_replace (_tmp25_, ": ", " - ");
#line 138 "../src/data/Emulator.vala"
			_tmp27_ = _tmp26_;
#line 138 "../src/data/Emulator.vala"
			_tmp28_ = string_replace (_tmp27_, ":", "");
#line 138 "../src/data/Emulator.vala"
			_tmp29_ = _tmp28_;
#line 138 "../src/data/Emulator.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, "game", _tmp29_);
#line 138 "../src/data/Emulator.vala"
			_g_free0 (_tmp29_);
#line 138 "../src/data/Emulator.vala"
			_g_free0 (_tmp27_);
#line 139 "../src/data/Emulator.vala"
			_tmp30_ = variables;
#line 139 "../src/data/Emulator.vala"
			_tmp31_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) game);
#line 139 "../src/data/Emulator.vala"
			_tmp32_ = _tmp31_;
#line 139 "../src/data/Emulator.vala"
			_tmp33_ = _tmp32_;
#line 139 "../src/data/Emulator.vala"
			_tmp34_ = g_file_get_path (_tmp33_);
#line 139 "../src/data/Emulator.vala"
			_tmp35_ = _tmp34_;
#line 139 "../src/data/Emulator.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp30_, "file", _tmp35_);
#line 139 "../src/data/Emulator.vala"
			_g_free0 (_tmp35_);
#line 139 "../src/data/Emulator.vala"
			_g_object_unref0 (_tmp33_);
#line 140 "../src/data/Emulator.vala"
			_tmp36_ = variables;
#line 140 "../src/data/Emulator.vala"
			_tmp37_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) game);
#line 140 "../src/data/Emulator.vala"
			_tmp38_ = _tmp37_;
#line 140 "../src/data/Emulator.vala"
			_tmp39_ = g_file_get_path (_tmp38_);
#line 140 "../src/data/Emulator.vala"
			_tmp40_ = _tmp39_;
#line 140 "../src/data/Emulator.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp36_, "game_dir", _tmp40_);
#line 140 "../src/data/Emulator.vala"
			_g_free0 (_tmp40_);
#line 1901 "Emulator.c"
		} else {
			GeeHashMap* _tmp41_;
			GeeHashMap* _tmp42_;
			GeeHashMap* _tmp43_;
#line 144 "../src/data/Emulator.vala"
			_tmp41_ = variables;
#line 144 "../src/data/Emulator.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp41_, "game", "");
#line 145 "../src/data/Emulator.vala"
			_tmp42_ = variables;
#line 145 "../src/data/Emulator.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp42_, "file", "");
#line 146 "../src/data/Emulator.vala"
			_tmp43_ = variables;
#line 146 "../src/data/Emulator.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp43_, "game_dir", "");
#line 1918 "Emulator.c"
		}
#line 148 "../src/data/Emulator.vala"
		_tmp44_ = game_hub_data_runnable_get_arguments ((GameHubDataRunnable*) self);
#line 148 "../src/data/Emulator.vala"
		_tmp45_ = _tmp44_;
#line 148 "../src/data/Emulator.vala"
		_tmp47_ = game_hub_utils_parse_args (_tmp45_, &_tmp46_);
#line 148 "../src/data/Emulator.vala"
		args = _tmp47_;
#line 148 "../src/data/Emulator.vala"
		args_length1 = _tmp46_;
#line 148 "../src/data/Emulator.vala"
		_args_size_ = args_length1;
#line 149 "../src/data/Emulator.vala"
		_tmp48_ = args;
#line 149 "../src/data/Emulator.vala"
		_tmp48__length1 = args_length1;
#line 149 "../src/data/Emulator.vala"
		if (_tmp48_ != NULL) {
#line 1938 "Emulator.c"
			gboolean _tmp49_ = FALSE;
			gchar** _tmp57_;
			gint _tmp57__length1;
#line 151 "../src/data/Emulator.vala"
			if (exec != NULL) {
#line 1944 "Emulator.c"
				gboolean _tmp50_ = FALSE;
				gchar** _tmp51_;
				gint _tmp51__length1;
#line 151 "../src/data/Emulator.vala"
				_tmp51_ = args;
#line 151 "../src/data/Emulator.vala"
				_tmp51__length1 = args_length1;
#line 151 "../src/data/Emulator.vala"
				if (_vala_string_array_contains (_tmp51_, _tmp51__length1, "$command")) {
#line 151 "../src/data/Emulator.vala"
					_tmp50_ = TRUE;
#line 1956 "Emulator.c"
				} else {
					gchar** _tmp52_;
					gint _tmp52__length1;
#line 151 "../src/data/Emulator.vala"
					_tmp52_ = args;
#line 151 "../src/data/Emulator.vala"
					_tmp52__length1 = args_length1;
#line 151 "../src/data/Emulator.vala"
					_tmp50_ = _vala_string_array_contains (_tmp52_, _tmp52__length1, "${command}");
#line 1966 "Emulator.c"
				}
#line 151 "../src/data/Emulator.vala"
				_tmp49_ = _tmp50_;
#line 1970 "Emulator.c"
			} else {
#line 151 "../src/data/Emulator.vala"
				_tmp49_ = FALSE;
#line 1974 "Emulator.c"
			}
#line 151 "../src/data/Emulator.vala"
			if (_tmp49_) {
#line 1978 "Emulator.c"
				gchar** _tmp53_;
				GeeHashMap* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
#line 153 "../src/data/Emulator.vala"
				_tmp53_ = g_new0 (gchar*, 0 + 1);
#line 153 "../src/data/Emulator.vala"
				result_args = (_vala_array_free (result_args, result_args_length1, (GDestroyNotify) g_free), NULL);
#line 153 "../src/data/Emulator.vala"
				result_args = _tmp53_;
#line 153 "../src/data/Emulator.vala"
				result_args_length1 = 0;
#line 153 "../src/data/Emulator.vala"
				_result_args_size_ = result_args_length1;
#line 154 "../src/data/Emulator.vala"
				_tmp54_ = variables;
#line 154 "../src/data/Emulator.vala"
				_tmp55_ = g_file_get_path (exec);
#line 154 "../src/data/Emulator.vala"
				_tmp56_ = _tmp55_;
#line 154 "../src/data/Emulator.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp54_, "command", _tmp56_);
#line 154 "../src/data/Emulator.vala"
				_g_free0 (_tmp56_);
#line 2003 "Emulator.c"
			}
#line 156 "../src/data/Emulator.vala"
			_tmp57_ = args;
#line 156 "../src/data/Emulator.vala"
			_tmp57__length1 = args_length1;
#line 2009 "Emulator.c"
			{
				gchar** arg_collection = NULL;
				gint arg_collection_length1 = 0;
				gint _arg_collection_size_ = 0;
				gint arg_it = 0;
#line 156 "../src/data/Emulator.vala"
				arg_collection = _tmp57_;
#line 156 "../src/data/Emulator.vala"
				arg_collection_length1 = _tmp57__length1;
#line 156 "../src/data/Emulator.vala"
				for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 2021 "Emulator.c"
					gchar* _tmp58_;
					gchar* arg = NULL;
#line 156 "../src/data/Emulator.vala"
					_tmp58_ = g_strdup (arg_collection[arg_it]);
#line 156 "../src/data/Emulator.vala"
					arg = _tmp58_;
#line 2028 "Emulator.c"
					{
						gboolean _tmp59_ = FALSE;
						const gchar* _tmp60_;
						const gchar* _tmp72_;
						gchar** _tmp76_;
						gint _tmp76__length1;
						const gchar* _tmp77_;
						gchar* _tmp78_;
#line 158 "../src/data/Emulator.vala"
						_tmp60_ = arg;
#line 158 "../src/data/Emulator.vala"
						if (g_strcmp0 (_tmp60_, "$game_args") == 0) {
#line 158 "../src/data/Emulator.vala"
							_tmp59_ = TRUE;
#line 2043 "Emulator.c"
						} else {
							const gchar* _tmp61_;
#line 158 "../src/data/Emulator.vala"
							_tmp61_ = arg;
#line 158 "../src/data/Emulator.vala"
							_tmp59_ = g_strcmp0 (_tmp61_, "${game_args}") == 0;
#line 2050 "Emulator.c"
						}
#line 158 "../src/data/Emulator.vala"
						if (_tmp59_) {
#line 160 "../src/data/Emulator.vala"
							if (game != NULL) {
#line 2056 "Emulator.c"
								gchar** game_args = NULL;
								const gchar* _tmp62_;
								const gchar* _tmp63_;
								gint _tmp64_ = 0;
								gchar** _tmp65_;
								gint game_args_length1;
								gint _game_args_size_;
								gchar** _tmp66_;
								gint _tmp66__length1;
#line 162 "../src/data/Emulator.vala"
								_tmp62_ = game_hub_data_runnable_get_arguments ((GameHubDataRunnable*) game);
#line 162 "../src/data/Emulator.vala"
								_tmp63_ = _tmp62_;
#line 162 "../src/data/Emulator.vala"
								_tmp65_ = game_hub_utils_parse_args (_tmp63_, &_tmp64_);
#line 162 "../src/data/Emulator.vala"
								game_args = _tmp65_;
#line 162 "../src/data/Emulator.vala"
								game_args_length1 = _tmp64_;
#line 162 "../src/data/Emulator.vala"
								_game_args_size_ = game_args_length1;
#line 163 "../src/data/Emulator.vala"
								_tmp66_ = game_args;
#line 163 "../src/data/Emulator.vala"
								_tmp66__length1 = game_args_length1;
#line 163 "../src/data/Emulator.vala"
								if (_tmp66_ != NULL) {
#line 2084 "Emulator.c"
									gchar** _tmp67_;
									gint _tmp67__length1;
#line 165 "../src/data/Emulator.vala"
									_tmp67_ = game_args;
#line 165 "../src/data/Emulator.vala"
									_tmp67__length1 = game_args_length1;
#line 2091 "Emulator.c"
									{
										gchar** game_arg_collection = NULL;
										gint game_arg_collection_length1 = 0;
										gint _game_arg_collection_size_ = 0;
										gint game_arg_it = 0;
#line 165 "../src/data/Emulator.vala"
										game_arg_collection = _tmp67_;
#line 165 "../src/data/Emulator.vala"
										game_arg_collection_length1 = _tmp67__length1;
#line 165 "../src/data/Emulator.vala"
										for (game_arg_it = 0; game_arg_it < game_arg_collection_length1; game_arg_it = game_arg_it + 1) {
#line 2103 "Emulator.c"
											gchar* _tmp68_;
											gchar* game_arg = NULL;
#line 165 "../src/data/Emulator.vala"
											_tmp68_ = g_strdup (game_arg_collection[game_arg_it]);
#line 165 "../src/data/Emulator.vala"
											game_arg = _tmp68_;
#line 2110 "Emulator.c"
											{
												gchar** _tmp69_;
												gint _tmp69__length1;
												const gchar* _tmp70_;
												gchar* _tmp71_;
#line 167 "../src/data/Emulator.vala"
												_tmp69_ = result_args;
#line 167 "../src/data/Emulator.vala"
												_tmp69__length1 = result_args_length1;
#line 167 "../src/data/Emulator.vala"
												_tmp70_ = game_arg;
#line 167 "../src/data/Emulator.vala"
												_tmp71_ = g_strdup (_tmp70_);
#line 167 "../src/data/Emulator.vala"
												_vala_array_add12 (&result_args, &result_args_length1, &_result_args_size_, _tmp71_);
#line 165 "../src/data/Emulator.vala"
												_g_free0 (game_arg);
#line 2128 "Emulator.c"
											}
										}
									}
								}
#line 160 "../src/data/Emulator.vala"
								game_args = (_vala_array_free (game_args, game_args_length1, (GDestroyNotify) g_free), NULL);
#line 2135 "Emulator.c"
							}
#line 171 "../src/data/Emulator.vala"
							_g_free0 (arg);
#line 171 "../src/data/Emulator.vala"
							continue;
#line 2141 "Emulator.c"
						}
#line 173 "../src/data/Emulator.vala"
						_tmp72_ = arg;
#line 173 "../src/data/Emulator.vala"
						if (string_contains (_tmp72_, "$")) {
#line 2147 "Emulator.c"
							const gchar* _tmp73_;
							GeeHashMap* _tmp74_;
							gchar* _tmp75_;
#line 175 "../src/data/Emulator.vala"
							_tmp73_ = arg;
#line 175 "../src/data/Emulator.vala"
							_tmp74_ = variables;
#line 175 "../src/data/Emulator.vala"
							_tmp75_ = game_hub_utils_fs_utils_expand (_tmp73_, NULL, _tmp74_);
#line 175 "../src/data/Emulator.vala"
							_g_free0 (arg);
#line 175 "../src/data/Emulator.vala"
							arg = _tmp75_;
#line 2161 "Emulator.c"
						}
#line 177 "../src/data/Emulator.vala"
						_tmp76_ = result_args;
#line 177 "../src/data/Emulator.vala"
						_tmp76__length1 = result_args_length1;
#line 177 "../src/data/Emulator.vala"
						_tmp77_ = arg;
#line 177 "../src/data/Emulator.vala"
						_tmp78_ = g_strdup (_tmp77_);
#line 177 "../src/data/Emulator.vala"
						_vala_array_add13 (&result_args, &result_args_length1, &_result_args_size_, _tmp78_);
#line 156 "../src/data/Emulator.vala"
						_g_free0 (arg);
#line 2175 "Emulator.c"
					}
				}
			}
		}
#line 131 "../src/data/Emulator.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 131 "../src/data/Emulator.vala"
		_g_object_unref0 (variables);
#line 2184 "Emulator.c"
	}
#line 182 "../src/data/Emulator.vala"
	_tmp79_ = result_args;
#line 182 "../src/data/Emulator.vala"
	_tmp79__length1 = result_args_length1;
#line 182 "../src/data/Emulator.vala"
	if (result_length1) {
#line 182 "../src/data/Emulator.vala"
		*result_length1 = _tmp79__length1;
#line 2194 "Emulator.c"
	}
#line 182 "../src/data/Emulator.vala"
	result = _tmp79_;
#line 182 "../src/data/Emulator.vala"
	return result;
#line 2200 "Emulator.c"
}

static void
game_hub_data_emulator_real_run_data_free (gpointer _data)
{
	GameHubDataEmulatorRunData* _data_;
	_data_ = _data;
#line 25 "../src/data/Emulator.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/Emulator.vala"
	g_slice_free (GameHubDataEmulatorRunData, _data_);
#line 2212 "Emulator.c"
}

static void
game_hub_data_emulator_real_run (GameHubDataRunnable* base,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	GameHubDataEmulator * self;
	GameHubDataEmulatorRunData* _data_;
	GameHubDataEmulator* _tmp0_;
#line 25 "../src/data/Emulator.vala"
	self = (GameHubDataEmulator*) base;
#line 25 "../src/data/Emulator.vala"
	_data_ = g_slice_new0 (GameHubDataEmulatorRunData);
#line 25 "../src/data/Emulator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/Emulator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_emulator_real_run_data_free);
#line 25 "../src/data/Emulator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/Emulator.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/Emulator.vala"
	game_hub_data_emulator_real_run_co (_data_);
#line 2237 "Emulator.c"
}

static void
game_hub_data_emulator_run_finish (GameHubDataRunnable* base,
                                   GAsyncResult* _res_)
{
	GameHubDataEmulatorRunData* _data_;
#line 25 "../src/data/Emulator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2247 "Emulator.c"
}

static void
game_hub_data_emulator_run_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	GameHubDataEmulatorRunData* _data_;
#line 191 "../src/data/Emulator.vala"
	_data_ = _user_data_;
#line 191 "../src/data/Emulator.vala"
	_data_->_source_object_ = source_object;
#line 191 "../src/data/Emulator.vala"
	_data_->_res_ = _res_;
#line 191 "../src/data/Emulator.vala"
	game_hub_data_emulator_real_run_co (_data_);
#line 2264 "Emulator.c"
}

static gboolean
___lambda112_ (GameHubDataEmulator* self)
{
	gboolean result = FALSE;
#line 194 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_is_running ((GameHubDataRunnable*) self, FALSE);
#line 194 "../src/data/Emulator.vala"
	game_hub_data_runnable_IsLaunched = FALSE;
#line 195 "../src/data/Emulator.vala"
	result = G_SOURCE_REMOVE;
#line 195 "../src/data/Emulator.vala"
	return result;
#line 2279 "Emulator.c"
}

static gboolean
____lambda112__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda112_ ((GameHubDataEmulator*) self);
#line 193 "../src/data/Emulator.vala"
	return result;
#line 2289 "Emulator.c"
}

static gboolean
game_hub_data_emulator_real_run_co (GameHubDataEmulatorRunData* _data_)
{
#line 185 "../src/data/Emulator.vala"
	switch (_data_->_state_) {
#line 185 "../src/data/Emulator.vala"
		case 0:
#line 2299 "Emulator.c"
		goto _state_0;
#line 185 "../src/data/Emulator.vala"
		case 1:
#line 2303 "Emulator.c"
		goto _state_1;
		default:
#line 185 "../src/data/Emulator.vala"
		g_assert_not_reached ();
#line 2308 "Emulator.c"
	}
	_state_0:
#line 187 "../src/data/Emulator.vala"
	if (game_hub_data_runnable_can_be_launched ((GameHubDataRunnable*) _data_->self, TRUE)) {
#line 187 "../src/data/Emulator.vala"
		_data_->_tmp1_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) _data_->self);
#line 187 "../src/data/Emulator.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 187 "../src/data/Emulator.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 187 "../src/data/Emulator.vala"
		_data_->_tmp0_ = g_file_query_exists (_data_->_tmp3_, NULL);
#line 187 "../src/data/Emulator.vala"
		_g_object_unref0 (_data_->_tmp3_);
#line 2323 "Emulator.c"
	} else {
#line 187 "../src/data/Emulator.vala"
		_data_->_tmp0_ = FALSE;
#line 2327 "Emulator.c"
	}
#line 187 "../src/data/Emulator.vala"
	if (_data_->_tmp0_) {
#line 189 "../src/data/Emulator.vala"
		game_hub_data_runnable_set_is_running ((GameHubDataRunnable*) _data_->self, TRUE);
#line 189 "../src/data/Emulator.vala"
		game_hub_data_runnable_IsLaunched = TRUE;
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp4_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) _data_->self);
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp7_ = 0;
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp8_ = game_hub_data_emulator_get_args (_data_->self, NULL, _data_->_tmp6_, &_data_->_tmp7_);
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp9__length1 = _data_->_tmp7_;
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp10_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) _data_->self);
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp13_ = g_file_get_parent (_data_->_tmp12_);
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp15_ = g_file_get_path (_data_->_tmp14_);
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 191 "../src/data/Emulator.vala"
		_data_->_state_ = 1;
#line 191 "../src/data/Emulator.vala"
		game_hub_utils_run_thread (_data_->_tmp9_, (gint) _data_->_tmp7_, _data_->_tmp16_, NULL, (gint) 0, TRUE, FALSE, TRUE, game_hub_data_emulator_run_ready, _data_);
#line 191 "../src/data/Emulator.vala"
		return FALSE;
#line 2369 "Emulator.c"
		_state_1:
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp17_ = game_hub_utils_run_thread_finish (_data_->_res_);
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp18_ = _data_->_tmp17_;
#line 191 "../src/data/Emulator.vala"
		_g_free0 (_data_->_tmp18_);
#line 191 "../src/data/Emulator.vala"
		_g_free0 (_data_->_tmp16_);
#line 191 "../src/data/Emulator.vala"
		_g_object_unref0 (_data_->_tmp14_);
#line 191 "../src/data/Emulator.vala"
		_g_object_unref0 (_data_->_tmp12_);
#line 191 "../src/data/Emulator.vala"
		_data_->_tmp9_ = (_vala_array_free (_data_->_tmp9_, _data_->_tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 191 "../src/data/Emulator.vala"
		_g_object_unref0 (_data_->_tmp6_);
#line 193 "../src/data/Emulator.vala"
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ____lambda112__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 2389 "Emulator.c"
	}
#line 185 "../src/data/Emulator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 185 "../src/data/Emulator.vala"
	if (_data_->_state_ != 0) {
#line 185 "../src/data/Emulator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 185 "../src/data/Emulator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2399 "Emulator.c"
		}
	}
#line 185 "../src/data/Emulator.vala"
	g_object_unref (_data_->_async_result);
#line 185 "../src/data/Emulator.vala"
	return FALSE;
#line 2406 "Emulator.c"
}

static void
game_hub_data_emulator_run_game_data_free (gpointer _data)
{
	GameHubDataEmulatorRunGameData* _data_;
	_data_ = _data;
#line 25 "../src/data/Emulator.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/Emulator.vala"
	g_slice_free (GameHubDataEmulatorRunGameData, _data_);
#line 2418 "Emulator.c"
}

void
game_hub_data_emulator_run_game (GameHubDataEmulator* self,
                                 GameHubDataGame* game,
                                 gboolean launch_in_game_dir,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	GameHubDataEmulatorRunGameData* _data_;
	GameHubDataEmulator* _tmp0_;
	GameHubDataGame* _tmp1_;
#line 25 "../src/data/Emulator.vala"
	_data_ = g_slice_new0 (GameHubDataEmulatorRunGameData);
#line 25 "../src/data/Emulator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/Emulator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_emulator_run_game_data_free);
#line 25 "../src/data/Emulator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/Emulator.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/Emulator.vala"
	_tmp1_ = _g_object_ref0 (game);
#line 25 "../src/data/Emulator.vala"
	_g_object_unref0 (_data_->game);
#line 25 "../src/data/Emulator.vala"
	_data_->game = _tmp1_;
#line 25 "../src/data/Emulator.vala"
	_data_->launch_in_game_dir = launch_in_game_dir;
#line 25 "../src/data/Emulator.vala"
	game_hub_data_emulator_run_game_co (_data_);
#line 2451 "Emulator.c"
}

void
game_hub_data_emulator_run_game_finish (GameHubDataEmulator* self,
                                        GAsyncResult* _res_)
{
	GameHubDataEmulatorRunGameData* _data_;
#line 25 "../src/data/Emulator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2461 "Emulator.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 200 "../src/data/Emulator.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 200 "../src/data/Emulator.vala"
	return _data11_;
#line 2471 "Emulator.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 200 "../src/data/Emulator.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 2481 "Emulator.c"
		GameHubDataEmulator* self;
#line 200 "../src/data/Emulator.vala"
		self = _data11_->self;
#line 200 "../src/data/Emulator.vala"
		_g_object_unref0 (_data11_->game);
#line 200 "../src/data/Emulator.vala"
		_g_object_unref0 (self);
#line 200 "../src/data/Emulator.vala"
		g_slice_free (Block11Data, _data11_);
#line 2491 "Emulator.c"
	}
}

static void
game_hub_data_emulator_run_game_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	GameHubDataEmulatorRunGameData* _data_;
#line 204 "../src/data/Emulator.vala"
	_data_ = _user_data_;
#line 204 "../src/data/Emulator.vala"
	_data_->_source_object_ = source_object;
#line 204 "../src/data/Emulator.vala"
	_data_->_res_ = _res_;
#line 204 "../src/data/Emulator.vala"
	game_hub_data_emulator_run_game_co (_data_);
#line 2509 "Emulator.c"
}

static gboolean
___lambda113_ (Block11Data* _data11_)
{
	GameHubDataEmulator* self;
	gboolean result = FALSE;
#line 221 "../src/data/Emulator.vala"
	self = _data11_->self;
#line 222 "../src/data/Emulator.vala"
	game_hub_data_runnable_set_is_running ((GameHubDataRunnable*) self, FALSE);
#line 222 "../src/data/Emulator.vala"
	game_hub_data_runnable_IsLaunched = FALSE;
#line 223 "../src/data/Emulator.vala"
	if (_data11_->game != NULL) {
#line 225 "../src/data/Emulator.vala"
		game_hub_data_runnable_set_is_running ((GameHubDataRunnable*) _data11_->game, FALSE);
#line 226 "../src/data/Emulator.vala"
		game_hub_data_runnable_update_status ((GameHubDataRunnable*) _data11_->game);
#line 2529 "Emulator.c"
	}
#line 228 "../src/data/Emulator.vala"
	result = G_SOURCE_REMOVE;
#line 228 "../src/data/Emulator.vala"
	return result;
#line 2535 "Emulator.c"
}

static gboolean
____lambda113__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda113_ (self);
#line 221 "../src/data/Emulator.vala"
	return result;
#line 2545 "Emulator.c"
}

static gboolean
game_hub_data_emulator_run_game_co (GameHubDataEmulatorRunGameData* _data_)
{
#line 200 "../src/data/Emulator.vala"
	switch (_data_->_state_) {
#line 200 "../src/data/Emulator.vala"
		case 0:
#line 2555 "Emulator.c"
		goto _state_0;
#line 200 "../src/data/Emulator.vala"
		case 1:
#line 2559 "Emulator.c"
		goto _state_1;
#line 200 "../src/data/Emulator.vala"
		case 2:
#line 2563 "Emulator.c"
		goto _state_2;
		default:
#line 200 "../src/data/Emulator.vala"
		g_assert_not_reached ();
#line 2568 "Emulator.c"
	}
	_state_0:
#line 200 "../src/data/Emulator.vala"
	_data_->_data11_ = g_slice_new0 (Block11Data);
#line 200 "../src/data/Emulator.vala"
	_data_->_data11_->_ref_count_ = 1;
#line 200 "../src/data/Emulator.vala"
	_data_->_data11_->self = g_object_ref (_data_->self);
#line 200 "../src/data/Emulator.vala"
	_g_object_unref0 (_data_->_data11_->game);
#line 200 "../src/data/Emulator.vala"
	_data_->_data11_->game = _data_->game;
#line 200 "../src/data/Emulator.vala"
	_data_->_data11_->_async_data_ = _data_;
#line 202 "../src/data/Emulator.vala"
	_data_->_tmp0_ = game_hub_data_runnable_get_use_compat ((GameHubDataRunnable*) _data_->self);
#line 202 "../src/data/Emulator.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 202 "../src/data/Emulator.vala"
	if (_data_->_tmp1_) {
#line 204 "../src/data/Emulator.vala"
		_data_->_state_ = 1;
#line 204 "../src/data/Emulator.vala"
		game_hub_data_emulator_run_game_compat (_data_->self, _data_->_data11_->game, _data_->launch_in_game_dir, game_hub_data_emulator_run_game_ready, _data_);
#line 204 "../src/data/Emulator.vala"
		return FALSE;
#line 2595 "Emulator.c"
		_state_1:
#line 204 "../src/data/Emulator.vala"
		game_hub_data_emulator_run_game_compat_finish (_data_->self, _data_->_res_);
#line 205 "../src/data/Emulator.vala"
		block11_data_unref (_data_->_data11_);
#line 205 "../src/data/Emulator.vala"
		_data_->_data11_ = NULL;
#line 205 "../src/data/Emulator.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 205 "../src/data/Emulator.vala"
		if (_data_->_state_ != 0) {
#line 205 "../src/data/Emulator.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 205 "../src/data/Emulator.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2611 "Emulator.c"
			}
		}
#line 205 "../src/data/Emulator.vala"
		g_object_unref (_data_->_async_result);
#line 205 "../src/data/Emulator.vala"
		return FALSE;
#line 2618 "Emulator.c"
	}
#line 208 "../src/data/Emulator.vala"
	_data_->_tmp2_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) _data_->self);
#line 208 "../src/data/Emulator.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 208 "../src/data/Emulator.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 208 "../src/data/Emulator.vala"
	_data_->_tmp5_ = g_file_query_exists (_data_->_tmp4_, NULL);
#line 208 "../src/data/Emulator.vala"
	_g_object_unref0 (_data_->_tmp4_);
#line 208 "../src/data/Emulator.vala"
	if (_data_->_tmp5_) {
#line 210 "../src/data/Emulator.vala"
		game_hub_data_runnable_set_is_running ((GameHubDataRunnable*) _data_->self, TRUE);
#line 210 "../src/data/Emulator.vala"
		game_hub_data_runnable_IsLaunched = TRUE;
#line 212 "../src/data/Emulator.vala"
		if (_data_->_data11_->game != NULL) {
#line 214 "../src/data/Emulator.vala"
			game_hub_data_runnable_set_is_running ((GameHubDataRunnable*) _data_->_data11_->game, TRUE);
#line 215 "../src/data/Emulator.vala"
			game_hub_data_runnable_update_status ((GameHubDataRunnable*) _data_->_data11_->game);
#line 2642 "Emulator.c"
		}
#line 218 "../src/data/Emulator.vala"
		if (_data_->_data11_->game != NULL) {
#line 218 "../src/data/Emulator.vala"
			_data_->_tmp7_ = _data_->launch_in_game_dir;
#line 2648 "Emulator.c"
		} else {
#line 218 "../src/data/Emulator.vala"
			_data_->_tmp7_ = FALSE;
#line 2652 "Emulator.c"
		}
#line 218 "../src/data/Emulator.vala"
		if (_data_->_tmp7_) {
#line 218 "../src/data/Emulator.vala"
			_data_->_tmp8_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->_data11_->game);
#line 218 "../src/data/Emulator.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 218 "../src/data/Emulator.vala"
			_data_->_tmp6_ = _data_->_tmp9_;
#line 2662 "Emulator.c"
		} else {
#line 218 "../src/data/Emulator.vala"
			_data_->_tmp10_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->self);
#line 218 "../src/data/Emulator.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 218 "../src/data/Emulator.vala"
			_data_->_tmp6_ = _data_->_tmp11_;
#line 2670 "Emulator.c"
		}
#line 218 "../src/data/Emulator.vala"
		_data_->_tmp12_ = _g_object_ref0 (_data_->_tmp6_);
#line 218 "../src/data/Emulator.vala"
		_data_->dir = _data_->_tmp12_;
#line 219 "../src/data/Emulator.vala"
		_data_->_tmp13_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) _data_->self);
#line 219 "../src/data/Emulator.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 219 "../src/data/Emulator.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 219 "../src/data/Emulator.vala"
		_data_->_tmp16_ = 0;
#line 219 "../src/data/Emulator.vala"
		_data_->_tmp17_ = game_hub_data_emulator_get_args (_data_->self, _data_->_data11_->game, _data_->_tmp15_, &_data_->_tmp16_);
#line 219 "../src/data/Emulator.vala"
		_data_->_tmp18_ = _data_->_tmp17_;
#line 219 "../src/data/Emulator.vala"
		_data_->_tmp18__length1 = _data_->_tmp16_;
#line 219 "../src/data/Emulator.vala"
		_data_->_tmp19_ = _data_->dir;
#line 219 "../src/data/Emulator.vala"
		_data_->_tmp20_ = g_file_get_path (_data_->_tmp19_);
#line 219 "../src/data/Emulator.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 219 "../src/data/Emulator.vala"
		_data_->_state_ = 2;
#line 219 "../src/data/Emulator.vala"
		game_hub_utils_run_thread (_data_->_tmp18_, (gint) _data_->_tmp16_, _data_->_tmp21_, NULL, (gint) 0, TRUE, FALSE, TRUE, game_hub_data_emulator_run_game_ready, _data_);
#line 219 "../src/data/Emulator.vala"
		return FALSE;
#line 2702 "Emulator.c"
		_state_2:
#line 219 "../src/data/Emulator.vala"
		_data_->_tmp22_ = game_hub_utils_run_thread_finish (_data_->_res_);
#line 219 "../src/data/Emulator.vala"
		_data_->_tmp23_ = _data_->_tmp22_;
#line 219 "../src/data/Emulator.vala"
		_g_free0 (_data_->_tmp23_);
#line 219 "../src/data/Emulator.vala"
		_g_free0 (_data_->_tmp21_);
#line 219 "../src/data/Emulator.vala"
		_data_->_tmp18_ = (_vala_array_free (_data_->_tmp18_, _data_->_tmp18__length1, (GDestroyNotify) g_free), NULL);
#line 219 "../src/data/Emulator.vala"
		_g_object_unref0 (_data_->_tmp15_);
#line 221 "../src/data/Emulator.vala"
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ____lambda113__gsource_func, block11_data_ref (_data_->_data11_), block11_data_unref);
#line 208 "../src/data/Emulator.vala"
		_g_object_unref0 (_data_->dir);
#line 2720 "Emulator.c"
	}
#line 200 "../src/data/Emulator.vala"
	block11_data_unref (_data_->_data11_);
#line 200 "../src/data/Emulator.vala"
	_data_->_data11_ = NULL;
#line 200 "../src/data/Emulator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 200 "../src/data/Emulator.vala"
	if (_data_->_state_ != 0) {
#line 200 "../src/data/Emulator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 200 "../src/data/Emulator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2734 "Emulator.c"
		}
	}
#line 200 "../src/data/Emulator.vala"
	g_object_unref (_data_->_async_result);
#line 200 "../src/data/Emulator.vala"
	return FALSE;
#line 2741 "Emulator.c"
}

static void
game_hub_data_emulator_run_game_compat_data_free (gpointer _data)
{
	GameHubDataEmulatorRunGameCompatData* _data_;
	_data_ = _data;
#line 25 "../src/data/Emulator.vala"
	_g_object_unref0 (_data_->game);
#line 25 "../src/data/Emulator.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/Emulator.vala"
	g_slice_free (GameHubDataEmulatorRunGameCompatData, _data_);
#line 2755 "Emulator.c"
}

void
game_hub_data_emulator_run_game_compat (GameHubDataEmulator* self,
                                        GameHubDataGame* game,
                                        gboolean launch_in_game_dir,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	GameHubDataEmulatorRunGameCompatData* _data_;
	GameHubDataEmulator* _tmp0_;
	GameHubDataGame* _tmp1_;
#line 25 "../src/data/Emulator.vala"
	_data_ = g_slice_new0 (GameHubDataEmulatorRunGameCompatData);
#line 25 "../src/data/Emulator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/Emulator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_emulator_run_game_compat_data_free);
#line 25 "../src/data/Emulator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/Emulator.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/Emulator.vala"
	_tmp1_ = _g_object_ref0 (game);
#line 25 "../src/data/Emulator.vala"
	_g_object_unref0 (_data_->game);
#line 25 "../src/data/Emulator.vala"
	_data_->game = _tmp1_;
#line 25 "../src/data/Emulator.vala"
	_data_->launch_in_game_dir = launch_in_game_dir;
#line 25 "../src/data/Emulator.vala"
	game_hub_data_emulator_run_game_compat_co (_data_);
#line 2788 "Emulator.c"
}

void
game_hub_data_emulator_run_game_compat_finish (GameHubDataEmulator* self,
                                               GAsyncResult* _res_)
{
	GameHubDataEmulatorRunGameCompatData* _data_;
#line 25 "../src/data/Emulator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2798 "Emulator.c"
}

static gboolean
game_hub_data_emulator_run_game_compat_co (GameHubDataEmulatorRunGameCompatData* _data_)
{
#line 233 "../src/data/Emulator.vala"
	switch (_data_->_state_) {
#line 233 "../src/data/Emulator.vala"
		case 0:
#line 2808 "Emulator.c"
		goto _state_0;
		default:
#line 233 "../src/data/Emulator.vala"
		g_assert_not_reached ();
#line 2813 "Emulator.c"
	}
	_state_0:
#line 235 "../src/data/Emulator.vala"
	_data_->_tmp0_ = game_hub_ui_dialogs_compat_run_dialog_new ((GameHubDataRunnable*) _data_->self, FALSE, _data_->game, _data_->launch_in_game_dir);
#line 235 "../src/data/Emulator.vala"
	g_object_ref_sink (_data_->_tmp0_);
#line 235 "../src/data/Emulator.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 235 "../src/data/Emulator.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 233 "../src/data/Emulator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 233 "../src/data/Emulator.vala"
	if (_data_->_state_ != 0) {
#line 233 "../src/data/Emulator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 233 "../src/data/Emulator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2832 "Emulator.c"
		}
	}
#line 233 "../src/data/Emulator.vala"
	g_object_unref (_data_->_async_result);
#line 233 "../src/data/Emulator.vala"
	return FALSE;
#line 2839 "Emulator.c"
}

gboolean
game_hub_data_emulator_is_equal (GameHubDataEmulator* first,
                                 GameHubDataEmulator* second)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
#line 238 "../src/data/Emulator.vala"
	g_return_val_if_fail (first != NULL, FALSE);
#line 238 "../src/data/Emulator.vala"
	g_return_val_if_fail (second != NULL, FALSE);
#line 240 "../src/data/Emulator.vala"
	if (first == second) {
#line 240 "../src/data/Emulator.vala"
		_tmp0_ = TRUE;
#line 2856 "Emulator.c"
	} else {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 240 "../src/data/Emulator.vala"
		_tmp1_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) first);
#line 240 "../src/data/Emulator.vala"
		_tmp2_ = _tmp1_;
#line 240 "../src/data/Emulator.vala"
		_tmp3_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) second);
#line 240 "../src/data/Emulator.vala"
		_tmp4_ = _tmp3_;
#line 240 "../src/data/Emulator.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, _tmp4_) == 0;
#line 2872 "Emulator.c"
	}
#line 240 "../src/data/Emulator.vala"
	result = _tmp0_;
#line 240 "../src/data/Emulator.vala"
	return result;
#line 2878 "Emulator.c"
}

guint
game_hub_data_emulator_hash (GameHubDataEmulator* emu)
{
	GHashFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	guint result = 0U;
#line 243 "../src/data/Emulator.vala"
	g_return_val_if_fail (emu != NULL, 0U);
#line 245 "../src/data/Emulator.vala"
	_tmp0_ = g_str_hash;
#line 245 "../src/data/Emulator.vala"
	_tmp1_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) emu);
#line 245 "../src/data/Emulator.vala"
	_tmp2_ = _tmp1_;
#line 245 "../src/data/Emulator.vala"
	result = _tmp0_ (_tmp2_);
#line 245 "../src/data/Emulator.vala"
	return result;
#line 2900 "Emulator.c"
}

static GFile*
game_hub_data_emulator_real_get_executable (GameHubDataRunnable* base)
{
	GFile* result;
	GameHubDataEmulator* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 30 "../src/data/Emulator.vala"
	self = (GameHubDataEmulator*) base;
#line 30 "../src/data/Emulator.vala"
	_tmp0_ = self->priv->_executable;
#line 30 "../src/data/Emulator.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 30 "../src/data/Emulator.vala"
	result = _tmp1_;
#line 30 "../src/data/Emulator.vala"
	return result;
#line 2920 "Emulator.c"
}

static void
game_hub_data_emulator_real_set_executable (GameHubDataRunnable* base,
                                            GFile* value)
{
	GameHubDataEmulator* self;
#line 30 "../src/data/Emulator.vala"
	self = (GameHubDataEmulator*) base;
#line 30 "../src/data/Emulator.vala"
	if (game_hub_data_emulator_real_get_executable (base) != value) {
#line 2932 "Emulator.c"
		GFile* _tmp0_;
#line 30 "../src/data/Emulator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/data/Emulator.vala"
		_g_object_unref0 (self->priv->_executable);
#line 30 "../src/data/Emulator.vala"
		self->priv->_executable = _tmp0_;
#line 30 "../src/data/Emulator.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_emulator_properties[GAME_HUB_DATA_EMULATOR_EXECUTABLE_PROPERTY]);
#line 2942 "Emulator.c"
	}
}

const gchar*
game_hub_data_emulator_get_game_executable_pattern (GameHubDataEmulator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/data/Emulator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/data/Emulator.vala"
	_tmp0_ = self->priv->_game_executable_pattern;
#line 33 "../src/data/Emulator.vala"
	result = _tmp0_;
#line 33 "../src/data/Emulator.vala"
	return result;
#line 2959 "Emulator.c"
}

void
game_hub_data_emulator_set_game_executable_pattern (GameHubDataEmulator* self,
                                                    const gchar* value)
{
#line 33 "../src/data/Emulator.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/data/Emulator.vala"
	if (g_strcmp0 (value, game_hub_data_emulator_get_game_executable_pattern (self)) != 0) {
#line 2970 "Emulator.c"
		gchar* _tmp0_;
#line 33 "../src/data/Emulator.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/data/Emulator.vala"
		_g_free0 (self->priv->_game_executable_pattern);
#line 33 "../src/data/Emulator.vala"
		self->priv->_game_executable_pattern = _tmp0_;
#line 33 "../src/data/Emulator.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_emulator_properties[GAME_HUB_DATA_EMULATOR_GAME_EXECUTABLE_PATTERN_PROPERTY]);
#line 2980 "Emulator.c"
	}
}

const gchar*
game_hub_data_emulator_get_game_image_pattern (GameHubDataEmulator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../src/data/Emulator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/data/Emulator.vala"
	_tmp0_ = self->priv->_game_image_pattern;
#line 34 "../src/data/Emulator.vala"
	result = _tmp0_;
#line 34 "../src/data/Emulator.vala"
	return result;
#line 2997 "Emulator.c"
}

void
game_hub_data_emulator_set_game_image_pattern (GameHubDataEmulator* self,
                                               const gchar* value)
{
#line 34 "../src/data/Emulator.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/data/Emulator.vala"
	if (g_strcmp0 (value, game_hub_data_emulator_get_game_image_pattern (self)) != 0) {
#line 3008 "Emulator.c"
		gchar* _tmp0_;
#line 34 "../src/data/Emulator.vala"
		_tmp0_ = g_strdup (value);
#line 34 "../src/data/Emulator.vala"
		_g_free0 (self->priv->_game_image_pattern);
#line 34 "../src/data/Emulator.vala"
		self->priv->_game_image_pattern = _tmp0_;
#line 34 "../src/data/Emulator.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_emulator_properties[GAME_HUB_DATA_EMULATOR_GAME_IMAGE_PATTERN_PROPERTY]);
#line 3018 "Emulator.c"
	}
}

const gchar*
game_hub_data_emulator_get_game_icon_pattern (GameHubDataEmulator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../src/data/Emulator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/data/Emulator.vala"
	_tmp0_ = self->priv->_game_icon_pattern;
#line 35 "../src/data/Emulator.vala"
	result = _tmp0_;
#line 35 "../src/data/Emulator.vala"
	return result;
#line 3035 "Emulator.c"
}

void
game_hub_data_emulator_set_game_icon_pattern (GameHubDataEmulator* self,
                                              const gchar* value)
{
#line 35 "../src/data/Emulator.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/data/Emulator.vala"
	if (g_strcmp0 (value, game_hub_data_emulator_get_game_icon_pattern (self)) != 0) {
#line 3046 "Emulator.c"
		gchar* _tmp0_;
#line 35 "../src/data/Emulator.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../src/data/Emulator.vala"
		_g_free0 (self->priv->_game_icon_pattern);
#line 35 "../src/data/Emulator.vala"
		self->priv->_game_icon_pattern = _tmp0_;
#line 35 "../src/data/Emulator.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_emulator_properties[GAME_HUB_DATA_EMULATOR_GAME_ICON_PATTERN_PROPERTY]);
#line 3056 "Emulator.c"
	}
}

static inline gpointer
game_hub_data_emulator_installer_get_instance_private (GameHubDataEmulatorInstaller* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataEmulatorInstaller_private_offset);
}

GameHubDataEmulatorInstaller*
game_hub_data_emulator_installer_construct (GType object_type,
                                            GameHubDataEmulator* emu,
                                            GFile* installer)
{
	GameHubDataEmulatorInstaller* self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GameHubDataPlatform _tmp3_ = 0;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	GeeArrayList* _tmp9_;
	GeeArrayList* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gint64 _tmp13_;
	gint64 _tmp14_;
	GameHubDataRunnableInstallerPart* _tmp15_;
	GameHubDataRunnableInstallerPart* _tmp16_;
#line 253 "../src/data/Emulator.vala"
	g_return_val_if_fail (emu != NULL, NULL);
#line 253 "../src/data/Emulator.vala"
	g_return_val_if_fail (installer != NULL, NULL);
#line 253 "../src/data/Emulator.vala"
	self = (GameHubDataEmulatorInstaller*) game_hub_data_runnable_installer_construct (object_type);
#line 255 "../src/data/Emulator.vala"
	_tmp0_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) emu);
#line 255 "../src/data/Emulator.vala"
	_tmp1_ = _tmp0_;
#line 255 "../src/data/Emulator.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 255 "../src/data/Emulator.vala"
	_g_free0 (self->priv->emu_name);
#line 255 "../src/data/Emulator.vala"
	self->priv->emu_name = _tmp2_;
#line 256 "../src/data/Emulator.vala"
	game_hub_data_runnable_installer_set_id ((GameHubDataRunnableInstaller*) self, "installer");
#line 257 "../src/data/Emulator.vala"
	_tmp4_ = g_file_get_path (installer);
#line 257 "../src/data/Emulator.vala"
	_tmp5_ = _tmp4_;
#line 257 "../src/data/Emulator.vala"
	_tmp6_ = g_utf8_strdown (_tmp5_, (gssize) -1);
#line 257 "../src/data/Emulator.vala"
	_tmp7_ = _tmp6_;
#line 257 "../src/data/Emulator.vala"
	_tmp8_ = g_str_has_suffix (_tmp7_, ".exe");
#line 257 "../src/data/Emulator.vala"
	_g_free0 (_tmp7_);
#line 257 "../src/data/Emulator.vala"
	_g_free0 (_tmp5_);
#line 257 "../src/data/Emulator.vala"
	if (_tmp8_) {
#line 257 "../src/data/Emulator.vala"
		_tmp3_ = GAME_HUB_DATA_PLATFORM_WINDOWS;
#line 3125 "Emulator.c"
	} else {
#line 257 "../src/data/Emulator.vala"
		_tmp3_ = GAME_HUB_DATA_PLATFORM_LINUX;
#line 3129 "Emulator.c"
	}
#line 257 "../src/data/Emulator.vala"
	game_hub_data_runnable_installer_set_platform ((GameHubDataRunnableInstaller*) self, _tmp3_);
#line 258 "../src/data/Emulator.vala"
	_tmp9_ = game_hub_data_runnable_installer_get_parts ((GameHubDataRunnableInstaller*) self);
#line 258 "../src/data/Emulator.vala"
	_tmp10_ = _tmp9_;
#line 258 "../src/data/Emulator.vala"
	_tmp11_ = g_file_get_uri (installer);
#line 258 "../src/data/Emulator.vala"
	_tmp12_ = _tmp11_;
#line 258 "../src/data/Emulator.vala"
	_tmp13_ = game_hub_data_runnable_installer_get_full_size ((GameHubDataRunnableInstaller*) self);
#line 258 "../src/data/Emulator.vala"
	_tmp14_ = _tmp13_;
#line 258 "../src/data/Emulator.vala"
	_tmp15_ = game_hub_data_runnable_installer_part_new ("installer", _tmp12_, _tmp14_, installer, installer, NULL, G_CHECKSUM_MD5);
#line 258 "../src/data/Emulator.vala"
	_tmp16_ = _tmp15_;
#line 258 "../src/data/Emulator.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp16_);
#line 258 "../src/data/Emulator.vala"
	_g_object_unref0 (_tmp16_);
#line 258 "../src/data/Emulator.vala"
	_g_free0 (_tmp12_);
#line 253 "../src/data/Emulator.vala"
	return self;
#line 3157 "Emulator.c"
}

GameHubDataEmulatorInstaller*
game_hub_data_emulator_installer_new (GameHubDataEmulator* emu,
                                      GFile* installer)
{
#line 253 "../src/data/Emulator.vala"
	return game_hub_data_emulator_installer_construct (GAME_HUB_DATA_EMULATOR_TYPE_INSTALLER, emu, installer);
#line 3166 "Emulator.c"
}

static gchar*
game_hub_data_emulator_installer_real_get_name (GameHubDataRunnableInstaller* base)
{
	gchar* result;
	GameHubDataEmulatorInstaller* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 251 "../src/data/Emulator.vala"
	self = (GameHubDataEmulatorInstaller*) base;
#line 251 "../src/data/Emulator.vala"
	_tmp0_ = self->priv->emu_name;
#line 251 "../src/data/Emulator.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 251 "../src/data/Emulator.vala"
	result = _tmp1_;
#line 251 "../src/data/Emulator.vala"
	return result;
#line 3186 "Emulator.c"
}

static void
game_hub_data_emulator_installer_class_init (GameHubDataEmulatorInstallerClass * klass,
                                             gpointer klass_data)
{
#line 248 "../src/data/Emulator.vala"
	game_hub_data_emulator_installer_parent_class = g_type_class_peek_parent (klass);
#line 248 "../src/data/Emulator.vala"
	((GameHubDataRunnableInstallerClass *) klass)->finalize = game_hub_data_emulator_installer_finalize;
#line 248 "../src/data/Emulator.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataEmulatorInstaller_private_offset);
#line 248 "../src/data/Emulator.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS (klass)->get_name = game_hub_data_emulator_installer_real_get_name;
#line 3201 "Emulator.c"
}

static void
game_hub_data_emulator_installer_instance_init (GameHubDataEmulatorInstaller * self,
                                                gpointer klass)
{
#line 248 "../src/data/Emulator.vala"
	self->priv = game_hub_data_emulator_installer_get_instance_private (self);
#line 3210 "Emulator.c"
}

static void
game_hub_data_emulator_installer_finalize (GameHubDataRunnableInstaller * obj)
{
	GameHubDataEmulatorInstaller * self;
#line 248 "../src/data/Emulator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_EMULATOR_TYPE_INSTALLER, GameHubDataEmulatorInstaller);
#line 250 "../src/data/Emulator.vala"
	_g_free0 (self->priv->emu_name);
#line 248 "../src/data/Emulator.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS (game_hub_data_emulator_installer_parent_class)->finalize (obj);
#line 3223 "Emulator.c"
}

static GType
game_hub_data_emulator_installer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataEmulatorInstallerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_emulator_installer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataEmulatorInstaller), 0, (GInstanceInitFunc) game_hub_data_emulator_installer_instance_init, NULL };
	GType game_hub_data_emulator_installer_type_id;
	game_hub_data_emulator_installer_type_id = g_type_register_static (GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, "GameHubDataEmulatorInstaller", &g_define_type_info, 0);
	GameHubDataEmulatorInstaller_private_offset = g_type_add_instance_private (game_hub_data_emulator_installer_type_id, sizeof (GameHubDataEmulatorInstallerPrivate));
	return game_hub_data_emulator_installer_type_id;
}

GType
game_hub_data_emulator_installer_get_type (void)
{
	static volatile gsize game_hub_data_emulator_installer_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_emulator_installer_type_id__volatile)) {
		GType game_hub_data_emulator_installer_type_id;
		game_hub_data_emulator_installer_type_id = game_hub_data_emulator_installer_get_type_once ();
		g_once_init_leave (&game_hub_data_emulator_installer_type_id__volatile, game_hub_data_emulator_installer_type_id);
	}
	return game_hub_data_emulator_installer_type_id__volatile;
}

static void
game_hub_data_emulator_class_init (GameHubDataEmulatorClass * klass,
                                   gpointer klass_data)
{
#line 25 "../src/data/Emulator.vala"
	game_hub_data_emulator_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/data/Emulator.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataEmulator_private_offset);
#line 25 "../src/data/Emulator.vala"
	((GameHubDataRunnableClass *) klass)->save = (void (*) (GameHubDataRunnable*)) game_hub_data_emulator_real_save;
#line 25 "../src/data/Emulator.vala"
	((GameHubDataRunnableClass *) klass)->update_status = (void (*) (GameHubDataRunnable*)) game_hub_data_emulator_real_update_status;
#line 25 "../src/data/Emulator.vala"
	((GameHubDataRunnableClass *) klass)->install = (void (*) (GameHubDataRunnable*, GameHubDataRunnableInstallerInstallMode, GAsyncReadyCallback, gpointer)) game_hub_data_emulator_real_install;
#line 25 "../src/data/Emulator.vala"
	((GameHubDataRunnableClass *) klass)->install_finish = (void (*) (GameHubDataRunnable*, GAsyncResult*)) game_hub_data_emulator_install_finish;
#line 25 "../src/data/Emulator.vala"
	((GameHubDataRunnableClass *) klass)->run = (void (*) (GameHubDataRunnable*, GAsyncReadyCallback, gpointer)) game_hub_data_emulator_real_run;
#line 25 "../src/data/Emulator.vala"
	((GameHubDataRunnableClass *) klass)->run_finish = (void (*) (GameHubDataRunnable*, GAsyncResult*)) game_hub_data_emulator_run_finish;
#line 25 "../src/data/Emulator.vala"
	GAME_HUB_DATA_RUNNABLE_CLASS (klass)->get_executable = game_hub_data_emulator_real_get_executable;
#line 25 "../src/data/Emulator.vala"
	GAME_HUB_DATA_RUNNABLE_CLASS (klass)->set_executable = game_hub_data_emulator_real_set_executable;
#line 25 "../src/data/Emulator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_hub_data_emulator_get_property;
#line 25 "../src/data/Emulator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_hub_data_emulator_set_property;
#line 25 "../src/data/Emulator.vala"
	G_OBJECT_CLASS (klass)->finalize = game_hub_data_emulator_finalize;
#line 25 "../src/data/Emulator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_EMULATOR_EXECUTABLE_PROPERTY, game_hub_data_emulator_properties[GAME_HUB_DATA_EMULATOR_EXECUTABLE_PROPERTY] = g_param_spec_object ("executable", "executable", "executable", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/data/Emulator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_EMULATOR_GAME_EXECUTABLE_PATTERN_PROPERTY, game_hub_data_emulator_properties[GAME_HUB_DATA_EMULATOR_GAME_EXECUTABLE_PATTERN_PROPERTY] = g_param_spec_string ("game-executable-pattern", "game-executable-pattern", "game-executable-pattern", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/data/Emulator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_EMULATOR_GAME_IMAGE_PATTERN_PROPERTY, game_hub_data_emulator_properties[GAME_HUB_DATA_EMULATOR_GAME_IMAGE_PATTERN_PROPERTY] = g_param_spec_string ("game-image-pattern", "game-image-pattern", "game-image-pattern", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/data/Emulator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_EMULATOR_GAME_ICON_PATTERN_PROPERTY, game_hub_data_emulator_properties[GAME_HUB_DATA_EMULATOR_GAME_ICON_PATTERN_PROPERTY] = g_param_spec_string ("game-icon-pattern", "game-icon-pattern", "game-icon-pattern", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/data/Emulator.vala"
	game_hub_data_emulator_signals[GAME_HUB_DATA_EMULATOR_REMOVED_SIGNAL] = g_signal_new ("removed", GAME_HUB_DATA_TYPE_EMULATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3288 "Emulator.c"
}

static void
game_hub_data_emulator_instance_init (GameHubDataEmulator * self,
                                      gpointer klass)
{
#line 25 "../src/data/Emulator.vala"
	self->priv = game_hub_data_emulator_get_instance_private (self);
#line 27 "../src/data/Emulator.vala"
	self->priv->is_removed = FALSE;
#line 3299 "Emulator.c"
}

static void
game_hub_data_emulator_finalize (GObject * obj)
{
	GameHubDataEmulator * self;
#line 25 "../src/data/Emulator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_TYPE_EMULATOR, GameHubDataEmulator);
#line 30 "../src/data/Emulator.vala"
	_g_object_unref0 (self->priv->_executable);
#line 31 "../src/data/Emulator.vala"
	_game_hub_data_runnable_installer_unref0 (self->installer);
#line 33 "../src/data/Emulator.vala"
	_g_free0 (self->priv->_game_executable_pattern);
#line 34 "../src/data/Emulator.vala"
	_g_free0 (self->priv->_game_image_pattern);
#line 35 "../src/data/Emulator.vala"
	_g_free0 (self->priv->_game_icon_pattern);
#line 25 "../src/data/Emulator.vala"
	G_OBJECT_CLASS (game_hub_data_emulator_parent_class)->finalize (obj);
#line 3320 "Emulator.c"
}

static GType
game_hub_data_emulator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataEmulatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_emulator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataEmulator), 0, (GInstanceInitFunc) game_hub_data_emulator_instance_init, NULL };
	GType game_hub_data_emulator_type_id;
	game_hub_data_emulator_type_id = g_type_register_static (GAME_HUB_DATA_TYPE_RUNNABLE, "GameHubDataEmulator", &g_define_type_info, 0);
	GameHubDataEmulator_private_offset = g_type_add_instance_private (game_hub_data_emulator_type_id, sizeof (GameHubDataEmulatorPrivate));
	return game_hub_data_emulator_type_id;
}

GType
game_hub_data_emulator_get_type (void)
{
	static volatile gsize game_hub_data_emulator_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_emulator_type_id__volatile)) {
		GType game_hub_data_emulator_type_id;
		game_hub_data_emulator_type_id = game_hub_data_emulator_get_type_once ();
		g_once_init_leave (&game_hub_data_emulator_type_id__volatile, game_hub_data_emulator_type_id);
	}
	return game_hub_data_emulator_type_id__volatile;
}

static void
_vala_game_hub_data_emulator_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GameHubDataEmulator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_TYPE_EMULATOR, GameHubDataEmulator);
#line 25 "../src/data/Emulator.vala"
	switch (property_id) {
#line 25 "../src/data/Emulator.vala"
		case GAME_HUB_DATA_EMULATOR_EXECUTABLE_PROPERTY:
#line 25 "../src/data/Emulator.vala"
		g_value_take_object (value, game_hub_data_runnable_get_executable ((GameHubDataRunnable*) self));
#line 25 "../src/data/Emulator.vala"
		break;
#line 25 "../src/data/Emulator.vala"
		case GAME_HUB_DATA_EMULATOR_GAME_EXECUTABLE_PATTERN_PROPERTY:
#line 25 "../src/data/Emulator.vala"
		g_value_set_string (value, game_hub_data_emulator_get_game_executable_pattern (self));
#line 25 "../src/data/Emulator.vala"
		break;
#line 25 "../src/data/Emulator.vala"
		case GAME_HUB_DATA_EMULATOR_GAME_IMAGE_PATTERN_PROPERTY:
#line 25 "../src/data/Emulator.vala"
		g_value_set_string (value, game_hub_data_emulator_get_game_image_pattern (self));
#line 25 "../src/data/Emulator.vala"
		break;
#line 25 "../src/data/Emulator.vala"
		case GAME_HUB_DATA_EMULATOR_GAME_ICON_PATTERN_PROPERTY:
#line 25 "../src/data/Emulator.vala"
		g_value_set_string (value, game_hub_data_emulator_get_game_icon_pattern (self));
#line 25 "../src/data/Emulator.vala"
		break;
#line 3379 "Emulator.c"
		default:
#line 25 "../src/data/Emulator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/data/Emulator.vala"
		break;
#line 3385 "Emulator.c"
	}
}

static void
_vala_game_hub_data_emulator_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GameHubDataEmulator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_TYPE_EMULATOR, GameHubDataEmulator);
#line 25 "../src/data/Emulator.vala"
	switch (property_id) {
#line 25 "../src/data/Emulator.vala"
		case GAME_HUB_DATA_EMULATOR_EXECUTABLE_PROPERTY:
#line 25 "../src/data/Emulator.vala"
		game_hub_data_runnable_set_executable ((GameHubDataRunnable*) self, g_value_get_object (value));
#line 25 "../src/data/Emulator.vala"
		break;
#line 25 "../src/data/Emulator.vala"
		case GAME_HUB_DATA_EMULATOR_GAME_EXECUTABLE_PATTERN_PROPERTY:
#line 25 "../src/data/Emulator.vala"
		game_hub_data_emulator_set_game_executable_pattern (self, g_value_get_string (value));
#line 25 "../src/data/Emulator.vala"
		break;
#line 25 "../src/data/Emulator.vala"
		case GAME_HUB_DATA_EMULATOR_GAME_IMAGE_PATTERN_PROPERTY:
#line 25 "../src/data/Emulator.vala"
		game_hub_data_emulator_set_game_image_pattern (self, g_value_get_string (value));
#line 25 "../src/data/Emulator.vala"
		break;
#line 25 "../src/data/Emulator.vala"
		case GAME_HUB_DATA_EMULATOR_GAME_ICON_PATTERN_PROPERTY:
#line 25 "../src/data/Emulator.vala"
		game_hub_data_emulator_set_game_icon_pattern (self, g_value_get_string (value));
#line 25 "../src/data/Emulator.vala"
		break;
#line 3423 "Emulator.c"
		default:
#line 25 "../src/data/Emulator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/data/Emulator.vala"
		break;
#line 3429 "Emulator.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

