/* UserGame.c generated by valac 0.47.3, the Vala compiler
 * generated from UserGame.vala, do not modify */

/*
This file is part of GameHub.
Copyright (C) 2018-2019 Anatoliy Kashkin

GameHub is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GameHub is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GameHub.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <sqlite3.h>

#define GAME_HUB_DATA_TYPE_RUNNABLE (game_hub_data_runnable_get_type ())
#define GAME_HUB_DATA_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable))
#define GAME_HUB_DATA_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))
#define GAME_HUB_DATA_IS_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_IS_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_RUNNABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))

typedef struct _GameHubDataRunnable GameHubDataRunnable;
typedef struct _GameHubDataRunnableClass GameHubDataRunnableClass;
typedef struct _GameHubDataRunnablePrivate GameHubDataRunnablePrivate;
typedef enum  {
	GAME_HUB_DATA_PLATFORM_LINUX,
	GAME_HUB_DATA_PLATFORM_WINDOWS,
	GAME_HUB_DATA_PLATFORM_MACOS,
	GAME_HUB_DATA_PLATFORM_EMULATED
} GameHubDataPlatform;

#define GAME_HUB_DATA_TYPE_PLATFORM (game_hub_data_platform_get_type ())
typedef enum  {
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_INTERACTIVE,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC_DOWNLOAD
} GameHubDataRunnableInstallerInstallMode;

#define GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_INSTALL_MODE (game_hub_data_runnable_installer_install_mode_get_type ())

#define GAME_HUB_DATA_TYPE_GAME (game_hub_data_game_get_type ())
#define GAME_HUB_DATA_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGame))
#define GAME_HUB_DATA_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))
#define GAME_HUB_DATA_IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))

typedef struct _GameHubDataGame GameHubDataGame;
typedef struct _GameHubDataGameClass GameHubDataGameClass;
typedef struct _GameHubDataGamePrivate GameHubDataGamePrivate;

#define GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT (game_hub_data_game_achievement_get_type ())
#define GAME_HUB_DATA_GAME_ACHIEVEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, GameHubDataGameAchievement))
#define GAME_HUB_DATA_GAME_ACHIEVEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, GameHubDataGameAchievementClass))
#define GAME_HUB_DATA_GAME_IS_ACHIEVEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT))
#define GAME_HUB_DATA_GAME_IS_ACHIEVEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT))
#define GAME_HUB_DATA_GAME_ACHIEVEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, GameHubDataGameAchievementClass))

typedef struct _GameHubDataGameAchievement GameHubDataGameAchievement;
typedef struct _GameHubDataGameAchievementClass GameHubDataGameAchievementClass;

#define GAME_HUB_DATA_GAME_TYPE_STATUS (game_hub_data_game_status_get_type ())
#define GAME_HUB_DATA_GAME_STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatus))
#define GAME_HUB_DATA_GAME_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatusClass))
#define GAME_HUB_DATA_GAME_IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS))
#define GAME_HUB_DATA_GAME_IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_STATUS))
#define GAME_HUB_DATA_GAME_STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatusClass))

typedef struct _GameHubDataGameStatus GameHubDataGameStatus;
typedef struct _GameHubDataGameStatusClass GameHubDataGameStatusClass;

#define GAME_HUB_DATA_GAME_TYPE_OVERLAY (game_hub_data_game_overlay_get_type ())
#define GAME_HUB_DATA_GAME_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlay))
#define GAME_HUB_DATA_GAME_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlayClass))
#define GAME_HUB_DATA_GAME_IS_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_OVERLAY))
#define GAME_HUB_DATA_GAME_IS_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_OVERLAY))
#define GAME_HUB_DATA_GAME_OVERLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlayClass))

typedef struct _GameHubDataGameOverlay GameHubDataGameOverlay;
typedef struct _GameHubDataGameOverlayClass GameHubDataGameOverlayClass;

#define GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME (game_hub_data_sources_user_user_game_get_type ())
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, GameHubDataSourcesUserUserGame))
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, GameHubDataSourcesUserUserGameClass))
#define GAME_HUB_DATA_SOURCES_USER_IS_USER_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME))
#define GAME_HUB_DATA_SOURCES_USER_IS_USER_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME))
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, GameHubDataSourcesUserUserGameClass))

typedef struct _GameHubDataSourcesUserUserGame GameHubDataSourcesUserUserGame;
typedef struct _GameHubDataSourcesUserUserGameClass GameHubDataSourcesUserUserGameClass;
typedef struct _GameHubDataSourcesUserUserGamePrivate GameHubDataSourcesUserUserGamePrivate;

#define GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER (game_hub_data_runnable_installer_get_type ())
#define GAME_HUB_DATA_RUNNABLE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstaller))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstallerClass))
#define GAME_HUB_DATA_RUNNABLE_IS_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_IS_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstallerClass))

typedef struct _GameHubDataRunnableInstaller GameHubDataRunnableInstaller;
typedef struct _GameHubDataRunnableInstallerClass GameHubDataRunnableInstallerClass;

#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER (game_hub_data_sources_user_user_game_installer_get_type ())
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER, GameHubDataSourcesUserUserGameInstaller))
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER, GameHubDataSourcesUserUserGameInstallerClass))
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_IS_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER))
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_IS_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER))
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER, GameHubDataSourcesUserUserGameInstallerClass))

typedef struct _GameHubDataSourcesUserUserGameInstaller GameHubDataSourcesUserUserGameInstaller;
typedef struct _GameHubDataSourcesUserUserGameInstallerClass GameHubDataSourcesUserUserGameInstallerClass;
enum  {
	GAME_HUB_DATA_SOURCES_USER_USER_GAME_0_PROPERTY,
	GAME_HUB_DATA_SOURCES_USER_USER_GAME_NUM_PROPERTIES
};
static GParamSpec* game_hub_data_sources_user_user_game_properties[GAME_HUB_DATA_SOURCES_USER_USER_GAME_NUM_PROPERTIES];
#define _game_hub_data_runnable_installer_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_runnable_installer_unref (var), NULL)))

#define GAME_HUB_DATA_TYPE_GAME_SOURCE (game_hub_data_game_source_get_type ())
#define GAME_HUB_DATA_GAME_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSource))
#define GAME_HUB_DATA_GAME_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSourceClass))
#define GAME_HUB_DATA_IS_GAME_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE))
#define GAME_HUB_DATA_IS_GAME_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME_SOURCE))
#define GAME_HUB_DATA_GAME_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSourceClass))

typedef struct _GameHubDataGameSource GameHubDataGameSource;
typedef struct _GameHubDataGameSourceClass GameHubDataGameSourceClass;

#define GAME_HUB_DATA_SOURCES_USER_TYPE_USER (game_hub_data_sources_user_user_get_type ())
#define GAME_HUB_DATA_SOURCES_USER_USER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_USER_TYPE_USER, GameHubDataSourcesUserUser))
#define GAME_HUB_DATA_SOURCES_USER_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_USER_TYPE_USER, GameHubDataSourcesUserUserClass))
#define GAME_HUB_DATA_SOURCES_USER_IS_USER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_USER_TYPE_USER))
#define GAME_HUB_DATA_SOURCES_USER_IS_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_USER_TYPE_USER))
#define GAME_HUB_DATA_SOURCES_USER_USER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_USER_TYPE_USER, GameHubDataSourcesUserUserClass))

typedef struct _GameHubDataSourcesUserUser GameHubDataSourcesUserUser;
typedef struct _GameHubDataSourcesUserUserClass GameHubDataSourcesUserUserClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

#define GAME_HUB_DATA_DB_TABLE_TYPE_FIELD (game_hub_data_db_table_field_get_type ())
#define GAME_HUB_DATA_DB_TABLE_FIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD, GameHubDataDBTableField))
#define GAME_HUB_DATA_DB_TABLE_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD, GameHubDataDBTableFieldClass))
#define GAME_HUB_DATA_DB_TABLE_IS_FIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD))
#define GAME_HUB_DATA_DB_TABLE_IS_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD))
#define GAME_HUB_DATA_DB_TABLE_FIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD, GameHubDataDBTableFieldClass))

typedef struct _GameHubDataDBTableField GameHubDataDBTableField;
typedef struct _GameHubDataDBTableFieldClass GameHubDataDBTableFieldClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG (game_hub_data_db_tables_tags_tag_get_type ())
#define GAME_HUB_DATA_DB_TABLES_TAGS_TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG, GameHubDataDBTablesTagsTag))
#define GAME_HUB_DATA_DB_TABLES_TAGS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG, GameHubDataDBTablesTagsTagClass))
#define GAME_HUB_DATA_DB_TABLES_TAGS_IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG))
#define GAME_HUB_DATA_DB_TABLES_TAGS_IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG))
#define GAME_HUB_DATA_DB_TABLES_TAGS_TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG, GameHubDataDBTablesTagsTagClass))

typedef struct _GameHubDataDBTablesTagsTag GameHubDataDBTablesTagsTag;
typedef struct _GameHubDataDBTablesTagsTagClass GameHubDataDBTablesTagsTagClass;
typedef struct _GameHubDataSourcesUserUserGameUpdateGameInfoData GameHubDataSourcesUserUserGameUpdateGameInfoData;
typedef struct _Block29Data Block29Data;

#define GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG (game_hub_ui_dialogs_install_dialog_get_type ())
#define GAME_HUB_UI_DIALOGS_INSTALL_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG, GameHubUIDialogsInstallDialog))
#define GAME_HUB_UI_DIALOGS_INSTALL_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG, GameHubUIDialogsInstallDialogClass))
#define GAME_HUB_UI_DIALOGS_IS_INSTALL_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG))
#define GAME_HUB_UI_DIALOGS_IS_INSTALL_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG))
#define GAME_HUB_UI_DIALOGS_INSTALL_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG, GameHubUIDialogsInstallDialogClass))

typedef struct _GameHubUIDialogsInstallDialog GameHubUIDialogsInstallDialog;
typedef struct _GameHubUIDialogsInstallDialogClass GameHubUIDialogsInstallDialogClass;

#define GAME_HUB_DATA_TYPE_COMPAT_TOOL (game_hub_data_compat_tool_get_type ())
#define GAME_HUB_DATA_COMPAT_TOOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatTool))
#define GAME_HUB_DATA_COMPAT_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatToolClass))
#define GAME_HUB_DATA_IS_COMPAT_TOOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL))
#define GAME_HUB_DATA_IS_COMPAT_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_COMPAT_TOOL))
#define GAME_HUB_DATA_COMPAT_TOOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatToolClass))

typedef struct _GameHubDataCompatTool GameHubDataCompatTool;
typedef struct _GameHubDataCompatToolClass GameHubDataCompatToolClass;
typedef struct _Block30Data Block30Data;
typedef struct _GameHubDataSourcesUserUserGameInstallData GameHubDataSourcesUserUserGameInstallData;
typedef struct _GameHubDataSourcesUserUserGameUninstallData GameHubDataSourcesUserUserGameUninstallData;
typedef enum  {
	GAME_HUB_DATA_GAME_STATE_UNINSTALLED,
	GAME_HUB_DATA_GAME_STATE_INSTALLED,
	GAME_HUB_DATA_GAME_STATE_DOWNLOADING,
	GAME_HUB_DATA_GAME_STATE_VERIFYING_INSTALLER_INTEGRITY,
	GAME_HUB_DATA_GAME_STATE_INSTALLING
} GameHubDataGameState;

#define GAME_HUB_DATA_GAME_TYPE_STATE (game_hub_data_game_state_get_type ())

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD (game_hub_utils_downloader_download_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownload))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownloadClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownloadClass))

typedef struct _GameHubUtilsDownloaderDownload GameHubUtilsDownloaderDownload;
typedef struct _GameHubUtilsDownloaderDownloadClass GameHubUtilsDownloaderDownloadClass;
#define _game_hub_data_game_status_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_game_status_unref (var), NULL)))
typedef struct _GameHubDataGameStatusPrivate GameHubDataGameStatusPrivate;
typedef struct _GameHubDataRunnableInstallerPrivate GameHubDataRunnableInstallerPrivate;
typedef struct _GameHubDataSourcesUserUserGameInstallerPrivate GameHubDataSourcesUserUserGameInstallerPrivate;

#define GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART (game_hub_data_runnable_installer_part_get_type ())
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_PART(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, GameHubDataRunnableInstallerPart))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, GameHubDataRunnableInstallerPartClass))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_IS_PART(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_IS_PART_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, GameHubDataRunnableInstallerPartClass))

typedef struct _GameHubDataRunnableInstallerPart GameHubDataRunnableInstallerPart;
typedef struct _GameHubDataRunnableInstallerPartClass GameHubDataRunnableInstallerPartClass;
enum  {
	GAME_HUB_DATA_SOURCES_USER_USER_GAME_REMOVED_SIGNAL,
	GAME_HUB_DATA_SOURCES_USER_USER_GAME_NUM_SIGNALS
};
static guint game_hub_data_sources_user_user_game_signals[GAME_HUB_DATA_SOURCES_USER_USER_GAME_NUM_SIGNALS] = {0};

struct _GameHubDataRunnable {
	GObject parent_instance;
	GameHubDataRunnablePrivate * priv;
};

struct _GameHubDataRunnableClass {
	GObjectClass parent_class;
	gboolean (*is_supported) (GameHubDataRunnable* self, GameHubDataPlatform* platform, gboolean with_compat);
	void (*install) (GameHubDataRunnable* self, GameHubDataRunnableInstallerInstallMode install_mode, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*install_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	void (*run) (GameHubDataRunnable* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	gboolean (*can_be_launched) (GameHubDataRunnable* self, gboolean is_launch_attempt);
	void (*run_with_compat) (GameHubDataRunnable* self, gboolean is_opened_from_menu, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_with_compat_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	GtkFileChooser* (*setup_executable_chooser) (GameHubDataRunnable* self);
	void (*choose_executable) (GameHubDataRunnable* self, gboolean update);
	void (*set_chosen_executable) (GameHubDataRunnable* self, GFile* file, gboolean update);
	void (*save) (GameHubDataRunnable* self);
	void (*update_status) (GameHubDataRunnable* self);
	void (*import) (GameHubDataRunnable* self, gboolean update);
	GFile* (*get_executable) (GameHubDataRunnable* self);
	void (*set_executable) (GameHubDataRunnable* self, GFile* value);
	GFile* (*get_default_install_dir) (GameHubDataRunnable* self);
};

struct _GameHubDataGame {
	GameHubDataRunnable parent_instance;
	GameHubDataGamePrivate * priv;
	GameHubDataGameStatus* _status;
	GeeArrayList* overlays;
	gchar* executable_path;
};

struct _GameHubDataGameClass {
	GameHubDataRunnableClass parent_class;
	void (*uninstall) (GameHubDataGame* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*uninstall_finish) (GameHubDataGame* self, GAsyncResult* _res_);
	void (*update_game_info) (GameHubDataGame* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*update_game_info_finish) (GameHubDataGame* self, GAsyncResult* _res_);
	void (*load_achievements) (GameHubDataGame* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeArrayList* (*load_achievements_finish) (GameHubDataGame* self, GAsyncResult* _res_);
};

struct _GameHubDataSourcesUserUserGame {
	GameHubDataGame parent_instance;
	GameHubDataSourcesUserUserGamePrivate * priv;
};

struct _GameHubDataSourcesUserUserGameClass {
	GameHubDataGameClass parent_class;
};

struct _GameHubDataSourcesUserUserGamePrivate {
	gboolean is_removed;
	GameHubDataSourcesUserUserGameInstaller* installer;
};

struct _GameHubDataSourcesUserUserGameUpdateGameInfoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesUserUserGame* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GameHubDataSourcesUserUserGameInstaller* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	JsonObject* i;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	JsonNode* _tmp11_;
	JsonNode* _tmp12_;
	JsonObject* _tmp13_;
	JsonObject* _tmp14_;
	JsonObject* _tmp15_;
	JsonObject* _tmp16_;
	const gchar* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	GameHubDataSourcesUserUserGameInstaller* _tmp20_;
};

struct _Block29Data {
	int _ref_count_;
	GameHubDataSourcesUserUserGame* self;
	gpointer _async_data_;
};

struct _Block30Data {
	int _ref_count_;
	Block29Data * _data29_;
	GameHubDataRunnableInstaller* installer;
};

struct _GameHubDataSourcesUserUserGameInstallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesUserUserGame* self;
	GameHubDataRunnableInstallerInstallMode install_mode;
	Block29Data* _data29_;
	GameHubDataSourcesUserUserGameInstaller* _tmp0_;
	GeeArrayList* installers;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GameHubDataSourcesUserUserGameInstaller* _tmp3_;
	GameHubUIDialogsInstallDialog* wnd;
	GeeArrayList* _tmp4_;
	GameHubUIDialogsInstallDialog* _tmp5_;
	GameHubUIDialogsInstallDialog* _tmp6_;
	GameHubUIDialogsInstallDialog* _tmp7_;
	GameHubUIDialogsInstallDialog* _tmp8_;
	GameHubUIDialogsInstallDialog* _tmp9_;
};

struct _GameHubDataSourcesUserUserGameUninstallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesUserUserGame* self;
};

struct _GameHubDataGameStatus {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataGameStatusPrivate * priv;
	GameHubDataGameState state;
	GameHubDataGame* game;
	GameHubUtilsDownloaderDownload* download;
};

struct _GameHubDataGameStatusClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataGameStatus *self);
};

struct _GameHubDataRunnableInstaller {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataRunnableInstallerPrivate * priv;
};

struct _GameHubDataRunnableInstallerClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataRunnableInstaller *self);
	void (*fetch_parts) (GameHubDataRunnableInstaller* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*fetch_parts_finish) (GameHubDataRunnableInstaller* self, GAsyncResult* _res_);
	gchar* (*get_name) (GameHubDataRunnableInstaller* self);
};

struct _GameHubDataSourcesUserUserGameInstaller {
	GameHubDataRunnableInstaller parent_instance;
	GameHubDataSourcesUserUserGameInstallerPrivate * priv;
};

struct _GameHubDataSourcesUserUserGameInstallerClass {
	GameHubDataRunnableInstallerClass parent_class;
};

struct _GameHubDataSourcesUserUserGameInstallerPrivate {
	gchar* game_name;
};

static gint GameHubDataSourcesUserUserGame_private_offset;
static gpointer game_hub_data_sources_user_user_game_parent_class = NULL;
extern GameHubDataSourcesUserUser* game_hub_data_sources_user_user_instance;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_ID;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_NAME;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_INFO;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_INFO_DETAILED;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_ICON;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_IMAGE;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_INSTALL_PATH;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_EXECUTABLE;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_COMPAT_TOOL;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_COMPAT_TOOL_SETTINGS;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_ARGUMENTS;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_LAST_LAUNCH;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_PLAYTIME_SOURCE;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_PLAYTIME_TRACKED;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_IMAGE_VERTICAL;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_PLATFORMS;
extern GameHubDataDBTableField* game_hub_data_db_tables_games_TAGS;
extern GeeArrayList* game_hub_data_db_tables_tags_TAGS;
extern GameHubDataDBTablesTagsTag* game_hub_data_db_tables_tags_BUILTIN_UNINSTALLED;
extern GameHubDataDBTablesTagsTag* game_hub_data_db_tables_tags_BUILTIN_INSTALLED;
static gint GameHubDataSourcesUserUserGameInstaller_private_offset;
static gpointer game_hub_data_sources_user_user_game_installer_parent_class = NULL;

GType game_hub_data_runnable_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnable, g_object_unref)
GType game_hub_data_platform_get_type (void) G_GNUC_CONST;
GType game_hub_data_runnable_installer_install_mode_get_type (void) G_GNUC_CONST;
GType game_hub_data_game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGame, g_object_unref)
gpointer game_hub_data_game_achievement_ref (gpointer instance);
void game_hub_data_game_achievement_unref (gpointer instance);
GParamSpec* game_hub_data_game_param_spec_achievement (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags);
void game_hub_data_game_value_set_achievement (GValue* value,
                                               gpointer v_object);
void game_hub_data_game_value_take_achievement (GValue* value,
                                                gpointer v_object);
gpointer game_hub_data_game_value_get_achievement (const GValue* value);
GType game_hub_data_game_achievement_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameAchievement, game_hub_data_game_achievement_unref)
gpointer game_hub_data_game_status_ref (gpointer instance);
void game_hub_data_game_status_unref (gpointer instance);
GParamSpec* game_hub_data_game_param_spec_status (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
void game_hub_data_game_value_set_status (GValue* value,
                                          gpointer v_object);
void game_hub_data_game_value_take_status (GValue* value,
                                           gpointer v_object);
gpointer game_hub_data_game_value_get_status (const GValue* value);
GType game_hub_data_game_status_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameStatus, game_hub_data_game_status_unref)
GType game_hub_data_game_overlay_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameOverlay, g_object_unref)
GType game_hub_data_sources_user_user_game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesUserUserGame, g_object_unref)
gpointer game_hub_data_runnable_installer_ref (gpointer instance);
void game_hub_data_runnable_installer_unref (gpointer instance);
GParamSpec* game_hub_data_runnable_param_spec_installer (const gchar* name,
                                                         const gchar* nick,
                                                         const gchar* blurb,
                                                         GType object_type,
                                                         GParamFlags flags);
void game_hub_data_runnable_value_set_installer (GValue* value,
                                                 gpointer v_object);
void game_hub_data_runnable_value_take_installer (GValue* value,
                                                  gpointer v_object);
gpointer game_hub_data_runnable_value_get_installer (const GValue* value);
GType game_hub_data_runnable_installer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableInstaller, game_hub_data_runnable_installer_unref)
GType game_hub_data_sources_user_user_game_installer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesUserUserGameInstaller, game_hub_data_runnable_installer_unref)
GameHubDataSourcesUserUserGame* game_hub_data_sources_user_user_game_new (const gchar* name,
                                                                          GFile* dir,
                                                                          GFile* exec,
                                                                          const gchar* args,
                                                                          gboolean is_installer);
GameHubDataSourcesUserUserGame* game_hub_data_sources_user_user_game_construct (GType object_type,
                                                                                const gchar* name,
                                                                                GFile* dir,
                                                                                GFile* exec,
                                                                                const gchar* args,
                                                                                gboolean is_installer);
GameHubDataGame* game_hub_data_game_construct (GType object_type);
gpointer game_hub_data_game_source_ref (gpointer instance);
void game_hub_data_game_source_unref (gpointer instance);
GParamSpec* game_hub_data_param_spec_game_source (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
void game_hub_data_value_set_game_source (GValue* value,
                                          gpointer v_object);
void game_hub_data_value_take_game_source (GValue* value,
                                           gpointer v_object);
gpointer game_hub_data_value_get_game_source (const GValue* value);
GType game_hub_data_game_source_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameSource, game_hub_data_game_source_unref)
GType game_hub_data_sources_user_user_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesUserUser, game_hub_data_game_source_unref)
void game_hub_data_game_set_source (GameHubDataGame* self,
                                    GameHubDataGameSource* value);
gchar* game_hub_utils_md5 (const gchar* s);
void game_hub_data_runnable_set_id (GameHubDataRunnable* self,
                                    const gchar* value);
void game_hub_data_runnable_set_name (GameHubDataRunnable* self,
                                      const gchar* value);
GeeArrayList* game_hub_data_runnable_get_platforms (GameHubDataRunnable* self);
void game_hub_data_runnable_set_install_dir (GameHubDataRunnable* self,
                                             GFile* value);
void game_hub_data_runnable_set_arguments (GameHubDataRunnable* self,
                                           const gchar* value);
void game_hub_data_runnable_set_executable (GameHubDataRunnable* self,
                                            GFile* value);
GameHubDataSourcesUserUserGameInstaller* game_hub_data_sources_user_user_game_installer_new (GameHubDataSourcesUserUserGame* game,
                                                                                             GFile* installer);
GameHubDataSourcesUserUserGameInstaller* game_hub_data_sources_user_user_game_installer_construct (GType object_type,
                                                                                                   GameHubDataSourcesUserUserGame* game,
                                                                                                   GFile* installer);
void game_hub_data_game_set_info (GameHubDataGame* self,
                                  const gchar* value);
void game_hub_data_runnable_save (GameHubDataRunnable* self);
static void _vala_JsonNode_free (JsonNode* self);
GameHubDataGameSource* game_hub_data_game_get_source (GameHubDataGame* self);
void game_hub_data_sources_user_user_add_game (GameHubDataSourcesUserUser* self,
                                               GameHubDataSourcesUserUserGame* game);
void game_hub_data_game_mount_overlays (GameHubDataGame* self,
                                        GFile* persist,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
void game_hub_data_game_mount_overlays_finish (GameHubDataGame* self,
                                               GAsyncResult* _res_);
void game_hub_data_runnable_update_status (GameHubDataRunnable* self);
GameHubDataSourcesUserUserGame* game_hub_data_sources_user_user_game_new_from_db (GameHubDataSourcesUserUser* src,
                                                                                  sqlite3_stmt* s);
GameHubDataSourcesUserUserGame* game_hub_data_sources_user_user_game_construct_from_db (GType object_type,
                                                                                        GameHubDataSourcesUserUser* src,
                                                                                        sqlite3_stmt* s);
gpointer game_hub_data_db_table_field_ref (gpointer instance);
void game_hub_data_db_table_field_unref (gpointer instance);
GParamSpec* game_hub_data_db_table_param_spec_field (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
void game_hub_data_db_table_value_set_field (GValue* value,
                                             gpointer v_object);
void game_hub_data_db_table_value_take_field (GValue* value,
                                              gpointer v_object);
gpointer game_hub_data_db_table_value_get_field (const GValue* value);
GType game_hub_data_db_table_field_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataDBTableField, game_hub_data_db_table_field_unref)
gchar* game_hub_data_db_table_field_get (GameHubDataDBTableField* self,
                                         sqlite3_stmt* s);
void game_hub_data_game_set_info_detailed (GameHubDataGame* self,
                                           const gchar* value);
void game_hub_data_game_set_icon (GameHubDataGame* self,
                                  const gchar* value);
void game_hub_data_game_set_image (GameHubDataGame* self,
                                   const gchar* value);
GFile* game_hub_utils_fs_utils_file (const gchar* path,
                                     const gchar* file,
                                     GeeHashMap* variables);
void game_hub_data_runnable_set_compat_tool (GameHubDataRunnable* self,
                                             const gchar* value);
void game_hub_data_runnable_set_compat_tool_settings (GameHubDataRunnable* self,
                                                      const gchar* value);
gint64 game_hub_data_db_table_field_get_int64 (GameHubDataDBTableField* self,
                                               sqlite3_stmt* s);
void game_hub_data_game_set_last_launch (GameHubDataGame* self,
                                         gint64 value);
void game_hub_data_game_set_playtime_source (GameHubDataGame* self,
                                             gint64 value);
void game_hub_data_game_set_playtime_tracked (GameHubDataGame* self,
                                              gint64 value);
void game_hub_data_game_set_image_vertical (GameHubDataGame* self,
                                            const gchar* value);
gchar* game_hub_data_platform_id (GameHubDataPlatform self);
GType game_hub_data_db_tables_tags_tag_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataDBTablesTagsTag, g_object_unref)
GeeArrayList* game_hub_data_game_get_tags (GameHubDataGame* self);
const gchar* game_hub_data_db_tables_tags_tag_get_id (GameHubDataDBTablesTagsTag* self);
static void game_hub_data_sources_user_user_game_real_update_game_info_data_free (gpointer _data);
static void game_hub_data_sources_user_user_game_real_update_game_info (GameHubDataGame* base,
                                                                 GAsyncReadyCallback _callback_,
                                                                 gpointer _user_data_);
static gboolean game_hub_data_sources_user_user_game_real_update_game_info_co (GameHubDataSourcesUserUserGameUpdateGameInfoData* _data_);
static void game_hub_data_sources_user_user_game_update_game_info_ready (GObject* source_object,
                                                                  GAsyncResult* _res_,
                                                                  gpointer _user_data_);
const gchar* game_hub_data_game_get_info (GameHubDataGame* self);
JsonNode* game_hub_utils_parser_parse_json (const gchar* json);
static void game_hub_data_sources_user_user_game_real_install_data_free (gpointer _data);
static void game_hub_data_sources_user_user_game_real_install (GameHubDataRunnable* base,
                                                        GameHubDataRunnableInstallerInstallMode install_mode,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
static gboolean game_hub_data_sources_user_user_game_real_install_co (GameHubDataSourcesUserUserGameInstallData* _data_);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
void game_hub_data_game_update_game_info (GameHubDataGame* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
void game_hub_data_game_update_game_info_finish (GameHubDataGame* self,
                                                 GAsyncResult* _res_);
static void game_hub_data_sources_user_user_game_install_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
GType game_hub_ui_dialogs_install_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUIDialogsInstallDialog, g_object_unref)
GameHubUIDialogsInstallDialog* game_hub_ui_dialogs_install_dialog_new (GameHubDataRunnable* runnable,
                                                                       GeeArrayList* installers,
                                                                       GameHubDataRunnableInstallerInstallMode install_mode);
GameHubUIDialogsInstallDialog* game_hub_ui_dialogs_install_dialog_construct (GType object_type,
                                                                             GameHubDataRunnable* runnable,
                                                                             GeeArrayList* installers,
                                                                             GameHubDataRunnableInstallerInstallMode install_mode);
static void __lambda48_ (Block29Data* _data29_);
void game_hub_data_runnable_install (GameHubDataRunnable* self,
                                     GameHubDataRunnableInstallerInstallMode install_mode,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
void game_hub_data_runnable_install_finish (GameHubDataRunnable* self,
                                            GAsyncResult* _res_);
static gboolean _game_hub_data_sources_user_user_game_real_install_co_gsource_func (gpointer self);
static void ___lambda48__game_hub_ui_dialogs_install_dialog_cancelled (GameHubUIDialogsInstallDialog* _sender,
                                                                gpointer self);
GType game_hub_data_compat_tool_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataCompatTool, g_object_unref)
static void __lambda49_ (Block29Data* _data29_,
                  GameHubDataRunnableInstaller* installer,
                  gboolean dl_only,
                  GameHubDataCompatTool* tool);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
void game_hub_data_runnable_installer_install (GameHubDataRunnableInstaller* self,
                                               GameHubDataRunnable* runnable,
                                               gboolean dl_only,
                                               GameHubDataCompatTool* tool,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
void game_hub_data_runnable_installer_install_finish (GameHubDataRunnableInstaller* self,
                                                      GAsyncResult* _res_);
static void __lambda50_ (Block30Data* _data30_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda50__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void ___lambda49__game_hub_ui_dialogs_install_dialog_install (GameHubUIDialogsInstallDialog* _sender,
                                                              GameHubDataRunnableInstaller* installer,
                                                              gboolean dl_only,
                                                              GameHubDataCompatTool* tool,
                                                              gpointer self);
static void game_hub_data_sources_user_user_game_real_uninstall_data_free (gpointer _data);
static void game_hub_data_sources_user_user_game_real_uninstall (GameHubDataGame* base,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static gboolean game_hub_data_sources_user_user_game_real_uninstall_co (GameHubDataSourcesUserUserGameUninstallData* _data_);
void game_hub_data_game_umount_overlays (GameHubDataGame* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
void game_hub_data_game_umount_overlays_finish (GameHubDataGame* self,
                                                GAsyncResult* _res_);
static void game_hub_data_sources_user_user_game_uninstall_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
void game_hub_data_sources_user_user_game_remove (GameHubDataSourcesUserUserGame* self);
void game_hub_data_sources_user_user_remove_game (GameHubDataSourcesUserUser* self,
                                                  GameHubDataSourcesUserUserGame* game);
static void game_hub_data_sources_user_user_game_real_save (GameHubDataRunnable* base);
static void game_hub_data_sources_user_user_game_real_update_status (GameHubDataRunnable* base);
GFile* game_hub_data_runnable_get_executable (GameHubDataRunnable* self);
GType game_hub_data_game_state_get_type (void) G_GNUC_CONST;
gpointer game_hub_utils_downloader_download_ref (gpointer instance);
void game_hub_utils_downloader_download_unref (gpointer instance);
GParamSpec* game_hub_utils_downloader_param_spec_download (const gchar* name,
                                                           const gchar* nick,
                                                           const gchar* blurb,
                                                           GType object_type,
                                                           GParamFlags flags);
void game_hub_utils_downloader_value_set_download (GValue* value,
                                                   gpointer v_object);
void game_hub_utils_downloader_value_take_download (GValue* value,
                                                    gpointer v_object);
gpointer game_hub_utils_downloader_value_get_download (const GValue* value);
GType game_hub_utils_downloader_download_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderDownload, game_hub_utils_downloader_download_unref)
GameHubDataGameStatus* game_hub_data_game_status_new (GameHubDataGameState state,
                                                      GameHubDataGame* game,
                                                      GameHubUtilsDownloaderDownload* download);
GameHubDataGameStatus* game_hub_data_game_status_construct (GType object_type,
                                                            GameHubDataGameState state,
                                                            GameHubDataGame* game,
                                                            GameHubUtilsDownloaderDownload* download);
void game_hub_data_game_set_status (GameHubDataGame* self,
                                    GameHubDataGameStatus* value);
GameHubDataGameStatus* game_hub_data_game_get_status (GameHubDataGame* self);
void game_hub_data_game_remove_tag (GameHubDataGame* self,
                                    GameHubDataDBTablesTagsTag* tag);
void game_hub_data_game_add_tag (GameHubDataGame* self,
                                 GameHubDataDBTablesTagsTag* tag);
GameHubDataRunnableInstaller* game_hub_data_runnable_installer_construct (GType object_type);
const gchar* game_hub_data_runnable_get_name (GameHubDataRunnable* self);
void game_hub_data_runnable_installer_set_id (GameHubDataRunnableInstaller* self,
                                              const gchar* value);
void game_hub_data_runnable_installer_set_platform (GameHubDataRunnableInstaller* self,
                                                    GameHubDataPlatform value);
GType game_hub_data_runnable_installer_part_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableInstallerPart, g_object_unref)
GeeArrayList* game_hub_data_runnable_installer_get_parts (GameHubDataRunnableInstaller* self);
gint64 game_hub_data_runnable_installer_get_full_size (GameHubDataRunnableInstaller* self);
GameHubDataRunnableInstallerPart* game_hub_data_runnable_installer_part_new (const gchar* id,
                                                                             const gchar* url,
                                                                             gint64 size,
                                                                             GFile* remote,
                                                                             GFile* local,
                                                                             const gchar* checksum,
                                                                             GChecksumType checksum_type);
GameHubDataRunnableInstallerPart* game_hub_data_runnable_installer_part_construct (GType object_type,
                                                                                   const gchar* id,
                                                                                   const gchar* url,
                                                                                   gint64 size,
                                                                                   GFile* remote,
                                                                                   GFile* local,
                                                                                   const gchar* checksum,
                                                                                   GChecksumType checksum_type);
static void game_hub_data_sources_user_user_game_installer_finalize (GameHubDataRunnableInstaller * obj);
static GType game_hub_data_sources_user_user_game_installer_get_type_once (void);
static void game_hub_data_sources_user_user_game_finalize (GObject * obj);
static GType game_hub_data_sources_user_user_game_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

extern const GameHubDataPlatform GAME_HUB_DATA_PLATFORM_PLATFORMS[4];

static inline gpointer
game_hub_data_sources_user_user_game_get_instance_private (GameHubDataSourcesUserUserGame* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataSourcesUserUserGame_private_offset);
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 48 "../src/data/sources/user/UserGame.vala"
	g_boxed_free (json_node_get_type (), self);
#line 775 "UserGame.c"
}

GameHubDataSourcesUserUserGame*
game_hub_data_sources_user_user_game_construct (GType object_type,
                                                const gchar* name,
                                                GFile* dir,
                                                GFile* exec,
                                                const gchar* args,
                                                gboolean is_installer)
{
	GameHubDataSourcesUserUserGame * self = NULL;
	GameHubDataSourcesUserUser* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GeeArrayList* _tmp7_;
	GeeArrayList* _tmp8_;
	gchar* path = NULL;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GameHubDataPlatform _tmp13_ = 0;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	const gchar* _tmp16_;
	GeeArrayList* _tmp19_;
	GeeArrayList* _tmp20_;
	GameHubDataGameSource* _tmp32_;
	GameHubDataGameSource* _tmp33_;
#line 32 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 32 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 32 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (exec != NULL, NULL);
#line 32 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (args != NULL, NULL);
#line 32 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) game_hub_data_game_construct (object_type);
#line 34 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = game_hub_data_sources_user_user_instance;
#line 34 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_source ((GameHubDataGame*) self, (GameHubDataGameSource*) _tmp0_);
#line 36 "../src/data/sources/user/UserGame.vala"
	_tmp1_ = g_strdup_printf ("%u", g_random_int ());
#line 36 "../src/data/sources/user/UserGame.vala"
	_tmp2_ = _tmp1_;
#line 36 "../src/data/sources/user/UserGame.vala"
	_tmp3_ = g_strconcat (name, _tmp2_, NULL);
#line 36 "../src/data/sources/user/UserGame.vala"
	_tmp4_ = _tmp3_;
#line 36 "../src/data/sources/user/UserGame.vala"
	_tmp5_ = game_hub_utils_md5 (_tmp4_);
#line 36 "../src/data/sources/user/UserGame.vala"
	_tmp6_ = _tmp5_;
#line 36 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_id ((GameHubDataRunnable*) self, _tmp6_);
#line 36 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp6_);
#line 36 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp4_);
#line 36 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp2_);
#line 37 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_name ((GameHubDataRunnable*) self, name);
#line 39 "../src/data/sources/user/UserGame.vala"
	_tmp7_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 39 "../src/data/sources/user/UserGame.vala"
	_tmp8_ = _tmp7_;
#line 39 "../src/data/sources/user/UserGame.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp8_);
#line 41 "../src/data/sources/user/UserGame.vala"
	_tmp9_ = g_file_get_path (exec);
#line 41 "../src/data/sources/user/UserGame.vala"
	_tmp10_ = _tmp9_;
#line 41 "../src/data/sources/user/UserGame.vala"
	_tmp11_ = g_utf8_strdown (_tmp10_, (gssize) -1);
#line 41 "../src/data/sources/user/UserGame.vala"
	_tmp12_ = _tmp11_;
#line 41 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp10_);
#line 41 "../src/data/sources/user/UserGame.vala"
	path = _tmp12_;
#line 42 "../src/data/sources/user/UserGame.vala"
	_tmp16_ = path;
#line 42 "../src/data/sources/user/UserGame.vala"
	if (g_str_has_suffix (_tmp16_, ".exe")) {
#line 42 "../src/data/sources/user/UserGame.vala"
		_tmp15_ = TRUE;
#line 869 "UserGame.c"
	} else {
		const gchar* _tmp17_;
#line 42 "../src/data/sources/user/UserGame.vala"
		_tmp17_ = path;
#line 42 "../src/data/sources/user/UserGame.vala"
		_tmp15_ = g_str_has_suffix (_tmp17_, ".bat");
#line 876 "UserGame.c"
	}
#line 42 "../src/data/sources/user/UserGame.vala"
	if (_tmp15_) {
#line 42 "../src/data/sources/user/UserGame.vala"
		_tmp14_ = TRUE;
#line 882 "UserGame.c"
	} else {
		const gchar* _tmp18_;
#line 42 "../src/data/sources/user/UserGame.vala"
		_tmp18_ = path;
#line 42 "../src/data/sources/user/UserGame.vala"
		_tmp14_ = g_str_has_suffix (_tmp18_, ".com");
#line 889 "UserGame.c"
	}
#line 42 "../src/data/sources/user/UserGame.vala"
	if (_tmp14_) {
#line 42 "../src/data/sources/user/UserGame.vala"
		_tmp13_ = GAME_HUB_DATA_PLATFORM_WINDOWS;
#line 895 "UserGame.c"
	} else {
#line 42 "../src/data/sources/user/UserGame.vala"
		_tmp13_ = GAME_HUB_DATA_PLATFORM_LINUX;
#line 899 "UserGame.c"
	}
#line 42 "../src/data/sources/user/UserGame.vala"
	_tmp19_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 42 "../src/data/sources/user/UserGame.vala"
	_tmp20_ = _tmp19_;
#line 42 "../src/data/sources/user/UserGame.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, (gpointer) ((gintptr) _tmp13_));
#line 44 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_install_dir ((GameHubDataRunnable*) self, dir);
#line 46 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_arguments ((GameHubDataRunnable*) self, args);
#line 48 "../src/data/sources/user/UserGame.vala"
	if (!is_installer) {
#line 50 "../src/data/sources/user/UserGame.vala"
		game_hub_data_runnable_set_executable ((GameHubDataRunnable*) self, exec);
#line 915 "UserGame.c"
	} else {
		GameHubDataSourcesUserUserGameInstaller* _tmp21_;
		JsonObject* root_object = NULL;
		JsonObject* _tmp22_;
		JsonObject* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		JsonNode* root_node = NULL;
		JsonNode* _tmp26_;
		JsonNode* _tmp27_;
		JsonObject* _tmp28_;
		JsonNode* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
#line 54 "../src/data/sources/user/UserGame.vala"
		_tmp21_ = game_hub_data_sources_user_user_game_installer_new (self, exec);
#line 54 "../src/data/sources/user/UserGame.vala"
		_game_hub_data_runnable_installer_unref0 (self->priv->installer);
#line 54 "../src/data/sources/user/UserGame.vala"
		self->priv->installer = _tmp21_;
#line 55 "../src/data/sources/user/UserGame.vala"
		_tmp22_ = json_object_new ();
#line 55 "../src/data/sources/user/UserGame.vala"
		root_object = _tmp22_;
#line 56 "../src/data/sources/user/UserGame.vala"
		_tmp23_ = root_object;
#line 56 "../src/data/sources/user/UserGame.vala"
		_tmp24_ = g_file_get_path (exec);
#line 56 "../src/data/sources/user/UserGame.vala"
		_tmp25_ = _tmp24_;
#line 56 "../src/data/sources/user/UserGame.vala"
		json_object_set_string_member (_tmp23_, "installer", _tmp25_);
#line 56 "../src/data/sources/user/UserGame.vala"
		_g_free0 (_tmp25_);
#line 57 "../src/data/sources/user/UserGame.vala"
		_tmp26_ = json_node_new (JSON_NODE_OBJECT);
#line 57 "../src/data/sources/user/UserGame.vala"
		root_node = _tmp26_;
#line 58 "../src/data/sources/user/UserGame.vala"
		_tmp27_ = root_node;
#line 58 "../src/data/sources/user/UserGame.vala"
		_tmp28_ = root_object;
#line 58 "../src/data/sources/user/UserGame.vala"
		json_node_set_object (_tmp27_, _tmp28_);
#line 59 "../src/data/sources/user/UserGame.vala"
		_tmp29_ = root_node;
#line 59 "../src/data/sources/user/UserGame.vala"
		_tmp30_ = json_to_string (_tmp29_, FALSE);
#line 59 "../src/data/sources/user/UserGame.vala"
		_tmp31_ = _tmp30_;
#line 59 "../src/data/sources/user/UserGame.vala"
		game_hub_data_game_set_info ((GameHubDataGame*) self, _tmp31_);
#line 59 "../src/data/sources/user/UserGame.vala"
		_g_free0 (_tmp31_);
#line 60 "../src/data/sources/user/UserGame.vala"
		game_hub_data_runnable_save ((GameHubDataRunnable*) self);
#line 48 "../src/data/sources/user/UserGame.vala"
		__vala_JsonNode_free0 (root_node);
#line 48 "../src/data/sources/user/UserGame.vala"
		_json_object_unref0 (root_object);
#line 976 "UserGame.c"
	}
#line 63 "../src/data/sources/user/UserGame.vala"
	_tmp32_ = game_hub_data_game_get_source ((GameHubDataGame*) self);
#line 63 "../src/data/sources/user/UserGame.vala"
	_tmp33_ = _tmp32_;
#line 63 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_add_game (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GAME_HUB_DATA_SOURCES_USER_TYPE_USER, GameHubDataSourcesUserUser), self);
#line 65 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_mount_overlays ((GameHubDataGame*) self, NULL, NULL, NULL);
#line 66 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) self);
#line 32 "../src/data/sources/user/UserGame.vala"
	_g_free0 (path);
#line 32 "../src/data/sources/user/UserGame.vala"
	return self;
#line 992 "UserGame.c"
}

GameHubDataSourcesUserUserGame*
game_hub_data_sources_user_user_game_new (const gchar* name,
                                          GFile* dir,
                                          GFile* exec,
                                          const gchar* args,
                                          gboolean is_installer)
{
#line 32 "../src/data/sources/user/UserGame.vala"
	return game_hub_data_sources_user_user_game_construct (GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, name, dir, exec, args, is_installer);
#line 1004 "UserGame.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 106 "../src/data/sources/user/UserGame.vala"
	return self ? g_object_ref (self) : NULL;
#line 1012 "UserGame.c"
}

GameHubDataSourcesUserUserGame*
game_hub_data_sources_user_user_game_construct_from_db (GType object_type,
                                                        GameHubDataSourcesUserUser* src,
                                                        sqlite3_stmt* s)
{
	GameHubDataSourcesUserUserGame * self = NULL;
	GameHubDataDBTableField* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GameHubDataDBTableField* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GameHubDataDBTableField* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GameHubDataDBTableField* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GameHubDataDBTableField* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GameHubDataDBTableField* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GameHubDataDBTableField* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GFile* _tmp21_;
	GFile* _tmp22_;
	GameHubDataDBTableField* _tmp23_;
	gchar* _tmp24_;
	GameHubDataDBTableField* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GameHubDataDBTableField* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GameHubDataDBTableField* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GameHubDataDBTableField* _tmp34_;
	GameHubDataDBTableField* _tmp35_;
	GameHubDataDBTableField* _tmp36_;
	GameHubDataDBTableField* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	GeeArrayList* _tmp40_;
	GeeArrayList* _tmp41_;
	gchar** pls = NULL;
	GameHubDataDBTableField* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar** _tmp45_;
	gchar** _tmp46_;
	gchar** _tmp47_;
	gint _tmp47__length1;
	gint pls_length1;
	gint _pls_size_;
	gchar** _tmp48_;
	gint _tmp48__length1;
	GeeArrayList* _tmp58_;
	GeeArrayList* _tmp59_;
	gchar* _tmp60_ = NULL;
	GameHubDataDBTableField* _tmp61_;
	gchar* _tmp62_;
	gchar** tag_ids = NULL;
	gchar** _tmp64_;
	gchar** _tmp65_;
	gint tag_ids_length1;
	gint _tag_ids_size_;
	gchar** _tmp66_;
	gint _tmp66__length1;
#line 69 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (src != NULL, NULL);
#line 69 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 69 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) game_hub_data_game_construct (object_type);
#line 71 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_source ((GameHubDataGame*) self, (GameHubDataGameSource*) src);
#line 72 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = game_hub_data_db_tables_games_ID;
#line 72 "../src/data/sources/user/UserGame.vala"
	_tmp1_ = game_hub_data_db_table_field_get (_tmp0_, s);
#line 72 "../src/data/sources/user/UserGame.vala"
	_tmp2_ = _tmp1_;
#line 72 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_id ((GameHubDataRunnable*) self, _tmp2_);
#line 72 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp2_);
#line 73 "../src/data/sources/user/UserGame.vala"
	_tmp3_ = game_hub_data_db_tables_games_NAME;
#line 73 "../src/data/sources/user/UserGame.vala"
	_tmp4_ = game_hub_data_db_table_field_get (_tmp3_, s);
#line 73 "../src/data/sources/user/UserGame.vala"
	_tmp5_ = _tmp4_;
#line 73 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_name ((GameHubDataRunnable*) self, _tmp5_);
#line 73 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp5_);
#line 74 "../src/data/sources/user/UserGame.vala"
	_tmp6_ = game_hub_data_db_tables_games_INFO;
#line 74 "../src/data/sources/user/UserGame.vala"
	_tmp7_ = game_hub_data_db_table_field_get (_tmp6_, s);
#line 74 "../src/data/sources/user/UserGame.vala"
	_tmp8_ = _tmp7_;
#line 74 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_info ((GameHubDataGame*) self, _tmp8_);
#line 74 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp8_);
#line 75 "../src/data/sources/user/UserGame.vala"
	_tmp9_ = game_hub_data_db_tables_games_INFO_DETAILED;
#line 75 "../src/data/sources/user/UserGame.vala"
	_tmp10_ = game_hub_data_db_table_field_get (_tmp9_, s);
#line 75 "../src/data/sources/user/UserGame.vala"
	_tmp11_ = _tmp10_;
#line 75 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_info_detailed ((GameHubDataGame*) self, _tmp11_);
#line 75 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp11_);
#line 76 "../src/data/sources/user/UserGame.vala"
	_tmp12_ = game_hub_data_db_tables_games_ICON;
#line 76 "../src/data/sources/user/UserGame.vala"
	_tmp13_ = game_hub_data_db_table_field_get (_tmp12_, s);
#line 76 "../src/data/sources/user/UserGame.vala"
	_tmp14_ = _tmp13_;
#line 76 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_icon ((GameHubDataGame*) self, _tmp14_);
#line 76 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp14_);
#line 77 "../src/data/sources/user/UserGame.vala"
	_tmp15_ = game_hub_data_db_tables_games_IMAGE;
#line 77 "../src/data/sources/user/UserGame.vala"
	_tmp16_ = game_hub_data_db_table_field_get (_tmp15_, s);
#line 77 "../src/data/sources/user/UserGame.vala"
	_tmp17_ = _tmp16_;
#line 77 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_image ((GameHubDataGame*) self, _tmp17_);
#line 77 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp17_);
#line 78 "../src/data/sources/user/UserGame.vala"
	_tmp18_ = game_hub_data_db_tables_games_INSTALL_PATH;
#line 78 "../src/data/sources/user/UserGame.vala"
	_tmp19_ = game_hub_data_db_table_field_get (_tmp18_, s);
#line 78 "../src/data/sources/user/UserGame.vala"
	_tmp20_ = _tmp19_;
#line 78 "../src/data/sources/user/UserGame.vala"
	_tmp21_ = game_hub_utils_fs_utils_file (_tmp20_, NULL, NULL);
#line 78 "../src/data/sources/user/UserGame.vala"
	_tmp22_ = _tmp21_;
#line 78 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_install_dir ((GameHubDataRunnable*) self, _tmp22_);
#line 78 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (_tmp22_);
#line 78 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp20_);
#line 79 "../src/data/sources/user/UserGame.vala"
	_tmp23_ = game_hub_data_db_tables_games_EXECUTABLE;
#line 79 "../src/data/sources/user/UserGame.vala"
	_tmp24_ = game_hub_data_db_table_field_get (_tmp23_, s);
#line 79 "../src/data/sources/user/UserGame.vala"
	_g_free0 (((GameHubDataGame*) self)->executable_path);
#line 79 "../src/data/sources/user/UserGame.vala"
	((GameHubDataGame*) self)->executable_path = _tmp24_;
#line 80 "../src/data/sources/user/UserGame.vala"
	_tmp25_ = game_hub_data_db_tables_games_COMPAT_TOOL;
#line 80 "../src/data/sources/user/UserGame.vala"
	_tmp26_ = game_hub_data_db_table_field_get (_tmp25_, s);
#line 80 "../src/data/sources/user/UserGame.vala"
	_tmp27_ = _tmp26_;
#line 80 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_compat_tool ((GameHubDataRunnable*) self, _tmp27_);
#line 80 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp27_);
#line 81 "../src/data/sources/user/UserGame.vala"
	_tmp28_ = game_hub_data_db_tables_games_COMPAT_TOOL_SETTINGS;
#line 81 "../src/data/sources/user/UserGame.vala"
	_tmp29_ = game_hub_data_db_table_field_get (_tmp28_, s);
#line 81 "../src/data/sources/user/UserGame.vala"
	_tmp30_ = _tmp29_;
#line 81 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_compat_tool_settings ((GameHubDataRunnable*) self, _tmp30_);
#line 81 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp30_);
#line 82 "../src/data/sources/user/UserGame.vala"
	_tmp31_ = game_hub_data_db_tables_games_ARGUMENTS;
#line 82 "../src/data/sources/user/UserGame.vala"
	_tmp32_ = game_hub_data_db_table_field_get (_tmp31_, s);
#line 82 "../src/data/sources/user/UserGame.vala"
	_tmp33_ = _tmp32_;
#line 82 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_arguments ((GameHubDataRunnable*) self, _tmp33_);
#line 82 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp33_);
#line 83 "../src/data/sources/user/UserGame.vala"
	_tmp34_ = game_hub_data_db_tables_games_LAST_LAUNCH;
#line 83 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_last_launch ((GameHubDataGame*) self, game_hub_data_db_table_field_get_int64 (_tmp34_, s));
#line 84 "../src/data/sources/user/UserGame.vala"
	_tmp35_ = game_hub_data_db_tables_games_PLAYTIME_SOURCE;
#line 84 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_playtime_source ((GameHubDataGame*) self, game_hub_data_db_table_field_get_int64 (_tmp35_, s));
#line 85 "../src/data/sources/user/UserGame.vala"
	_tmp36_ = game_hub_data_db_tables_games_PLAYTIME_TRACKED;
#line 85 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_playtime_tracked ((GameHubDataGame*) self, game_hub_data_db_table_field_get_int64 (_tmp36_, s));
#line 86 "../src/data/sources/user/UserGame.vala"
	_tmp37_ = game_hub_data_db_tables_games_IMAGE_VERTICAL;
#line 86 "../src/data/sources/user/UserGame.vala"
	_tmp38_ = game_hub_data_db_table_field_get (_tmp37_, s);
#line 86 "../src/data/sources/user/UserGame.vala"
	_tmp39_ = _tmp38_;
#line 86 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_image_vertical ((GameHubDataGame*) self, _tmp39_);
#line 86 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp39_);
#line 88 "../src/data/sources/user/UserGame.vala"
	_tmp40_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 88 "../src/data/sources/user/UserGame.vala"
	_tmp41_ = _tmp40_;
#line 88 "../src/data/sources/user/UserGame.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp41_);
#line 89 "../src/data/sources/user/UserGame.vala"
	_tmp42_ = game_hub_data_db_tables_games_PLATFORMS;
#line 89 "../src/data/sources/user/UserGame.vala"
	_tmp43_ = game_hub_data_db_table_field_get (_tmp42_, s);
#line 89 "../src/data/sources/user/UserGame.vala"
	_tmp44_ = _tmp43_;
#line 89 "../src/data/sources/user/UserGame.vala"
	_tmp46_ = _tmp45_ = g_strsplit (_tmp44_, ",", 0);
#line 89 "../src/data/sources/user/UserGame.vala"
	_tmp47_ = _tmp46_;
#line 89 "../src/data/sources/user/UserGame.vala"
	_tmp47__length1 = _vala_array_length (_tmp45_);
#line 89 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp44_);
#line 89 "../src/data/sources/user/UserGame.vala"
	pls = _tmp47_;
#line 89 "../src/data/sources/user/UserGame.vala"
	pls_length1 = _tmp47__length1;
#line 89 "../src/data/sources/user/UserGame.vala"
	_pls_size_ = pls_length1;
#line 90 "../src/data/sources/user/UserGame.vala"
	_tmp48_ = pls;
#line 90 "../src/data/sources/user/UserGame.vala"
	_tmp48__length1 = pls_length1;
#line 1261 "UserGame.c"
	{
		gchar** pl_collection = NULL;
		gint pl_collection_length1 = 0;
		gint _pl_collection_size_ = 0;
		gint pl_it = 0;
#line 90 "../src/data/sources/user/UserGame.vala"
		pl_collection = _tmp48_;
#line 90 "../src/data/sources/user/UserGame.vala"
		pl_collection_length1 = _tmp48__length1;
#line 90 "../src/data/sources/user/UserGame.vala"
		for (pl_it = 0; pl_it < pl_collection_length1; pl_it = pl_it + 1) {
#line 1273 "UserGame.c"
			gchar* _tmp49_;
			gchar* pl = NULL;
#line 90 "../src/data/sources/user/UserGame.vala"
			_tmp49_ = g_strdup (pl_collection[pl_it]);
#line 90 "../src/data/sources/user/UserGame.vala"
			pl = _tmp49_;
#line 1280 "UserGame.c"
			{
				{
					GameHubDataPlatform* p_collection = NULL;
					gint p_collection_length1 = 0;
					gint _p_collection_size_ = 0;
					gint p_it = 0;
#line 92 "../src/data/sources/user/UserGame.vala"
					p_collection = GAME_HUB_DATA_PLATFORM_PLATFORMS;
#line 92 "../src/data/sources/user/UserGame.vala"
					p_collection_length1 = G_N_ELEMENTS (GAME_HUB_DATA_PLATFORM_PLATFORMS);
#line 92 "../src/data/sources/user/UserGame.vala"
					for (p_it = 0; p_it < p_collection_length1; p_it = p_it + 1) {
#line 1293 "UserGame.c"
						GameHubDataPlatform p = 0;
#line 92 "../src/data/sources/user/UserGame.vala"
						p = p_collection[p_it];
#line 1297 "UserGame.c"
						{
							const gchar* _tmp50_;
							GameHubDataPlatform _tmp51_;
							gchar* _tmp52_;
							gchar* _tmp53_;
							gboolean _tmp54_;
#line 94 "../src/data/sources/user/UserGame.vala"
							_tmp50_ = pl;
#line 94 "../src/data/sources/user/UserGame.vala"
							_tmp51_ = p;
#line 94 "../src/data/sources/user/UserGame.vala"
							_tmp52_ = game_hub_data_platform_id (_tmp51_);
#line 94 "../src/data/sources/user/UserGame.vala"
							_tmp53_ = _tmp52_;
#line 94 "../src/data/sources/user/UserGame.vala"
							_tmp54_ = g_strcmp0 (_tmp50_, _tmp53_) == 0;
#line 94 "../src/data/sources/user/UserGame.vala"
							_g_free0 (_tmp53_);
#line 94 "../src/data/sources/user/UserGame.vala"
							if (_tmp54_) {
#line 1318 "UserGame.c"
								GeeArrayList* _tmp55_;
								GeeArrayList* _tmp56_;
								GameHubDataPlatform _tmp57_;
#line 96 "../src/data/sources/user/UserGame.vala"
								_tmp55_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 96 "../src/data/sources/user/UserGame.vala"
								_tmp56_ = _tmp55_;
#line 96 "../src/data/sources/user/UserGame.vala"
								_tmp57_ = p;
#line 96 "../src/data/sources/user/UserGame.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp56_, (gpointer) ((gintptr) _tmp57_));
#line 97 "../src/data/sources/user/UserGame.vala"
								break;
#line 1332 "UserGame.c"
							}
						}
					}
				}
#line 90 "../src/data/sources/user/UserGame.vala"
				_g_free0 (pl);
#line 1339 "UserGame.c"
			}
		}
	}
#line 102 "../src/data/sources/user/UserGame.vala"
	_tmp58_ = game_hub_data_game_get_tags ((GameHubDataGame*) self);
#line 102 "../src/data/sources/user/UserGame.vala"
	_tmp59_ = _tmp58_;
#line 102 "../src/data/sources/user/UserGame.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp59_);
#line 103 "../src/data/sources/user/UserGame.vala"
	_tmp61_ = game_hub_data_db_tables_games_TAGS;
#line 103 "../src/data/sources/user/UserGame.vala"
	_tmp62_ = game_hub_data_db_table_field_get (_tmp61_, s);
#line 103 "../src/data/sources/user/UserGame.vala"
	_tmp60_ = _tmp62_;
#line 103 "../src/data/sources/user/UserGame.vala"
	if (_tmp60_ == NULL) {
#line 1357 "UserGame.c"
		gchar* _tmp63_;
#line 103 "../src/data/sources/user/UserGame.vala"
		_tmp63_ = g_strdup ("");
#line 103 "../src/data/sources/user/UserGame.vala"
		_g_free0 (_tmp60_);
#line 103 "../src/data/sources/user/UserGame.vala"
		_tmp60_ = _tmp63_;
#line 1365 "UserGame.c"
	}
#line 103 "../src/data/sources/user/UserGame.vala"
	_tmp65_ = _tmp64_ = g_strsplit (_tmp60_, ",", 0);
#line 103 "../src/data/sources/user/UserGame.vala"
	tag_ids = _tmp65_;
#line 103 "../src/data/sources/user/UserGame.vala"
	tag_ids_length1 = _vala_array_length (_tmp64_);
#line 103 "../src/data/sources/user/UserGame.vala"
	_tag_ids_size_ = tag_ids_length1;
#line 104 "../src/data/sources/user/UserGame.vala"
	_tmp66_ = tag_ids;
#line 104 "../src/data/sources/user/UserGame.vala"
	_tmp66__length1 = tag_ids_length1;
#line 1379 "UserGame.c"
	{
		gchar** tid_collection = NULL;
		gint tid_collection_length1 = 0;
		gint _tid_collection_size_ = 0;
		gint tid_it = 0;
#line 104 "../src/data/sources/user/UserGame.vala"
		tid_collection = _tmp66_;
#line 104 "../src/data/sources/user/UserGame.vala"
		tid_collection_length1 = _tmp66__length1;
#line 104 "../src/data/sources/user/UserGame.vala"
		for (tid_it = 0; tid_it < tid_collection_length1; tid_it = tid_it + 1) {
#line 1391 "UserGame.c"
			gchar* _tmp67_;
			gchar* tid = NULL;
#line 104 "../src/data/sources/user/UserGame.vala"
			_tmp67_ = g_strdup (tid_collection[tid_it]);
#line 104 "../src/data/sources/user/UserGame.vala"
			tid = _tmp67_;
#line 1398 "UserGame.c"
			{
				{
					GeeArrayList* _t_list = NULL;
					GeeArrayList* _tmp68_;
					GeeArrayList* _tmp69_;
					gint _t_size = 0;
					GeeArrayList* _tmp70_;
					gint _tmp71_;
					gint _tmp72_;
					gint _t_index = 0;
#line 106 "../src/data/sources/user/UserGame.vala"
					_tmp68_ = game_hub_data_db_tables_tags_TAGS;
#line 106 "../src/data/sources/user/UserGame.vala"
					_tmp69_ = _g_object_ref0 (_tmp68_);
#line 106 "../src/data/sources/user/UserGame.vala"
					_t_list = _tmp69_;
#line 106 "../src/data/sources/user/UserGame.vala"
					_tmp70_ = _t_list;
#line 106 "../src/data/sources/user/UserGame.vala"
					_tmp71_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp70_);
#line 106 "../src/data/sources/user/UserGame.vala"
					_tmp72_ = _tmp71_;
#line 106 "../src/data/sources/user/UserGame.vala"
					_t_size = _tmp72_;
#line 106 "../src/data/sources/user/UserGame.vala"
					_t_index = -1;
#line 106 "../src/data/sources/user/UserGame.vala"
					while (TRUE) {
#line 1427 "UserGame.c"
						GameHubDataDBTablesTagsTag* t = NULL;
						GeeArrayList* _tmp73_;
						gpointer _tmp74_;
						const gchar* _tmp75_;
						GameHubDataDBTablesTagsTag* _tmp76_;
						const gchar* _tmp77_;
						const gchar* _tmp78_;
#line 106 "../src/data/sources/user/UserGame.vala"
						_t_index = _t_index + 1;
#line 106 "../src/data/sources/user/UserGame.vala"
						if (!(_t_index < _t_size)) {
#line 106 "../src/data/sources/user/UserGame.vala"
							break;
#line 1441 "UserGame.c"
						}
#line 106 "../src/data/sources/user/UserGame.vala"
						_tmp73_ = _t_list;
#line 106 "../src/data/sources/user/UserGame.vala"
						_tmp74_ = gee_abstract_list_get ((GeeAbstractList*) _tmp73_, _t_index);
#line 106 "../src/data/sources/user/UserGame.vala"
						t = (GameHubDataDBTablesTagsTag*) _tmp74_;
#line 108 "../src/data/sources/user/UserGame.vala"
						_tmp75_ = tid;
#line 108 "../src/data/sources/user/UserGame.vala"
						_tmp76_ = t;
#line 108 "../src/data/sources/user/UserGame.vala"
						_tmp77_ = game_hub_data_db_tables_tags_tag_get_id (_tmp76_);
#line 108 "../src/data/sources/user/UserGame.vala"
						_tmp78_ = _tmp77_;
#line 108 "../src/data/sources/user/UserGame.vala"
						if (g_strcmp0 (_tmp75_, _tmp78_) == 0) {
#line 1459 "UserGame.c"
							GeeArrayList* _tmp79_;
							GeeArrayList* _tmp80_;
							GameHubDataDBTablesTagsTag* _tmp81_;
#line 110 "../src/data/sources/user/UserGame.vala"
							_tmp79_ = game_hub_data_game_get_tags ((GameHubDataGame*) self);
#line 110 "../src/data/sources/user/UserGame.vala"
							_tmp80_ = _tmp79_;
#line 110 "../src/data/sources/user/UserGame.vala"
							_tmp81_ = t;
#line 110 "../src/data/sources/user/UserGame.vala"
							if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp80_, _tmp81_)) {
#line 1471 "UserGame.c"
								GeeArrayList* _tmp82_;
								GeeArrayList* _tmp83_;
								GameHubDataDBTablesTagsTag* _tmp84_;
#line 110 "../src/data/sources/user/UserGame.vala"
								_tmp82_ = game_hub_data_game_get_tags ((GameHubDataGame*) self);
#line 110 "../src/data/sources/user/UserGame.vala"
								_tmp83_ = _tmp82_;
#line 110 "../src/data/sources/user/UserGame.vala"
								_tmp84_ = t;
#line 110 "../src/data/sources/user/UserGame.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp83_, _tmp84_);
#line 1483 "UserGame.c"
							}
#line 111 "../src/data/sources/user/UserGame.vala"
							_g_object_unref0 (t);
#line 111 "../src/data/sources/user/UserGame.vala"
							break;
#line 1489 "UserGame.c"
						}
#line 106 "../src/data/sources/user/UserGame.vala"
						_g_object_unref0 (t);
#line 1493 "UserGame.c"
					}
#line 106 "../src/data/sources/user/UserGame.vala"
					_g_object_unref0 (_t_list);
#line 1497 "UserGame.c"
				}
#line 104 "../src/data/sources/user/UserGame.vala"
				_g_free0 (tid);
#line 1501 "UserGame.c"
			}
		}
	}
#line 116 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_mount_overlays ((GameHubDataGame*) self, NULL, NULL, NULL);
#line 117 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) self);
#line 69 "../src/data/sources/user/UserGame.vala"
	tag_ids = (_vala_array_free (tag_ids, tag_ids_length1, (GDestroyNotify) g_free), NULL);
#line 69 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp60_);
#line 69 "../src/data/sources/user/UserGame.vala"
	pls = (_vala_array_free (pls, pls_length1, (GDestroyNotify) g_free), NULL);
#line 69 "../src/data/sources/user/UserGame.vala"
	return self;
#line 1517 "UserGame.c"
}

GameHubDataSourcesUserUserGame*
game_hub_data_sources_user_user_game_new_from_db (GameHubDataSourcesUserUser* src,
                                                  sqlite3_stmt* s)
{
#line 69 "../src/data/sources/user/UserGame.vala"
	return game_hub_data_sources_user_user_game_construct_from_db (GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, src, s);
#line 1526 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_update_game_info_data_free (gpointer _data)
{
	GameHubDataSourcesUserUserGameUpdateGameInfoData* _data_;
	_data_ = _data;
#line 25 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_slice_free (GameHubDataSourcesUserUserGameUpdateGameInfoData, _data_);
#line 1538 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_update_game_info (GameHubDataGame* base,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_)
{
	GameHubDataSourcesUserUserGame * self;
	GameHubDataSourcesUserUserGameUpdateGameInfoData* _data_;
	GameHubDataSourcesUserUserGame* _tmp0_;
#line 25 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) base;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesUserUserGameUpdateGameInfoData);
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_user_user_game_real_update_game_info_data_free);
#line 25 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_real_update_game_info_co (_data_);
#line 1563 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_update_game_info_finish (GameHubDataGame* base,
                                                              GAsyncResult* _res_)
{
	GameHubDataSourcesUserUserGameUpdateGameInfoData* _data_;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1573 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_update_game_info_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_)
{
	GameHubDataSourcesUserUserGameUpdateGameInfoData* _data_;
#line 122 "../src/data/sources/user/UserGame.vala"
	_data_ = _user_data_;
#line 122 "../src/data/sources/user/UserGame.vala"
	_data_->_source_object_ = source_object;
#line 122 "../src/data/sources/user/UserGame.vala"
	_data_->_res_ = _res_;
#line 122 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_real_update_game_info_co (_data_);
#line 1590 "UserGame.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 127 "../src/data/sources/user/UserGame.vala"
	return self ? json_object_ref (self) : NULL;
#line 1598 "UserGame.c"
}

static gboolean
game_hub_data_sources_user_user_game_real_update_game_info_co (GameHubDataSourcesUserUserGameUpdateGameInfoData* _data_)
{
#line 120 "../src/data/sources/user/UserGame.vala"
	switch (_data_->_state_) {
#line 120 "../src/data/sources/user/UserGame.vala"
		case 0:
#line 1608 "UserGame.c"
		goto _state_0;
#line 120 "../src/data/sources/user/UserGame.vala"
		case 1:
#line 1612 "UserGame.c"
		goto _state_1;
		default:
#line 120 "../src/data/sources/user/UserGame.vala"
		g_assert_not_reached ();
#line 1617 "UserGame.c"
	}
	_state_0:
#line 122 "../src/data/sources/user/UserGame.vala"
	_data_->_state_ = 1;
#line 122 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_mount_overlays ((GameHubDataGame*) _data_->self, NULL, game_hub_data_sources_user_user_game_update_game_info_ready, _data_);
#line 122 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 1626 "UserGame.c"
	_state_1:
#line 122 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_mount_overlays_finish ((GameHubDataGame*) _data_->self, _data_->_res_);
#line 123 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) _data_->self);
#line 125 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp2_ = _data_->self->priv->installer;
#line 125 "../src/data/sources/user/UserGame.vala"
	if (_data_->_tmp2_ == NULL) {
#line 125 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp3_ = game_hub_data_game_get_info ((GameHubDataGame*) _data_->self);
#line 125 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 125 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp1_ = _data_->_tmp4_ != NULL;
#line 1642 "UserGame.c"
	} else {
#line 125 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp1_ = FALSE;
#line 1646 "UserGame.c"
	}
#line 125 "../src/data/sources/user/UserGame.vala"
	if (_data_->_tmp1_) {
#line 125 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp5_ = game_hub_data_game_get_info ((GameHubDataGame*) _data_->self);
#line 125 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 125 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp7_ = strlen (_data_->_tmp6_);
#line 125 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 125 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp0_ = _data_->_tmp8_ > 0;
#line 1660 "UserGame.c"
	} else {
#line 125 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp0_ = FALSE;
#line 1664 "UserGame.c"
	}
#line 125 "../src/data/sources/user/UserGame.vala"
	if (_data_->_tmp0_) {
#line 127 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp9_ = game_hub_data_game_get_info ((GameHubDataGame*) _data_->self);
#line 127 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 127 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp11_ = game_hub_utils_parser_parse_json (_data_->_tmp10_);
#line 127 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 127 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp13_ = json_node_get_object (_data_->_tmp12_);
#line 127 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp14_ = _json_object_ref0 (_data_->_tmp13_);
#line 127 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 127 "../src/data/sources/user/UserGame.vala"
		__vala_JsonNode_free0 (_data_->_tmp12_);
#line 127 "../src/data/sources/user/UserGame.vala"
		_data_->i = _data_->_tmp15_;
#line 128 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp16_ = _data_->i;
#line 128 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp17_ = json_object_get_string_member (_data_->_tmp16_, "installer");
#line 128 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp18_ = g_file_new_for_path (_data_->_tmp17_);
#line 128 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 128 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp20_ = game_hub_data_sources_user_user_game_installer_new (_data_->self, _data_->_tmp19_);
#line 128 "../src/data/sources/user/UserGame.vala"
		_game_hub_data_runnable_installer_unref0 (_data_->self->priv->installer);
#line 128 "../src/data/sources/user/UserGame.vala"
		_data_->self->priv->installer = _data_->_tmp20_;
#line 128 "../src/data/sources/user/UserGame.vala"
		_g_object_unref0 (_data_->_tmp19_);
#line 125 "../src/data/sources/user/UserGame.vala"
		_json_object_unref0 (_data_->i);
#line 1704 "UserGame.c"
	}
#line 131 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_save ((GameHubDataRunnable*) _data_->self);
#line 120 "../src/data/sources/user/UserGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 120 "../src/data/sources/user/UserGame.vala"
	if (_data_->_state_ != 0) {
#line 120 "../src/data/sources/user/UserGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 120 "../src/data/sources/user/UserGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1716 "UserGame.c"
		}
	}
#line 120 "../src/data/sources/user/UserGame.vala"
	g_object_unref (_data_->_async_result);
#line 120 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 1723 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_install_data_free (gpointer _data)
{
	GameHubDataSourcesUserUserGameInstallData* _data_;
	_data_ = _data;
#line 25 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_slice_free (GameHubDataSourcesUserUserGameInstallData, _data_);
#line 1735 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_install (GameHubDataRunnable* base,
                                                   GameHubDataRunnableInstallerInstallMode install_mode,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	GameHubDataSourcesUserUserGame * self;
	GameHubDataSourcesUserUserGameInstallData* _data_;
	GameHubDataSourcesUserUserGame* _tmp0_;
#line 25 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) base;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesUserUserGameInstallData);
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_user_user_game_real_install_data_free);
#line 25 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->install_mode = install_mode;
#line 25 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_real_install_co (_data_);
#line 1763 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_install_finish (GameHubDataRunnable* base,
                                                     GAsyncResult* _res_)
{
	GameHubDataSourcesUserUserGameInstallData* _data_;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1773 "UserGame.c"
}

static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
#line 134 "../src/data/sources/user/UserGame.vala"
	g_atomic_int_inc (&_data29_->_ref_count_);
#line 134 "../src/data/sources/user/UserGame.vala"
	return _data29_;
#line 1783 "UserGame.c"
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
#line 134 "../src/data/sources/user/UserGame.vala"
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
#line 1793 "UserGame.c"
		GameHubDataSourcesUserUserGame* self;
#line 134 "../src/data/sources/user/UserGame.vala"
		self = _data29_->self;
#line 134 "../src/data/sources/user/UserGame.vala"
		_g_object_unref0 (self);
#line 134 "../src/data/sources/user/UserGame.vala"
		g_slice_free (Block29Data, _data29_);
#line 1801 "UserGame.c"
	}
}

static void
game_hub_data_sources_user_user_game_install_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	GameHubDataSourcesUserUserGameInstallData* _data_;
#line 136 "../src/data/sources/user/UserGame.vala"
	_data_ = _user_data_;
#line 136 "../src/data/sources/user/UserGame.vala"
	_data_->_source_object_ = source_object;
#line 136 "../src/data/sources/user/UserGame.vala"
	_data_->_res_ = _res_;
#line 136 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_real_install_co (_data_);
#line 1819 "UserGame.c"
}

static gboolean
_game_hub_data_sources_user_user_game_real_install_co_gsource_func (gpointer self)
{
	gboolean result;
	result = game_hub_data_sources_user_user_game_real_install_co (self);
#line 145 "../src/data/sources/user/UserGame.vala"
	return result;
#line 1829 "UserGame.c"
}

static void
__lambda48_ (Block29Data* _data29_)
{
	GameHubDataSourcesUserUserGame* self;
#line 145 "../src/data/sources/user/UserGame.vala"
	self = _data29_->self;
#line 145 "../src/data/sources/user/UserGame.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _game_hub_data_sources_user_user_game_real_install_co_gsource_func, _data29_->_async_data_, NULL);
#line 1840 "UserGame.c"
}

static void
___lambda48__game_hub_ui_dialogs_install_dialog_cancelled (GameHubUIDialogsInstallDialog* _sender,
                                                           gpointer self)
{
#line 145 "../src/data/sources/user/UserGame.vala"
	__lambda48_ (self);
#line 1849 "UserGame.c"
}

static gpointer
_game_hub_data_runnable_installer_ref0 (gpointer self)
{
#line 147 "../src/data/sources/user/UserGame.vala"
	return self ? game_hub_data_runnable_installer_ref (self) : NULL;
#line 1857 "UserGame.c"
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
#line 147 "../src/data/sources/user/UserGame.vala"
	g_atomic_int_inc (&_data30_->_ref_count_);
#line 147 "../src/data/sources/user/UserGame.vala"
	return _data30_;
#line 1867 "UserGame.c"
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
#line 147 "../src/data/sources/user/UserGame.vala"
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
#line 1877 "UserGame.c"
		GameHubDataSourcesUserUserGame* self;
#line 147 "../src/data/sources/user/UserGame.vala"
		self = _data30_->_data29_->self;
#line 147 "../src/data/sources/user/UserGame.vala"
		_game_hub_data_runnable_installer_unref0 (_data30_->installer);
#line 147 "../src/data/sources/user/UserGame.vala"
		block29_data_unref (_data30_->_data29_);
#line 147 "../src/data/sources/user/UserGame.vala"
		_data30_->_data29_ = NULL;
#line 147 "../src/data/sources/user/UserGame.vala"
		g_slice_free (Block30Data, _data30_);
#line 1889 "UserGame.c"
	}
}

static void
__lambda50_ (Block30Data* _data30_,
             GObject* obj,
             GAsyncResult* res)
{
	Block29Data* _data29_;
	GameHubDataSourcesUserUserGame* self;
#line 148 "../src/data/sources/user/UserGame.vala"
	_data29_ = _data30_->_data29_;
#line 148 "../src/data/sources/user/UserGame.vala"
	self = _data29_->self;
#line 148 "../src/data/sources/user/UserGame.vala"
	g_return_if_fail (res != NULL);
#line 149 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_installer_install_finish (_data30_->installer, res);
#line 150 "../src/data/sources/user/UserGame.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _game_hub_data_sources_user_user_game_real_install_co_gsource_func, _data29_->_async_data_, NULL);
#line 1910 "UserGame.c"
}

static void
___lambda50__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 148 "../src/data/sources/user/UserGame.vala"
	__lambda50_ (self, source_object, res);
#line 148 "../src/data/sources/user/UserGame.vala"
	block30_data_unref (self);
#line 1922 "UserGame.c"
}

static void
__lambda49_ (Block29Data* _data29_,
             GameHubDataRunnableInstaller* installer,
             gboolean dl_only,
             GameHubDataCompatTool* tool)
{
	GameHubDataSourcesUserUserGame* self;
	Block30Data* _data30_;
	GameHubDataRunnableInstaller* _tmp0_;
#line 147 "../src/data/sources/user/UserGame.vala"
	self = _data29_->self;
#line 147 "../src/data/sources/user/UserGame.vala"
	g_return_if_fail (installer != NULL);
#line 147 "../src/data/sources/user/UserGame.vala"
	_data30_ = g_slice_new0 (Block30Data);
#line 147 "../src/data/sources/user/UserGame.vala"
	_data30_->_ref_count_ = 1;
#line 147 "../src/data/sources/user/UserGame.vala"
	_data30_->_data29_ = block29_data_ref (_data29_);
#line 147 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = _game_hub_data_runnable_installer_ref0 (installer);
#line 147 "../src/data/sources/user/UserGame.vala"
	_game_hub_data_runnable_installer_unref0 (_data30_->installer);
#line 147 "../src/data/sources/user/UserGame.vala"
	_data30_->installer = _tmp0_;
#line 148 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_installer_install (_data30_->installer, (GameHubDataRunnable*) self, dl_only, tool, ___lambda50__gasync_ready_callback, block30_data_ref (_data30_));
#line 147 "../src/data/sources/user/UserGame.vala"
	block30_data_unref (_data30_);
#line 147 "../src/data/sources/user/UserGame.vala"
	_data30_ = NULL;
#line 1956 "UserGame.c"
}

static void
___lambda49__game_hub_ui_dialogs_install_dialog_install (GameHubUIDialogsInstallDialog* _sender,
                                                         GameHubDataRunnableInstaller* installer,
                                                         gboolean dl_only,
                                                         GameHubDataCompatTool* tool,
                                                         gpointer self)
{
#line 147 "../src/data/sources/user/UserGame.vala"
	__lambda49_ (self, installer, dl_only, tool);
#line 1968 "UserGame.c"
}

static gboolean
game_hub_data_sources_user_user_game_real_install_co (GameHubDataSourcesUserUserGameInstallData* _data_)
{
#line 134 "../src/data/sources/user/UserGame.vala"
	switch (_data_->_state_) {
#line 134 "../src/data/sources/user/UserGame.vala"
		case 0:
#line 1978 "UserGame.c"
		goto _state_0;
#line 134 "../src/data/sources/user/UserGame.vala"
		case 1:
#line 1982 "UserGame.c"
		goto _state_1;
#line 134 "../src/data/sources/user/UserGame.vala"
		case 2:
#line 1986 "UserGame.c"
		goto _state_2;
		default:
#line 134 "../src/data/sources/user/UserGame.vala"
		g_assert_not_reached ();
#line 1991 "UserGame.c"
	}
	_state_0:
#line 134 "../src/data/sources/user/UserGame.vala"
	_data_->_data29_ = g_slice_new0 (Block29Data);
#line 134 "../src/data/sources/user/UserGame.vala"
	_data_->_data29_->_ref_count_ = 1;
#line 134 "../src/data/sources/user/UserGame.vala"
	_data_->_data29_->self = g_object_ref (_data_->self);
#line 134 "../src/data/sources/user/UserGame.vala"
	_data_->_data29_->_async_data_ = _data_;
#line 136 "../src/data/sources/user/UserGame.vala"
	_data_->_state_ = 1;
#line 136 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_update_game_info ((GameHubDataGame*) _data_->self, game_hub_data_sources_user_user_game_install_ready, _data_);
#line 136 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 2008 "UserGame.c"
	_state_1:
#line 136 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_update_game_info_finish ((GameHubDataGame*) _data_->self, _data_->_res_);
#line 138 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp0_ = _data_->self->priv->installer;
#line 138 "../src/data/sources/user/UserGame.vala"
	if (_data_->_tmp0_ == NULL) {
#line 138 "../src/data/sources/user/UserGame.vala"
		block29_data_unref (_data_->_data29_);
#line 138 "../src/data/sources/user/UserGame.vala"
		_data_->_data29_ = NULL;
#line 138 "../src/data/sources/user/UserGame.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 138 "../src/data/sources/user/UserGame.vala"
		if (_data_->_state_ != 0) {
#line 138 "../src/data/sources/user/UserGame.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 138 "../src/data/sources/user/UserGame.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2028 "UserGame.c"
			}
		}
#line 138 "../src/data/sources/user/UserGame.vala"
		g_object_unref (_data_->_async_result);
#line 138 "../src/data/sources/user/UserGame.vala"
		return FALSE;
#line 2035 "UserGame.c"
	}
#line 140 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp1_ = gee_array_list_new (GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, (GBoxedCopyFunc) game_hub_data_runnable_installer_ref, (GDestroyNotify) game_hub_data_runnable_installer_unref, NULL, NULL, NULL);
#line 140 "../src/data/sources/user/UserGame.vala"
	_data_->installers = _data_->_tmp1_;
#line 141 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp2_ = _data_->installers;
#line 141 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp3_ = _data_->self->priv->installer;
#line 141 "../src/data/sources/user/UserGame.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp2_, (GameHubDataRunnableInstaller*) _data_->_tmp3_);
#line 143 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp4_ = _data_->installers;
#line 143 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp5_ = game_hub_ui_dialogs_install_dialog_new ((GameHubDataRunnable*) _data_->self, _data_->_tmp4_, _data_->install_mode);
#line 143 "../src/data/sources/user/UserGame.vala"
	g_object_ref_sink (_data_->_tmp5_);
#line 143 "../src/data/sources/user/UserGame.vala"
	_data_->wnd = _data_->_tmp5_;
#line 145 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp6_ = _data_->wnd;
#line 145 "../src/data/sources/user/UserGame.vala"
	g_signal_connect_data (_data_->_tmp6_, "cancelled", (GCallback) ___lambda48__game_hub_ui_dialogs_install_dialog_cancelled, block29_data_ref (_data_->_data29_), (GClosureNotify) block29_data_unref, 0);
#line 147 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp7_ = _data_->wnd;
#line 147 "../src/data/sources/user/UserGame.vala"
	g_signal_connect_data (_data_->_tmp7_, "install", (GCallback) ___lambda49__game_hub_ui_dialogs_install_dialog_install, block29_data_ref (_data_->_data29_), (GClosureNotify) block29_data_unref, 0);
#line 154 "../src/data/sources/user/UserGame.vala"
	if (_data_->install_mode == GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_INTERACTIVE) {
#line 156 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp8_ = _data_->wnd;
#line 156 "../src/data/sources/user/UserGame.vala"
		gtk_widget_show_all ((GtkWidget*) _data_->_tmp8_);
#line 157 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp9_ = _data_->wnd;
#line 157 "../src/data/sources/user/UserGame.vala"
		gtk_window_present ((GtkWindow*) _data_->_tmp9_);
#line 2073 "UserGame.c"
	}
#line 160 "../src/data/sources/user/UserGame.vala"
	_data_->_state_ = 2;
#line 160 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 2079 "UserGame.c"
	_state_2:
	;
#line 134 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (_data_->wnd);
#line 134 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (_data_->installers);
#line 134 "../src/data/sources/user/UserGame.vala"
	block29_data_unref (_data_->_data29_);
#line 134 "../src/data/sources/user/UserGame.vala"
	_data_->_data29_ = NULL;
#line 134 "../src/data/sources/user/UserGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 134 "../src/data/sources/user/UserGame.vala"
	if (_data_->_state_ != 0) {
#line 134 "../src/data/sources/user/UserGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 134 "../src/data/sources/user/UserGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2098 "UserGame.c"
		}
	}
#line 134 "../src/data/sources/user/UserGame.vala"
	g_object_unref (_data_->_async_result);
#line 134 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 2105 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_uninstall_data_free (gpointer _data)
{
	GameHubDataSourcesUserUserGameUninstallData* _data_;
	_data_ = _data;
#line 25 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_slice_free (GameHubDataSourcesUserUserGameUninstallData, _data_);
#line 2117 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_uninstall (GameHubDataGame* base,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	GameHubDataSourcesUserUserGame * self;
	GameHubDataSourcesUserUserGameUninstallData* _data_;
	GameHubDataSourcesUserUserGame* _tmp0_;
#line 25 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) base;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesUserUserGameUninstallData);
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_user_user_game_real_uninstall_data_free);
#line 25 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_real_uninstall_co (_data_);
#line 2142 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_uninstall_finish (GameHubDataGame* base,
                                                       GAsyncResult* _res_)
{
	GameHubDataSourcesUserUserGameUninstallData* _data_;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2152 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_uninstall_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	GameHubDataSourcesUserUserGameUninstallData* _data_;
#line 165 "../src/data/sources/user/UserGame.vala"
	_data_ = _user_data_;
#line 165 "../src/data/sources/user/UserGame.vala"
	_data_->_source_object_ = source_object;
#line 165 "../src/data/sources/user/UserGame.vala"
	_data_->_res_ = _res_;
#line 165 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_real_uninstall_co (_data_);
#line 2169 "UserGame.c"
}

static gboolean
game_hub_data_sources_user_user_game_real_uninstall_co (GameHubDataSourcesUserUserGameUninstallData* _data_)
{
#line 163 "../src/data/sources/user/UserGame.vala"
	switch (_data_->_state_) {
#line 163 "../src/data/sources/user/UserGame.vala"
		case 0:
#line 2179 "UserGame.c"
		goto _state_0;
#line 163 "../src/data/sources/user/UserGame.vala"
		case 1:
#line 2183 "UserGame.c"
		goto _state_1;
		default:
#line 163 "../src/data/sources/user/UserGame.vala"
		g_assert_not_reached ();
#line 2188 "UserGame.c"
	}
	_state_0:
#line 165 "../src/data/sources/user/UserGame.vala"
	_data_->_state_ = 1;
#line 165 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_umount_overlays ((GameHubDataGame*) _data_->self, game_hub_data_sources_user_user_game_uninstall_ready, _data_);
#line 165 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 2197 "UserGame.c"
	_state_1:
#line 165 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_umount_overlays_finish ((GameHubDataGame*) _data_->self, _data_->_res_);
#line 166 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_remove (_data_->self);
#line 163 "../src/data/sources/user/UserGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 163 "../src/data/sources/user/UserGame.vala"
	if (_data_->_state_ != 0) {
#line 163 "../src/data/sources/user/UserGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 163 "../src/data/sources/user/UserGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2211 "UserGame.c"
		}
	}
#line 163 "../src/data/sources/user/UserGame.vala"
	g_object_unref (_data_->_async_result);
#line 163 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 2218 "UserGame.c"
}

void
game_hub_data_sources_user_user_game_remove (GameHubDataSourcesUserUserGame* self)
{
	GameHubDataGameSource* _tmp0_;
	GameHubDataGameSource* _tmp1_;
#line 169 "../src/data/sources/user/UserGame.vala"
	g_return_if_fail (self != NULL);
#line 171 "../src/data/sources/user/UserGame.vala"
	self->priv->is_removed = TRUE;
#line 172 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = game_hub_data_game_get_source ((GameHubDataGame*) self);
#line 172 "../src/data/sources/user/UserGame.vala"
	_tmp1_ = _tmp0_;
#line 172 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_remove_game (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GAME_HUB_DATA_SOURCES_USER_TYPE_USER, GameHubDataSourcesUserUser), self);
#line 173 "../src/data/sources/user/UserGame.vala"
	g_signal_emit (self, game_hub_data_sources_user_user_game_signals[GAME_HUB_DATA_SOURCES_USER_USER_GAME_REMOVED_SIGNAL], 0);
#line 2238 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_save (GameHubDataRunnable* base)
{
	GameHubDataSourcesUserUserGame * self;
#line 176 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) base;
#line 178 "../src/data/sources/user/UserGame.vala"
	if (!self->priv->is_removed) {
#line 180 "../src/data/sources/user/UserGame.vala"
		GAME_HUB_DATA_RUNNABLE_CLASS (game_hub_data_sources_user_user_game_parent_class)->save ((GameHubDataRunnable*) G_TYPE_CHECK_INSTANCE_CAST (self, GAME_HUB_DATA_TYPE_GAME, GameHubDataGame));
#line 2251 "UserGame.c"
	}
}

static void
game_hub_data_sources_user_user_game_real_update_status (GameHubDataRunnable* base)
{
	GameHubDataSourcesUserUserGame * self;
	GFile* exec = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GameHubDataGameState _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	GFile* _tmp4_;
	GameHubDataGameStatus* _tmp6_;
	GameHubDataGameStatus* _tmp7_;
	GameHubDataGameStatus* _tmp8_;
	GameHubDataGameStatus* _tmp9_;
	GameHubDataGameState _tmp10_;
#line 184 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) base;
#line 186 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) self);
#line 186 "../src/data/sources/user/UserGame.vala"
	_tmp1_ = _tmp0_;
#line 186 "../src/data/sources/user/UserGame.vala"
	exec = _tmp1_;
#line 187 "../src/data/sources/user/UserGame.vala"
	_tmp4_ = exec;
#line 187 "../src/data/sources/user/UserGame.vala"
	if (_tmp4_ != NULL) {
#line 2282 "UserGame.c"
		GFile* _tmp5_;
#line 187 "../src/data/sources/user/UserGame.vala"
		_tmp5_ = exec;
#line 187 "../src/data/sources/user/UserGame.vala"
		_tmp3_ = g_file_query_exists (_tmp5_, NULL);
#line 2288 "UserGame.c"
	} else {
#line 187 "../src/data/sources/user/UserGame.vala"
		_tmp3_ = FALSE;
#line 2292 "UserGame.c"
	}
#line 187 "../src/data/sources/user/UserGame.vala"
	if (_tmp3_) {
#line 187 "../src/data/sources/user/UserGame.vala"
		_tmp2_ = GAME_HUB_DATA_GAME_STATE_INSTALLED;
#line 2298 "UserGame.c"
	} else {
#line 187 "../src/data/sources/user/UserGame.vala"
		_tmp2_ = GAME_HUB_DATA_GAME_STATE_UNINSTALLED;
#line 2302 "UserGame.c"
	}
#line 187 "../src/data/sources/user/UserGame.vala"
	_tmp6_ = game_hub_data_game_status_new (_tmp2_, (GameHubDataGame*) self, NULL);
#line 187 "../src/data/sources/user/UserGame.vala"
	_tmp7_ = _tmp6_;
#line 187 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_status ((GameHubDataGame*) self, _tmp7_);
#line 187 "../src/data/sources/user/UserGame.vala"
	_game_hub_data_game_status_unref0 (_tmp7_);
#line 188 "../src/data/sources/user/UserGame.vala"
	_tmp8_ = game_hub_data_game_get_status ((GameHubDataGame*) self);
#line 188 "../src/data/sources/user/UserGame.vala"
	_tmp9_ = _tmp8_;
#line 188 "../src/data/sources/user/UserGame.vala"
	_tmp10_ = _tmp9_->state;
#line 188 "../src/data/sources/user/UserGame.vala"
	if (_tmp10_ == GAME_HUB_DATA_GAME_STATE_INSTALLED) {
#line 2320 "UserGame.c"
		GameHubDataDBTablesTagsTag* _tmp11_;
		GameHubDataDBTablesTagsTag* _tmp12_;
#line 190 "../src/data/sources/user/UserGame.vala"
		_tmp11_ = game_hub_data_db_tables_tags_BUILTIN_UNINSTALLED;
#line 190 "../src/data/sources/user/UserGame.vala"
		game_hub_data_game_remove_tag ((GameHubDataGame*) self, _tmp11_);
#line 191 "../src/data/sources/user/UserGame.vala"
		_tmp12_ = game_hub_data_db_tables_tags_BUILTIN_INSTALLED;
#line 191 "../src/data/sources/user/UserGame.vala"
		game_hub_data_game_add_tag ((GameHubDataGame*) self, _tmp12_);
#line 2331 "UserGame.c"
	} else {
		GameHubDataDBTablesTagsTag* _tmp13_;
		GameHubDataDBTablesTagsTag* _tmp14_;
#line 195 "../src/data/sources/user/UserGame.vala"
		_tmp13_ = game_hub_data_db_tables_tags_BUILTIN_UNINSTALLED;
#line 195 "../src/data/sources/user/UserGame.vala"
		game_hub_data_game_add_tag ((GameHubDataGame*) self, _tmp13_);
#line 196 "../src/data/sources/user/UserGame.vala"
		_tmp14_ = game_hub_data_db_tables_tags_BUILTIN_INSTALLED;
#line 196 "../src/data/sources/user/UserGame.vala"
		game_hub_data_game_remove_tag ((GameHubDataGame*) self, _tmp14_);
#line 2343 "UserGame.c"
	}
#line 184 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (exec);
#line 2347 "UserGame.c"
}

static inline gpointer
game_hub_data_sources_user_user_game_installer_get_instance_private (GameHubDataSourcesUserUserGameInstaller* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataSourcesUserUserGameInstaller_private_offset);
}

GameHubDataSourcesUserUserGameInstaller*
game_hub_data_sources_user_user_game_installer_construct (GType object_type,
                                                          GameHubDataSourcesUserUserGame* game,
                                                          GFile* installer)
{
	GameHubDataSourcesUserUserGameInstaller* self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GameHubDataPlatform _tmp3_ = 0;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	GeeArrayList* _tmp9_;
	GeeArrayList* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gint64 _tmp13_;
	gint64 _tmp14_;
	GameHubDataRunnableInstallerPart* _tmp15_;
	GameHubDataRunnableInstallerPart* _tmp16_;
#line 205 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 205 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (installer != NULL, NULL);
#line 205 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGameInstaller*) game_hub_data_runnable_installer_construct (object_type);
#line 207 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) game);
#line 207 "../src/data/sources/user/UserGame.vala"
	_tmp1_ = _tmp0_;
#line 207 "../src/data/sources/user/UserGame.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 207 "../src/data/sources/user/UserGame.vala"
	_g_free0 (self->priv->game_name);
#line 207 "../src/data/sources/user/UserGame.vala"
	self->priv->game_name = _tmp2_;
#line 208 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_installer_set_id ((GameHubDataRunnableInstaller*) self, "installer");
#line 209 "../src/data/sources/user/UserGame.vala"
	_tmp4_ = g_file_get_path (installer);
#line 209 "../src/data/sources/user/UserGame.vala"
	_tmp5_ = _tmp4_;
#line 209 "../src/data/sources/user/UserGame.vala"
	_tmp6_ = g_utf8_strdown (_tmp5_, (gssize) -1);
#line 209 "../src/data/sources/user/UserGame.vala"
	_tmp7_ = _tmp6_;
#line 209 "../src/data/sources/user/UserGame.vala"
	_tmp8_ = g_str_has_suffix (_tmp7_, ".exe");
#line 209 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp7_);
#line 209 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp5_);
#line 209 "../src/data/sources/user/UserGame.vala"
	if (_tmp8_) {
#line 209 "../src/data/sources/user/UserGame.vala"
		_tmp3_ = GAME_HUB_DATA_PLATFORM_WINDOWS;
#line 2415 "UserGame.c"
	} else {
#line 209 "../src/data/sources/user/UserGame.vala"
		_tmp3_ = GAME_HUB_DATA_PLATFORM_LINUX;
#line 2419 "UserGame.c"
	}
#line 209 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_installer_set_platform ((GameHubDataRunnableInstaller*) self, _tmp3_);
#line 210 "../src/data/sources/user/UserGame.vala"
	_tmp9_ = game_hub_data_runnable_installer_get_parts ((GameHubDataRunnableInstaller*) self);
#line 210 "../src/data/sources/user/UserGame.vala"
	_tmp10_ = _tmp9_;
#line 210 "../src/data/sources/user/UserGame.vala"
	_tmp11_ = g_file_get_uri (installer);
#line 210 "../src/data/sources/user/UserGame.vala"
	_tmp12_ = _tmp11_;
#line 210 "../src/data/sources/user/UserGame.vala"
	_tmp13_ = game_hub_data_runnable_installer_get_full_size ((GameHubDataRunnableInstaller*) self);
#line 210 "../src/data/sources/user/UserGame.vala"
	_tmp14_ = _tmp13_;
#line 210 "../src/data/sources/user/UserGame.vala"
	_tmp15_ = game_hub_data_runnable_installer_part_new ("installer", _tmp12_, _tmp14_, installer, installer, NULL, G_CHECKSUM_MD5);
#line 210 "../src/data/sources/user/UserGame.vala"
	_tmp16_ = _tmp15_;
#line 210 "../src/data/sources/user/UserGame.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp16_);
#line 210 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (_tmp16_);
#line 210 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp12_);
#line 205 "../src/data/sources/user/UserGame.vala"
	return self;
#line 2447 "UserGame.c"
}

GameHubDataSourcesUserUserGameInstaller*
game_hub_data_sources_user_user_game_installer_new (GameHubDataSourcesUserUserGame* game,
                                                    GFile* installer)
{
#line 205 "../src/data/sources/user/UserGame.vala"
	return game_hub_data_sources_user_user_game_installer_construct (GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER, game, installer);
#line 2456 "UserGame.c"
}

static gchar*
game_hub_data_sources_user_user_game_installer_real_get_name (GameHubDataRunnableInstaller* base)
{
	gchar* result;
	GameHubDataSourcesUserUserGameInstaller* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 203 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGameInstaller*) base;
#line 203 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = self->priv->game_name;
#line 203 "../src/data/sources/user/UserGame.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 203 "../src/data/sources/user/UserGame.vala"
	result = _tmp1_;
#line 203 "../src/data/sources/user/UserGame.vala"
	return result;
#line 2476 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_installer_class_init (GameHubDataSourcesUserUserGameInstallerClass * klass,
                                                           gpointer klass_data)
{
#line 200 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_installer_parent_class = g_type_class_peek_parent (klass);
#line 200 "../src/data/sources/user/UserGame.vala"
	((GameHubDataRunnableInstallerClass *) klass)->finalize = game_hub_data_sources_user_user_game_installer_finalize;
#line 200 "../src/data/sources/user/UserGame.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataSourcesUserUserGameInstaller_private_offset);
#line 200 "../src/data/sources/user/UserGame.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS (klass)->get_name = game_hub_data_sources_user_user_game_installer_real_get_name;
#line 2491 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_installer_instance_init (GameHubDataSourcesUserUserGameInstaller * self,
                                                              gpointer klass)
{
#line 200 "../src/data/sources/user/UserGame.vala"
	self->priv = game_hub_data_sources_user_user_game_installer_get_instance_private (self);
#line 2500 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_installer_finalize (GameHubDataRunnableInstaller * obj)
{
	GameHubDataSourcesUserUserGameInstaller * self;
#line 200 "../src/data/sources/user/UserGame.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER, GameHubDataSourcesUserUserGameInstaller);
#line 202 "../src/data/sources/user/UserGame.vala"
	_g_free0 (self->priv->game_name);
#line 200 "../src/data/sources/user/UserGame.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS (game_hub_data_sources_user_user_game_installer_parent_class)->finalize (obj);
#line 2513 "UserGame.c"
}

static GType
game_hub_data_sources_user_user_game_installer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataSourcesUserUserGameInstallerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_sources_user_user_game_installer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataSourcesUserUserGameInstaller), 0, (GInstanceInitFunc) game_hub_data_sources_user_user_game_installer_instance_init, NULL };
	GType game_hub_data_sources_user_user_game_installer_type_id;
	game_hub_data_sources_user_user_game_installer_type_id = g_type_register_static (GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, "GameHubDataSourcesUserUserGameInstaller", &g_define_type_info, 0);
	GameHubDataSourcesUserUserGameInstaller_private_offset = g_type_add_instance_private (game_hub_data_sources_user_user_game_installer_type_id, sizeof (GameHubDataSourcesUserUserGameInstallerPrivate));
	return game_hub_data_sources_user_user_game_installer_type_id;
}

GType
game_hub_data_sources_user_user_game_installer_get_type (void)
{
	static volatile gsize game_hub_data_sources_user_user_game_installer_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_sources_user_user_game_installer_type_id__volatile)) {
		GType game_hub_data_sources_user_user_game_installer_type_id;
		game_hub_data_sources_user_user_game_installer_type_id = game_hub_data_sources_user_user_game_installer_get_type_once ();
		g_once_init_leave (&game_hub_data_sources_user_user_game_installer_type_id__volatile, game_hub_data_sources_user_user_game_installer_type_id);
	}
	return game_hub_data_sources_user_user_game_installer_type_id__volatile;
}

static void
game_hub_data_sources_user_user_game_class_init (GameHubDataSourcesUserUserGameClass * klass,
                                                 gpointer klass_data)
{
#line 25 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataSourcesUserUserGame_private_offset);
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataGameClass *) klass)->update_game_info = (void (*) (GameHubDataGame*, GAsyncReadyCallback, gpointer)) game_hub_data_sources_user_user_game_real_update_game_info;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataGameClass *) klass)->update_game_info_finish = (void (*) (GameHubDataGame*, GAsyncResult*)) game_hub_data_sources_user_user_game_update_game_info_finish;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataRunnableClass *) klass)->install = (void (*) (GameHubDataRunnable*, GameHubDataRunnableInstallerInstallMode, GAsyncReadyCallback, gpointer)) game_hub_data_sources_user_user_game_real_install;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataRunnableClass *) klass)->install_finish = (void (*) (GameHubDataRunnable*, GAsyncResult*)) game_hub_data_sources_user_user_game_install_finish;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataGameClass *) klass)->uninstall = (void (*) (GameHubDataGame*, GAsyncReadyCallback, gpointer)) game_hub_data_sources_user_user_game_real_uninstall;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataGameClass *) klass)->uninstall_finish = (void (*) (GameHubDataGame*, GAsyncResult*)) game_hub_data_sources_user_user_game_uninstall_finish;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataRunnableClass *) klass)->save = (void (*) (GameHubDataRunnable*)) game_hub_data_sources_user_user_game_real_save;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataRunnableClass *) klass)->update_status = (void (*) (GameHubDataRunnable*)) game_hub_data_sources_user_user_game_real_update_status;
#line 25 "../src/data/sources/user/UserGame.vala"
	G_OBJECT_CLASS (klass)->finalize = game_hub_data_sources_user_user_game_finalize;
#line 25 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_signals[GAME_HUB_DATA_SOURCES_USER_USER_GAME_REMOVED_SIGNAL] = g_signal_new ("removed", GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2566 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_instance_init (GameHubDataSourcesUserUserGame * self,
                                                    gpointer klass)
{
#line 25 "../src/data/sources/user/UserGame.vala"
	self->priv = game_hub_data_sources_user_user_game_get_instance_private (self);
#line 27 "../src/data/sources/user/UserGame.vala"
	self->priv->is_removed = FALSE;
#line 2577 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_finalize (GObject * obj)
{
	GameHubDataSourcesUserUserGame * self;
#line 25 "../src/data/sources/user/UserGame.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, GameHubDataSourcesUserUserGame);
#line 30 "../src/data/sources/user/UserGame.vala"
	_game_hub_data_runnable_installer_unref0 (self->priv->installer);
#line 25 "../src/data/sources/user/UserGame.vala"
	G_OBJECT_CLASS (game_hub_data_sources_user_user_game_parent_class)->finalize (obj);
#line 2590 "UserGame.c"
}

static GType
game_hub_data_sources_user_user_game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataSourcesUserUserGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_sources_user_user_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataSourcesUserUserGame), 0, (GInstanceInitFunc) game_hub_data_sources_user_user_game_instance_init, NULL };
	GType game_hub_data_sources_user_user_game_type_id;
	game_hub_data_sources_user_user_game_type_id = g_type_register_static (GAME_HUB_DATA_TYPE_GAME, "GameHubDataSourcesUserUserGame", &g_define_type_info, 0);
	GameHubDataSourcesUserUserGame_private_offset = g_type_add_instance_private (game_hub_data_sources_user_user_game_type_id, sizeof (GameHubDataSourcesUserUserGamePrivate));
	return game_hub_data_sources_user_user_game_type_id;
}

GType
game_hub_data_sources_user_user_game_get_type (void)
{
	static volatile gsize game_hub_data_sources_user_user_game_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_sources_user_user_game_type_id__volatile)) {
		GType game_hub_data_sources_user_user_game_type_id;
		game_hub_data_sources_user_user_game_type_id = game_hub_data_sources_user_user_game_get_type_once ();
		g_once_init_leave (&game_hub_data_sources_user_user_game_type_id__volatile, game_hub_data_sources_user_user_game_type_id);
	}
	return game_hub_data_sources_user_user_game_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

